function addMoney() {
	if (mapElements) mapElements.addMoneyBut.texture = assets.resources['plusBut_disabled'].texture;
	
	moneyPopup = new PIXI.Container();
	moneyPopup.position.y = stageH*0.07;
	
	var bg = getAsset('popup_large', 'auto', stageH*0.84);
	moneyPopup.addChild(bg);
	moneyPopup.bg = bg;
	
	var centerX = parseInt(bg.width/2);
	
	var closeBut = getAsset('closeBut', bg.width/16);
	moneyPopup.addChild(closeBut);
	closeBut.position.x = bg.width/1.055;
	closeBut.position.y = bg.height/19;
	closeBut.interactive = closeBut.buttonMode = true;
	moneyPopup.addChild(closeBut);
	
	var label = createText(xmlValue('coinsPopupLabel'), {fontSize:25, x:centerX, y:bg.height/24, width:bg.width*0.33});
	moneyPopup.addChild(label);
	
	numlog('openPayment'+(tryToBuy || ""));
	
	closeBut.on('click', removeAddMoneyPopup).on('touchstart', removeAddMoneyPopup);
	
	
	// bottom buttons
	//var but1 = initBUT(xmlValue('earnCoinsBut'),'');
	var but3 = initBUT('     '+xmlValue('giftCardBut'),'');
	//moneyPopup.addChild(but1);
	moneyPopup.addChild(but3);
	//but1.on('click', earnCoins).on('touchstart', earnCoins);
	but3.on('click', giftCard).on('touchstart', giftCard);
	var but2;
	
	// draw rows
	var mob = false;
	var rows = new PIXI.Container();
	rows.position.x = bg.width*0.03;
	rows.position.y = bg.height*0.19;
	moneyPopup.addChild(rows);
	
	moneyPopup.showPayments = function(obj) {
		removeLoader();
		var i;
		var t3w = 0, t2w = 0;
		var prevClp;
		
		if (obj === undefined) {
			getPayments();
			if (paymentsObject !== undefined) obj = paymentsObject;
		}
		
		if (obj !== undefined) {
			for (i=0; i<obj.length; i++) {
				var ico = '';
				if (obj[i].popular==1) ico = 'mostPopular';
				else if (obj[i].best==1) ico = 'bestValue';
				var clp = makeROW(obj[i], mob, ico, i);
				clp.position.y = i*bg.height*0.124;
				rows.addChild(clp);
				prevClp = clp;
			}
		}
		
		
		var fb = getAsset('fbicon', bg.width*0.04);
		fb.anchor.y = 0.5; fb.position.y = but3.h/2; fb.position.x = fb.width*0.35;
		but3.addChild(fb);
		
		if (but2) moneyPopup.removeChild(but2);
		but2 = initBUT(xmlValue(mob ? 'webPaymentBut' : 'mobPaymentBut'),'');
		but2.on('click', mobPayment).on('touchstart', mobPayment);
		moneyPopup.addChild(but2);
		
		but2.visible = mobilePaymentsObject && obj==paymentsObject || obj==mobilePaymentsObject && paymentsObject>0 ? mobilePaymentsObject.length>0 : paymentsObject.length>0;
		// button placements
		/*but1.position.y = */but2.position.y = but3.position.y = parseInt(bg.height * 0.94);
		var vahe = but2.visible ? bg.width*0.03 : bg.width*0.1;
		//but1.scale.set(0.93);
		but2.scale.set(0.93);
		but3.scale.set(0.93);
		var bw = /*but1.w*0.93 + vahe + */but3.w*0.93 + (but2.visible ? but2.w*0.93 + vahe : 0);
		centerBut(but2, centerX);
		but2.position.x -= bw/2 - but2.w*0.93/2;
		//but2.position.x = but1.position.x + but1.w*0.93 + vahe;
		but3.position.x = but2.visible ? but2.position.x + but2.w*0.93 + vahe : but2.position.x;
		but3.visible = false;
		
		
		// offer icons
		if (bg.width>stageW*0.6) {
			var offersXX = parseInt(bg.width*0.03), timerT=0, offerBadgeText, turnaOfferBadgeText, offerICO, offerBadge, turnaOfferICO, turnaOfferBadge, turnaOfferLabel;
			if (offerData && offerLeft>0) {
				offerICO = new PIXI.Sprite.fromImage(offerData.icon);
				if (offerICO.texture.baseTexture.hasLoaded==true) showOfferIcon();
				else offerICO.texture.baseTexture.on('loaded', showOfferIcon);
				function showOfferIcon() {
					offerICO.width = bg.width*0.16;
					offerICO.scale.y = offerICO.scale.x;
					offerICO.anchor.x = offerICO.anchor.y = 0.5;
					offerICO.position = {x:offersXX, y:parseInt(bg.height*0.04)};
					offerBadge = getAsset('timer_bg', offerICO.width*0.85);
					offerBadge.anchor.x = offerBadge.anchor.y = 0.5;
					offerBadge.position = {x:offersXX, y:offerICO.position.y + offerICO.height*0.45};
					moneyPopup.addChild(offerICO);
					moneyPopup.addChild(offerBadge);
					offerBadgeText = createText(convertToTime(offerLeft, true), {fontSize:16, x:offersXX, y:offerBadge.position.y - offerBadge.height*0.05, width:offerBadge.width*0.8, autoResize:true});
					moneyPopup.addChild(offerBadgeText);
					offerICO.interactive = offerICO.buttonMode = true;
					offerICO.on('click', clickOfferIcon).on('touchstart', clickOfferIcon);
					function clickOfferIcon() {
						if (!offerPopup) {
							var tmp = tryToBuy;
							removeAddMoneyPopup();
							tryToBuy = tmp;
							setTimeout(openOffer, 350);
							offerICO.interactive = false; setTimeout(function() {if (offerICO) offerICO.interactive = true;}, 400);
						}
					}
				}
				offersXX += parseInt(offerICO.width);
				rows.position.y = bg.height*0.23;
			}
			if (tournamentData && tournamentData.offer && tournamentData.offer.timeLeft>0) {
				turnaOfferICO = getAsset("TournamentOfferClicker", bg.width*0.16);
				turnaOfferICO.anchor.set(0.5);
				turnaOfferICO.position = {x:offersXX+3, y:parseInt(bg.height*0.044)};
				turnaOfferICO.interactive = turnaOfferICO.buttonMode = true;
				turnaOfferICO.on('click', openTOffer).on('touchstart', openTOffer);
				//turnaOfferBadge = getAsset('timer_bg', turnaOfferICO.width*0.85);
				//turnaOfferBadge.anchor.x = turnaOfferBadge.anchor.y = 0.5;
				//turnaOfferBadge.position = {x:offersXX, y:turnaOfferICO.position.y + turnaOfferICO.height*0.45};
				moneyPopup.addChild(turnaOfferICO);
				//turnaOfferLabel = createText('Tournament<br>offer', {fontSize:12.5, x:parseInt(offersXX + turnaOfferICO.width*0.035), y:parseInt(bg.height*0.03), width:turnaOfferICO.width*0.78, multiline:true});
				//moneyPopup.addChild(turnaOfferLabel);
				//moneyPopup.addChild(turnaOfferBadge);
				timerT = tournamentData.offer.timeLeft;
				turnaOfferBadgeText = createText(convertToTime(timerT, true), {fontSize:16, x:turnaOfferICO.position.x, y:turnaOfferICO.position.y + (turnaOfferICO.height/2)*0.7, width:turnaOfferICO.width*0.8, autoResize:true});
				moneyPopup.addChild(turnaOfferBadgeText);
				function openTOffer() {
					if (!offerPopup) {
						var tmp = tryToBuy;
						removeAddMoneyPopup();
						tryToBuy = tmp;
						offerData = tournamentData.offer;
						setTimeout(openOffer, 350);
						turnaOfferICO.interactive = false; setTimeout(function() {if (turnaOfferICO) turnaOfferICO.interactive = true;}, 400);
					}
				}
				rows.position.y = bg.height*0.23;
			}
			if (offerBadgeText || turnaOfferBadgeText) {
				var ss = setInterval(function() {
					if (turnaOfferBadgeText) {
						timerT--;
						if (timerT>0) updateTxt(turnaOfferBadgeText, convertToTime(timerT, true));
						else {
							if (turnaOfferICO) turnaOfferICO.destroy(); turnaOfferICO = null;
							//if (turnaOfferBadge) turnaOfferBadge.destroy(); turnaOfferBadge = null;
							//if (turnaOfferLabel) turnaOfferLabel.destroy(); turnaOfferLabel = null;
							if (turnaOfferBadgeText) turnaOfferBadgeText.destroy(); turnaOfferBadgeText = null;
						}
					}
					if (offerBadgeText) {
						if (offerLeft>0) updateTxt(offerBadgeText, convertToTime(offerLeft, true));
						else {
							if (offerBadgeText) offerBadgeText.destroy(); offerBadgeText = null;
							if (offerBadge) offerBadge.destroy(); offerBadge = null;
							if (offerICO) offerICO.destroy(); offerICO = null;
						}
					}
				}, 1000); 
			}
		}
	};
	moneyPopup.showPayments(paymentsObject);
	
	// refresh on open!
	getPayments('buy_popup_web','noloader');
	
	if (autoplaying) setTimeout(function() {
		drawProcessingClip();
		setTimeout(giveMeMoney, 2000);
	}, 2000);
	function makeROW(obj, mob, asst, nr) {
			var row = new PIXI.Container();
		
			var bg = getAsset('buycoins_row'+(asst!='' ? '_green' : ''), moneyPopup.bg.width*0.89);
			bg.height = moneyPopup.bg.height*0.12;
			bg.anchor.y = 0.5;
			bg.position.x = moneyPopup.bg.width*0.03;
			row.addChild(bg);
			
			var txt2 = obj.free>0 ? xmlValue('freeCoinsPurchase').replace('[coins]', '+'+obj.free) : '';
			var txt3 = coinFormat(obj.price)+(obj.currency==null ? '' : ' '+obj.currency);
			
			if (obj.free==undefined) obj.free=0;
			var t1 = createText((obj.amount - obj.free), {fontSize:26, color:'yellow', align:'left', x:bg.width*0.14, y:bg.height*0.038, width:bg.width*0.25});
			t1.anchor.x = 0;
			row.addChild(t1);
			var t2 = createText(txt2, {fontSize:20, align:'left', x:bg.width*0.262, y:bg.height*0.05, width:bg.width*0.2, autoResize:true});
			row.addChild(t2);
			t2.anchor.x = 0;
			row.t2 = t2;
			
			// coin
			var ico_type = 'coin';
			var ico_size = bg.width*0.07;
			if (nr==1) {ico_type='sales50'; ico_size=bg.width*0.1;}
			else if (nr==2) {ico_type='sales100'; ico_size=bg.width*0.1;}
			else if (nr==3) {ico_type='sales250'; ico_size=bg.width*0.1;}
			else if (nr==4) {ico_type='sales500a'; ico_size=bg.width*0.1;}
			else if (nr==5) {ico_type='sales500'; ico_size=bg.width*0.1;}
			var ico = getAsset(ico_type, ico_size);
			ico.anchor.x = ico.anchor.y = 0.5;
			ico.position.x = bg.width * 0.09;
			row.addChild(ico);
			
			// best offer badgets
			if (asst!='') {
				var ico2 = getAsset(asst, bg.width*0.17);
				ico2.anchor.x = ico2.anchor.y = 0.5;
				ico2.position.x = bg.width*0.546;
				row.addChild(ico2);
			}
			
			var but = initBUT(xmlValue('buy'),'green');
			but.scale.set(0.82);
			but.position.x = bg.width - but.w*but.scale.x + 5;
			but.position.y = -but.h*but.scale.y/2;
			but.on('click', buyCoins).on('touchend', buyCoins);
			var pm = obj.url;
			row.addChild(but);
			
			var t3 = createText(txt3, {fontSize:20, align:'right', x:but.position.x - bg.width*0.02, y:bg.height*0.05, width:bg.width*0.25});
			t3.anchor.x = 1;
			row.addChild(t3);
			
			return row;

			function buyCoins() {
				var pop = stopClip && stopClip.action ? 'popup_' : '';
				ads(pm.replace("[reason]", pop + tryToBuy));
				but.disable();
				drawProcessingClip();
			}

			function coinFormat(n) {
				n = Math.round(n*100)/100;
				var s = String(n);
				var tmp = s.split('.');
				if (tmp.length==1) return s+'.00';
				if (tmp[1].length==1) return s+'0';
				return s;
			}
	}
	
	/*function earnCoins() {
		if (but1.mode!='disabled') {
			earnCoins(); // Jarko JS
			but1.disable();
		}
	}*/
	function mobPayment() {
		if (but2.mode!='disabled') {
			mob = !mob;
			but2.disable();
			removeAllChilds(rows);
			getPayments(mob ? 'buy_popup_mob' : 'buy_popup_web');
			
		}
	}
	function giftCard() {
		if (but3.mode!='disabled') {
			fbGiftCard(); //Jarko JS
			but3.disable();
			// fb icon replace
		}
	}
	
	animatePopup(moneyPopup);
}
function removeAddMoneyPopup(processing) {
	// this removes processing clip also.
	if (stopClip.black2) {
		stopClip.removeChild(stopClip.black2); stopClip.black2=null; 
		stopClip.enableButtons();
	}
	// others..........
	// ................
	if (elements) elements.removeNotouch();
	if (mapElements) mapElements.addMoneyBut.texture = assets.resources['plusBut'].texture;
	if (processing!=false) numlog('closePayment');
	if (tournamentPopup && tournamentPopup.tokenPopup && tournamentPopup.tokenPopup.enableButs) tournamentPopup.tokenPopup.enableButs();
	if (tournamentPopup && tournamentPopup.enableTokenButs) tournamentPopup.enableTokenButs();
	if (doubleDragonsPopup) {
		doubleDragonsPopup.closeBut.interactive = doubleDragonsPopup.closeBut.buttonMode = true;
		doubleDragonsPopup.but.enable();
		if (autoplaying) setTimeout(doubleDragonsPopup.butAction, 500);
	}
	if (popupLives) popupLives.enableButtons();
	
	repeatGameAferMoneyclip();
	quitPopup(moneyPopup);
}


// processing clip ----------------------------------------------------------------------------------------------------------------
function drawProcessingClip() {
	removeAllChilds(moneyPopup);
	if (stopClip && stopClip.action && tryToBuy!='timesupOffer') hideCloseClip();
	
	// draw processing clip
	if (!moneyPopup) {
		moneyPopup = new PIXI.Container();
		moneyPopup.position.y = stageH*0.07;
		
		moneyPopup.emptyBlk2 = wholeBox(0x000000, 0.2);
		moneyPopup.emptyBlk2.interactive = true;
		stage.addChild(moneyPopup.emptyBlk2);
		stage.addChild(moneyPopup);
	}
	
	moneyPopup.position.x = 0;
	var bg = getAsset('popup_small', 'auto', stageH*0.84);
	bg.position.x = stageW/2;
	bg.anchor.x = 0.5;
	moneyPopup.addChild(bg);
	moneyPopup.bg = bg;
	var centerX = stageW/2;
	
	// processing draw...
	cancelBut = getAsset('closeBut', bg.width/12);
	cancelBut.interactive = cancelBut.buttonMode = true;
	cancelBut.position.x = centerX + bg.width*0.34;
	cancelBut.position.y = bg.height/11;
	cancelBut.on('click', cancelPaymentElementsRestore).on('touchend', cancelPaymentElementsRestore);
	moneyPopup.addChild(cancelBut);

	var label = createText(xmlValue('paymentProcessing_label'), {fontSize:26, x:centerX*1.02, y:bg.height/12, width:bg.width/1.7});
	moneyPopup.addChild(label);
	var t1 = createText(xmlValue('paymentProcessing_description'), {fontSize:21, color:'yellow', x:centerX, y:bg.height*0.78, multiline:true, width:bg.width*0.7});
	moneyPopup.addChild(t1);
	
	// add dragon sheet
	var dragon = getSheet('dragon');
	makeSheet(dragon, bg.width*0.48, false, 0.5, centerX*1.03, bg.height*0.38);
	moneyPopup.addChild(dragon);
	
	// add loader sheet
	var loadMC = getSheet('loader');
	makeSheet(loadMC, bg.width*0.45, true, 0.5, centerX, bg.height*0.66);
	loadMC.height = loadMC.width/6;
	moneyPopup.addChild(loadMC);

	startPingBought(); // !!! need or not.

}
function startPingBought() {
	// PING*******************************************************************************************
	if (moneyPopup) {if (moneyPopup.tmh) clearInterval(moneyPopup.tmh); moneyPopup.tmh = setInterval(ping, 2500);}
	else if (offerPopup) {if (offerPopup.tmh) clearInterval(offerPopup.tmh); offerPopup.tmh = setInterval(ping, 2500);}
	function ping() {
		getJsonPrices(false, 'boughtCoins');
	}
}



function buy(action, todo) {
	if (sandBoxId>0) {
		repeatClock();
	} else {
		
		var query = action=='20sekBonus' || action=='highlight' ? 'usebooster' : 'setmoney';
		// booster percent
		var boosterPercent = '';
		if (kivid && (action=='20sekBonus' || action=='highlight' || action=='externalTime' || action=='externalTimeDiscount' || action=='externalTimeT' || action=='externalTimeDiscountT')) {
			boosterPercent = '&completePercent='+(turns3*200/totalTiles3).toString();
		}
		if (query != 'usebooster' && !fromCoins || action.indexOf('Pack')>0) addLoader();
		
		serverSend('/api/'+query+'&action='+action+boosterPercent+'&playlog_id='+playLog, function(jsonLoaderMoney) {
			
			money = jsonLoaderMoney.money; // buying take money down.
			
			tryToBuy = action+','+todo;
			jsonObject = jsonLoaderMoney;
			removeLoader(true);
			refreshTopData();

			// enough money (server control)
			if (jsonObject.error) {
				addMoney();
			} else {
				
				tryToBuy = '';
				
				if (action=='highlight' && elements) elements.makeHighlight();
				else if (action=='externalTime' || action=='externalTimeDiscount' || action=='externalTimeT' || action=='externalTimeDiscountT') {
					addVremja(60);
					if (autoplaying) setTimeout(function() {autoCollect=true; nextAutoCollect();}, 500);
				}
				else if (action=='doubleDragons') {
					if (doubleDragonsPopup) {
						doubleDragons = true;
						doubleCounter++;
						dragonCount = dragonCount*2;
						if (elements) updateTxt(elements.t_dr, '0 / '+dragonCount);
						doubleDragonsPopup.removeDD();
					}
				}
				else if (action=='tokenPack1' || action=='tokenPack2' || action=='tokenPack3') {
					if (moneyPopup) quitPopup(moneyPopup);
					if (tournamentPopup) {
						if (tournamentPopup.tokenPopup) quitPopup(tournamentPopup.tokenPopup);
						tournamentPopup.drawPLAY();
					}
				}
				else if (action=='gemPack1' || action=='gemPack2' || action=='gemPack3') {
					if (moneyPopup) quitPopup(moneyPopup);
					if (challengePopup) challengePopup.drawPLAY();
				}
				else if (action=='nextStar') {
					// repeat imideately
					addVremja(60);
					if (!musicOff) playMusic(2);
					if (elements && tutorialStep==0 && haveBoosters()) {
						TweenLite.to(elements.boosters, 0.5, {y:stageH*0.055});
						elements.boosters.visible = true;
					}
					quitPopup(completePopup);
				}
				else if (action=='20sekBonus' && elements) elements.makeTimeBooster();
				else if (todo=='cameFromLost') {reloadLevel();}
				else if (action=='fillLives') {
					// remove popups inside startPlay.
					nextLiveTime = 0;
					if (popupLives) quitPopup(popupLives);
					if (goalClip) startPlay();
				}
				
				
				if (fromCoins) removeAddMoneyPopup();
			}
			fromCoins = false;
			
			

			
		}, function(error) {
			disconnect('Can\'t buy '+action, true);
		});

	}
}
function removePayment() {
	// cancel payment
	log('cancel payment - remove buy/offer popups');
	removeLoader(true);
	cancelPaymentElementsRestore();
}
function cancelPaymentElementsRestore() {
	log('restore while cancel payment');
	if (moneyPopup) {clearInterval(moneyPopup.tmh); moneyPopup.tmh = null; quitPopup(moneyPopup);}
	if (offerPopup) {clearInterval(offerPopup.tmh); offerPopup.tmh = null; quitPopup(offerPopup);}
	if (firsttimeOfferPopup) {quitPopup(firsttimeOfferPopup);}
	if (mapElements && mapElements.addMoneyBut) mapElements.addMoneyBut.texture = assets.resources['plusBut'].texture;
	if (elements) elements.removeNotouch();
	if (tournamentPopup && tournamentPopup.tokenPopup && tournamentPopup.tokenPopup.enableButs) tournamentPopup.tokenPopup.enableButs();
	if (doubleDragonsPopup) {
		doubleDragonsPopup.closeBut.interactive = doubleDragonsPopup.closeBut.buttonMode = true;
		doubleDragonsPopup.but.enable();
	}
	if (popupLives && popupLives.quitting!=true) popupLives.enableButtons();
	if (stopClip.black) stopClip.enableButtons();
	repeatGameAferMoneyclip();
}
function repeatGameAferMoneyclip() {
	if (GAME && kivid) {
		if (levelTime<=0) finishLevel(true); else {
		
			if (tryToBuy!='') {
				if (tryToBuy.slice(0,9)=='highlight' && !highLightMode && elements && elements.boosters && elements.boosters.highlightBut) elements.boosters.highlightBut.enable();
				else if (tryToBuy.slice(0,10)=='20sekBonus' && elements && elements.boosters && elements.boosters.timeBooster && elements.boosters.timeBooster.max_used_times>0) {repeatClock(); elements.boosters.timeBooster.enable();}
			}	
			repeatClock();
			if (autoplaying && total>0 && autoCollect && !tournamentPopup) {autoCollectTimeout = null; setTimeout(nextAutoCollect,700);}
		}
	}
	tryToBuy = '';
}