function addStopClip(action) {
	if (stopClip.black) return;
	stopClip.action = action;
	clockStop();
	if (hinta) hideHint();
	
	var blurFilter = new PIXI.filters.BlurFilter();
	blurFilter.blur = 5;
	if (kivid) kivid.filters = [blurFilter];
	
	var black = wholeBox(0x000000, 0.66);
	stopClip.black = black;
	black.alpha = 0;
	black.interactive = true;
	gameContainer.addChild(black);
	TweenLite.to(black, 0.5, {alpha:1});
	
	var bg = getAsset(isTournament && !tournament_type ? 'popup_blue_small' : 'popup_pink_small', 'auto', stageH*0.8);
	//bg.height = bg.width*1.1;
	bg.position.x = stageW/2 - bg.width/2; bg.position.y = stageH/2 - bg.height/2;
	stopClip.addChild(bg);
	centerX = stageW/2;
	stopClip.addChild(bg);
	stopClip.bg = bg;
	

	
	var t1,t2,t3, ico, but1, but2, but3, close1, close2, close3, ico1, ico2, ico3, ico1a, ico2a, ico3a, pack, dragon, icoSize, ico_heart;
	
	pauseDisable();
	
	function disableButtons() {
		if (close1) close1.interactive = close1.buttonMode = false;
		if (close2) close2.interactive = close2.buttonMode = false;
		if (close3) close3.disable();
		if (but1) but1.disable();
		if (but2) but2.disable();
		if (but3) but3.disable();
		disable(ico1);
		disable(ico2);
		disable(ico3);
		disable(ico1a);
		disable(ico2a);
		disable(ico3a);
		function disable(clp) {
			if (clp && assets.resources[clp.type+clp.value+'_disabled']) {
				clp.texture = assets.resources[clp.type+clp.value+'_disabled'].texture;
				clp.width = icoSize; clp.scale.y = clp.scale.x;
			}
			if (clp && clp.t) clp.t.visible = false;
		}
	}
	stopClip.enableButtons = function() {
		if (close1) close1.interactive = close1.buttonMode = true;
		if (close2) close2.interactive = close2.buttonMode = true;
		if (close3) close3.enable();
		if (but1) but1.enable();
		if (but2) but2.enable();
		if (but3) but3.enable();
		enable(ico1);
		enable(ico2);
		enable(ico3);
		enable(ico1a);
		enable(ico2a);
		enable(ico3a);
		function enable(clp) {
			if (clp && assets.resources[clp.type+clp.value]) {
				clp.texture = assets.resources[clp.type+clp.value].texture;
				clp.width = icoSize; clp.scale.y = clp.scale.x;
			}
			if (clp && clp.t) clp.t.visible = true;
		}
	};
	
	
	
		
	if (action == 'TIME UP') {
		
		if (mapDATA && mapDATA[1].stars==0) analytics('/api/analytics?code=tutorialStep_10.1');
		
		label = createText(xmlValue('timeUp'), {fontSize:26, x:centerX, y:bg.height/4.8, width:bg.width*0.74, autoResize:true});
		stopClip.addChild(label);
		
		//t1 = createText(xmlValue('timeUp'), {fontSize:35, x:centerX, y:bg.position.y + bg.height*0.15, width:bg.width*0.85, autoResize:true});
		//stopClip.addChild(t1);

		var descr;
		stopClip.quitting = false;

		if (isTournament) {
			var dragonsLeft = dragonCount - friendTilePairsCollected*2;
			analytics('/api/analytics?code=timeUpTournament&dragonsLeft='+dragonsLeft);
			numlog('timesUpTournament'); // Jarko JS
			if (tournament_try100percent) {
				
				descr = xmlValue('timesupDescriptionTournament');
				var tok = getAsset('tokenBroken', bg.width*0.42);
				tok.position.x = centerX;
				tok.position.y = bg.position.y + bg.height*0.38;
				tok.anchor.x = tok.anchor.y = 0.5;
				stopClip.addChild(tok);
			} else {
				descr = xmlValue('timesupDescriptionTournament_notoken');
			}
		} else {
			analytics('/api/analytics?code=timeUp&stars='+starsCollected());
			numlog('timesUp'); // Jarko JS
			
			var turnsLeft = totalTiles3 * star_percent[0]/200 - turns3;
			if (turnsLeft > parseInt(turnsLeft)) turnsLeft = parseInt(turnsLeft)+1;
			//descr = turnsLeft>20 ? xmlValue('timesupDescription2') : xmlValue('timesupDescription');
			//descr = descr.replace('[turns]', turnsLeft);
			descr = 'Get 60 seconds more time and get at least one star to complete the level';
			
			var dragon = getSheet('dragonSad256');
			animeSpeed = 0.4;
			makeSheet(dragon, stageW*0.28, true, 0.5, stageW*0.417, stageH*0.4);
			animeSpeed = 0.44;
			dragon.position.x = centerX;
			dragon.position.y = bg.position.y + bg.height*0.38;
			stopClip.addChild(dragon);
		}
		
		t1 = createText(isTournament ? 'Almost made it!' : 'Almost there!', {fontSize:24, color:"yellow", bold:false, stroke:4, x:centerX, y:bg.height*0.76, width:bg.width*0.7, multiline:false});
		stopClip.addChild(t1);
		
		t2 = createText(descr, {color:'white', stroke:4, fontSize:18, bold:false, x:centerX, y:bg.height*0.88, width:bg.width*0.54, multiline:true});
		stopClip.addChild(t2);
		
		//!!!spritesheet   if (isTournament) dragon spritesheet draw		
		
		if (money<3) {
			but3 = initBUT(' '+xmlValue('playon')+' for '+(isTournament ? prices.externalTimeDiscountT : prices.externalTimeDiscount) + '  [coin]','green');
		} else {
			but3 = initBUT(' '+xmlValue('playon')+' for '+(isTournament ? prices.externalTimeT : prices.externalTime) + '  [coin]','green');
		}
		but3.scale.set(1.2);
		but3.disable();
		//maxButWidth(but3, bg.width*0.9);
		centerBut(but3, centerX+bg.width*0.03);
		but3.position.y = bg.height;
		stopClip.addChild(but3);
		
		if (isTournament && dragonCnt==thisLevDragons*2 && fields.length>0) {
			close3 = initBUT(xmlValue('skipLevel'), '');
		} else {
			close3 = initBUT((isTournament ? '  [tokenBroken] ' : '  [heartBroken] ') + xmlValue('giveUp'), 'blue');
		}
		close3.position.y = but3.position.y + but3.h*1.5;
		close3.scale.set(0.75);
		centerBut(close3, centerX);
		close3.on('click', closeButPress3).on('touchend', closeButPress3);
		stopClip.addChild(close3);
		stopClip.close3 = close3;
		close3.disable();
		
		//icon
		icoSize = bg.width*0.15;
		ico1 = getAsset('time60_disabled', icoSize);
		ico1.type = 'time';
		ico1.value = 60;
		ico1.anchor.x = ico1.anchor.y = 0.5;
		ico1.position.x = centerX - but3.w*0.45*but3.scale.x;
		ico1.position.y = but3.position.y + but3.h/2*but3.scale.y;
		stopClip.addChild(ico1);
		
		
		but3.on('click', butF3).on('touchend', butF3);
		
		/*setTimeout(function () {
			if (stopClip && close3 && but3 && stopClip.black) {
				close3.enable();
				but3.enable();
				ico1.texture = assets.resources['time60'].texture;
				ico1.width = bg.width*0.22; ico1.scale.y = ico1.scale.x;
			}
		}, doubleDragonsPopup ? 300 : 2000);
		//hints.visible = false;*/
		
		
		
		// new: setlevel paring
		if (money < prices.externalTime) {// || true
			addLoader();
			var timeLev = threeInOneLevel ? completedTimes.join(",") : levelTimeStart - timeBonus/10;
			serverSend('/api/'+(sandBoxId>0 ? 'testresult' : 'setlevel')+'&id='+selectedLevel+'&playlog_id='+playLog+'&friendTileUsed='+(haveFrinedBoost<0 ? 1 : 0)+'&points='+levelScore+'&timeScore='+timeScore+'&timeBonus='+timeBonus+'&reason='+setLevelReason+'&time='+timeLev+'&firstStarTime='+firstStarTime+'&randomizer='+Math.random(), 
				function(jo) {
					removeLoader();
					setTimeout(stopClip.enableButtons, 1200);
					
					//jo.specialOffer = [{amount:40, price:1.99, currency:'EUR', free:20, url:"startPayment(40, 1.99, '[reason]', 1, 'soffer', 0);",piggybank:2}];
					
					if (jo.specialOffer && jo.specialOffer[0]) {
						// add special offer
						offerBox = new PIXI.Container();
						offerBox.position = {x:stageW*0.84, y:stageH*0.164};
						
						var bg = getAsset('popup_blue_small', 'auto', stageH*0.69);
						bg.anchor.x = 0.5;
						offerBox.addChild(bg);
						var w = stageW*0.37;
						bg.width = 1;
						stopClip.addChild(offerBox);
						
						TweenLite.to(bg, 0.5, {width:w, onComplete:function() {
							var t1 = createText(xmlValue('flashOffer'), {fontSize:23, x:0, y:bg.height*0.08});
							offerBox.addChild(t1);
							var ico = getAsset('sales100', w*0.36);
							ico.anchor.set(0.5);
							ico.position = {x:-w*0.16, y:bg.height*0.29};
							offerBox.addChild(ico);
							var ico2 = getAsset('time60', w*0.36);
							ico2.anchor.set(0.5);
							ico2.position = {x:w*0.16, y:ico.position.y};
							offerBox.addChild(ico2);
							
							var percent = parseInt(jo.specialOffer[0].free/jo.specialOffer[0].amount*100);
							var box = getAsset('loading3', w*0.57);
							box.anchor.set(0.5);
							box.position = {x:0, y:bg.height*0.49};
							var red = new PIXI.Graphics();
							red.beginFill(0xe02f2f, 1);
							red.drawRoundedRect(-box.width*0.47,-box.height*0.4, box.width*0.94, box.height*0.8, box.height*0.2);
							red.endFill();
							var t0 = createText(-percent+'%', {fontSize:21, stroke:0});
							t0.position = red.position = box.position;
							offerBox.addChild(red);
							offerBox.addChild(box);
							offerBox.addChild(t0);
							var t = createText(jo.specialOffer[0].amount, {fontSize:28});
							t.position = ico.position;
							offerBox.addChild(t);
							var t2 = createText(xmlValue('forTxt')+'  '+(parseInt(jo.specialOffer[0].price*10000/percent)/100)+' '+jo.specialOffer[0].currency, {fontSize:18, x:0, y:bg.height*0.59});
							offerBox.addChild(t2);
							var lin = new PIXI.Graphics();
							lin.lineStyle(4, 0xcc0000, 1);
							lin.moveTo(t2.position.x - t2.width*0.6, t2.position.y + t2.height/2.5);
							lin.lineTo(t2.position.x + t2.width*0.6, t2.position.y - t2.height/2.5);
							offerBox.addChild(lin);
							var t3 = createText(xmlValue('forTxt')+'  '+jo.specialOffer[0].price+' '+jo.specialOffer[0].currency, {fontSize:22, color:'#9af824', strokeColor:'#2a5508', x:0, y:bg.height*0.655});
							offerBox.addChild(t3);
							var but = initBUT(xmlValue('buyNow'), 'green');
							centerBut(but, 0);
							but.position.y = bg.height*0.7;
							but.on('click', prs).on('touchend',prs);
							function prs() {
								ads(jo.specialOffer[0].url.replace('[reason]', 'timeUp'));
								if (offerBox) offerBox.destroy();
								offerBox = null;
								disableButtons();
								tryToBuy = 'timesupOffer';
								drawProcessingClip();
							}
							offerBox.addChild(but);
							var td = createText(xmlValue('timeupOfferDisclaimer'), {fontSize:12, color:'brown', width:w*0.7, multiline:true, stroke:0, x:0, y:bg.height*0.86});
							offerBox.addChild(td);
							var badgeGreen = getAsset('blue_badge1', w*0.47);
							badgeGreen.anchor.set(0.5);
							badgeGreen.position = {x:-w*0.36, y:bg.height*0.17};
							offerBox.addChild(badgeGreen);
							var tb = createText(xmlValue('timeupOfferValid'), {fontSize:16, color:'brown', width:badgeGreen.width*0.5, multiline:true, x:badgeGreen.position.x, y:badgeGreen.position.y});
							tb.rotation = -0.3;
							offerBox.addChild(tb);
						}});
					}
					
				},
				function() {
					removeLoader();
					stopClip.enableButtons();
				});
		} else setTimeout(stopClip.enableButtons, 1500);
		
		
		
		function closeButPress3() {
			if (close3.mode!='disabled') {
				noTouch();
				if (mapDATA && mapDATA[1].stars==0) analytics('/api/analytics?code=tutorialStep_10.3');
				closeF3();
			}
		}
		function closeF3() {
			hideCloseClip();
			setTimeout(function() {
				if (isTournament && dragonCnt==thisLevDragons*2 && fields.length>0) {
					proceedTournament();
				} else {
					setLevelReason = 'timesUp';
					endLevel('lose');
				}
			}, 300);
		}
		function butF3() {
			if (but3.mode!='disabled') {
				noTouch();
				
				if (mapDATA && mapDATA[1].stars==0) analytics('/api/analytics?code=tutorialStep_10.2');
				
				if (isTournament) {
					if (money<3) checkMoney(prices.externalTimeDiscountT, 'externalTimeDiscountT');
					else checkMoney(prices.externalTimeT, 'externalTimeT');
				} else {
					if (sandBoxId>0) addVremja(60);
					else if (money<3) checkMoney(prices.externalTimeDiscount, 'externalTimeDiscount');
					else checkMoney(prices.externalTime, 'externalTime');
				}
			}
		}
		if (autoplaying) setTimeout(butF3, 2200);
	}
	else if (action=='FREE RESHUFFLE') {
		
		
		
		
		
		ico = getAsset('shuffle', bg.width*0.4);
		ico.position.x = centerX;
		ico.position.y = bg.position.y + bg.height*0.53;
		glow1 = getAsset('glow', bg.width);
		glow1.anchor.x = glow1.anchor.y = ico.anchor.x = ico.anchor.y = 0.5;
		glow1.position.x = ico.position.x; glow1.position.y = ico.position.y;
		stopClip.glowRotate = setInterval(function() {
			glow1.rotation += 0.05;
		}, 30);
		stopClip.addChild(glow1);
		stopClip.addChild(ico);
		
		t2 = createText(xmlValue('freeReshuffles').replace('[number]', haveReshuffles), {color:"yellow", fontSize:23, x:centerX, y:bg.position.y + bg.height*0.13, width:bg.width*0.8, multiline:true, height:bg.height*0.09});
		stopClip.addChild(t2);
		
		t1 = createText(xmlValue('freeReshuffle'), {fontSize:30, autoResize:true, x:centerX, y:bg.position.y + bg.height*0.27, width:bg.width*0.8});
		if (t1.position.y-t1.height/2+10 < t2.position.y + t2.height/2) t1.position.y = t2.position.y + t2.height/2 + 10 + t1.height/2;
		stopClip.addChild(t1);
		
		but1 = initBUT(xmlValue('reshuffleButton'),'green');
		centerBut(but1, centerX);
		but1.position.y = bg.position.y + bg.height*0.8;
		but1.on('click', butF1).on('touchend', butF1);
		stopClip.addChild(but1);
		
		close1 = getAsset('closeBut', bg.width/9);
		close1.position.x = bg.position.x + bg.width*0.9;
		close1.position.y = bg.position.y - bg.height*0.004;
		close1.interactive = close1.buttonMode = true;
		close1.on('click', cloze1Prs).on('touchend', cloze1Prs);
		stopClip.addChild(close1);
		
		if (haveReshuffles>1) analytics('/api/analytics?code=showWheelReshuffle&stars='+starsCollected());
		else analytics('/api/analytics?code=showFreeReshuffle&stars='+starsCollected());


		function butF1() {
			playSound('popup_kaob');
			
			if (haveReshuffles>1) analytics('/api/analytics?code=useWheelReshuffle&stars='+starsCollected());
			else analytics('/api/analytics?code=reshuffleOffer&stars='+starsCollected());
			
			buyReshuffle('free', 'popup');
			makeShuffleUntilCan();
			hideCloseClip();
		}
		function cloze1Prs() {
			noTouch();
			hideCloseClip();
			setTimeout(function() {
				setLevelReason = '';
				endLevel('lose');
			}, 300); 	
		}
		if (autoplaying) setTimeout(butF1, 1600);
	
	
	
	
		
	}
	else if (action=='RESHUFFLE') {
		
		
		analytics('/api/analytics?code=showReshuffle30&stars='+starsCollected());
		
		centerX = bg.position.x + bg.width*0.5;
		but2 = initBUT(xmlValue('reshuffleButton')+' '+3+'[coin]', 'green');
		centerBut(but2, centerX);
		but2.position.y = bg.position.y + bg.height*0.78;
		but2.on('click', butF2).on('touchend', butF2);
		stopClip.addChild(but2);
		
		t2 = createText(xmlValue('reshuffleButton'), {color:"yellow", fontSize:28, x:centerX, y:bg.position.y + bg.height*0.13, width:bg.width*0.8});
		stopClip.addChild(t2);
		
		t1 = createText(xmlValue('reshuffleDescription'), {fontSize:21, autoResize:true, x:centerX, y:bg.position.y + bg.height*0.27, width:bg.width*0.8});
		if (t1.position.y-t1.height/2+10 < t2.position.y + t2.height/2) t1.position.y = t2.position.y + t2.height/2 + 10 + t1.height/2;
		stopClip.addChild(t1);
		
		ico = getAsset('shuffle', bg.width*0.29);
		ico2 = getAsset('time30', bg.width*0.29);
		ico.position.x = bg.position.x + bg.width*0.25;
		ico2.position.x = bg.position.x + bg.width*0.75;
		ico.position.y = ico2.position.y = bg.position.y + bg.height*0.53;
		glow1 = getAsset('glow', bg.width*0.6);
		var glow2 = getAsset('glow', bg.width*0.6);
		glow1.anchor.x = glow1.anchor.y = glow2.anchor.x = glow2.anchor.y = ico.anchor.x = ico.anchor.y =ico2.anchor.x = ico2.anchor.y = 0.5;
		glow1.position.x = ico.position.x; glow1.position.y = ico.position.y;
		glow2.position.x = ico2.position.x; glow2.position.y = ico2.position.y;
		stopClip.glowRotate = setInterval(function() {
			glow1.rotation += 0.05;
			glow2.rotation += 0.05;
		}, 30);
		stopClip.addChild(glow1);
		stopClip.addChild(glow2);
		stopClip.addChild(ico);
		stopClip.addChild(ico2);
		t3 = createText('+', {color:"#4E3000", fontSize:70, x:centerX, y:ico.position.y*1.03, width:bg.width*0.8, shadow:false, stroke:0});
		stopClip.addChild(t3);
		
		
		close2 = getAsset('closeBut', bg.width/9);
		close2.position.x = bg.position.x + bg.width*0.9;
		close2.position.y = bg.position.y - bg.height*0.004;
		close2.interactive = close2.buttonMode = true;
		close2.on('click', cloze2Prs).on('touchend', cloze2Prs);
		stopClip.addChild(close2);
		
		function butF2() {
			noTouch();
			buyReshuffle('', 'popup');
			but2.disable();
		}
		function cloze2Prs() {
			but2.disable();
			noTouch();
			// mbrix.
			/*if (jsonObject && jsonObject.ads && jsonObject.ads.reshuffle) {
				//!!!checkMbrixReshuffle();
				ads(jsonObject.ads.reshuffle);
			} else {*/
				hideCloseClip();
				setTimeout(function() {
					setLevelReason = 'noReshuffle';
					endLevel('lose');
				}, 300);
			//}
		}
		if (autoplaying) setTimeout(butF2, 1600);
		
		
		
	}
	function noTouch() {
		if (action=='TIME UP') close3.disable();
		stopClip.black2 = wholeBox(0xff0000, 0);
		stopClip.black2.interactive = true;
		stopClip.addChild(stopClip.black2);
	}
	
}
function hideCloseClip() {
	if (kivid) kivid.filters = null;
	if (stopClip && stopClip.black) {
		stopClip.quitting = true;
		TweenLite.to(stopClip.black, 0.3, {alpha:0, onComplete:function() {
			removeAllChilds(stopClip);
			stopClip.action = null;
			gameContainer.removeChild(stopClip.black);
			stopClip.black = null;
			stopClip.black2 = null;
			if (stopClip.glowRotate) {clearInterval(stopClip.glowRotate); stopClip.glowRotate = null;}
		}});
	}
}
