var tournamentPing,askedRepeatPopup=false, tournamentGifts=[], doubleDragonsAmount=0, tournament_type=0, tr_type='';
function openTournament(fromFirstPopups) {
	if (tournamentPing) clearTimeout(tournamentPing);
	
	doubleDragonsAmount=0;
	tournamentPopup = new PIXI.Container();
	tournamentPopup.position.y = stageH*0.07;
	
	tournament_type = jsonObject.tournament.ttype;
	tr_type = tournament_type ?  'Baby Dragon': 'Golden Dragon';
	
	var bg = getAsset(tournament_type ? 'popup_pink_large' : 'popup_blue_large', stageH*0.84*(1140/990));
	bg.height = stageH*0.84;
	tournamentPopup.addChild(bg);
	tournamentPopup.bg = bg;
	
	setTimeout(function() {if (elements && elements.t_dr) elements.removeChild(elements.t_dr);}, 400);
	
	var centerX = parseInt(bg.width/2);
	var tuto = null;
	var slo1, slo2, slo3, slo4;
	
	tournamentPopup.label = createText(' ', {fontSize:18, bold:false, x:centerX, y:bg.height/24, width:tournamentPopup.bg.width*0.55, autoResize:true});
	tournamentPopup.addChild(tournamentPopup.label);
	tournamentPopup.label.anchor.x = 1;
	tournamentPopup.label2 = createText(' ', {fontSize:18, bold:false, color:'yellow', x:centerX, y:bg.height/24, width:tournamentPopup.bg.width*0.55, autoResize:true});
	tournamentPopup.addChild(tournamentPopup.label2);
	tournamentPopup.label2.anchor.x = 0;
	
	var closeBut = getAsset('closeBut', bg.width/17);
	closeBut.position.x = bg.width/1.05;
	closeBut.position.y = bg.height/19;
	closeBut.interactive = closeBut.buttonMode = true;
	
	var si,sp,prizesToGo; // token ticking interval (tournamentData.tokenTimer)
	var tokensBoughtPopup = false;
	var spinBut, playTBut;
	var tournamentOfferData;
	
	var IE_TournaTimer;
	tournamentPopup.startIEtimer = function() {
		clearInterval(IE_TournaTimer);
		IE_TournaTimer = setTimeout(function() {
			if (tournamentPopup && screen) {
				if (playTBut && playTBut.mode=='disabled' && !tokensBoughtPopup) removeTournamentMap();
				else tournamentPopup.startIEtimer();
			}
		}, 15*60000);
	};
	tournamentPopup.startIEtimer();
	
	var leaderboard = new PIXI.Container();
	leaderboard.scrollTouched = 0;

	closeBut.on('click', removeTournamentMap).on('touchstart', removeTournamentMap);
	function removeTournamentMap() {
		removeTournament();
		playMusic(1);
		jsonObject.timeToLifeFill = null;
		var tlwas = tournamentLeft;
		goMAP();
		tournamentLeft = tlwas;
		offery();
		tournamentNextSpinData = null;
		jsonTournamentDONE = null;
	}
	function removeTournament() {
		if (tournamentPing) clearTimeout(tournamentPing);
		clearInterval(si);
		clearInterval(sp);
		clearInterval(IE_TournaTimer);
		removeLoader();
		backStep=0;
		stopBlinkingVideoIcon();
		quitPopup(tournamentPopup);
	}
	function stopBlinkingVideoIcon() {
		if (tournamentPopup.blinkingIcon) {
			if (screen && tokenAdsIcon) {
				screen.removeChild(tokenAdsIcon);
				screen.removeChild(tokenVideoTxt);
				screen.removeChild(tokenVideoTxt2); 
			}
		}
		tokenAdsIcon = tokenVideoTxt = tokenVideoTxt2 = tournamentPopup.blinkingIcon = null;
	}
	tournamentPopup.removeTournamentMap = removeTournamentMap;
	tournamentPopup.removeingData = function() {
		leaderboard.destroy({children:true, baseTexture:true});
		if (slo1) {
			slo1.destroy({children:true, baseTexture:true});
			slo2.destroy({children:true, baseTexture:true});
			slo3.destroy({children:true, baseTexture:true});
			slo4.destroy({children:true, baseTexture:true});
		}
		prizes.destroy({children:true});
		screen.destroy({children:true});
		tournamentPopup.destroy({children:true});
		removeAllChilds(screen);
		stopBlinkingVideoIcon();
		slo1 = null;
		slo2 = null;
		slo3 = null;
		slo4 = null;
		leaderboard = null;
		prizes = null;
		screen = null;
		tournamentPopup = null;
	};
	
	// notouch
	var notouch;
	function addNotouch() {
		if (!notouch) {
			notouch = wholeBox(0xffff00, dev ? 0.22 : 0);
			notouch.interactive = true;
			stage.addChild(notouch);
		}
	}
	function removeNotouch() {
		if (notouch) stage.removeChild(notouch);
		notouch = null;
	}

	
	var screen = new PIXI.Container();
	screen.position.x = bg.width*0.1;
	screen.position.y = bg.width*0.17;
	tournamentPopup.addChild(screen);
	screen.visible = false;
	tournamentPopup.addChild(closeBut);
	
	var timerToken, rightBg, tokens, exp1, exp2, readyToSpin = false, activeLevel, tournamentLevels = [], rolling = false,
		tokensTime, tokensNRHave;
	
	function storeLocalData(jo) {
		if (jo.tokentime>=0) timerToken = jo.tokentime;
		if (jo.tokens>=0) tokens = jo.tokens;
		if (jo.doubleDragons>=0) doubleDragonsAmount = jo.doubleDragons*1;
		if (jo.tournament) {
			if (jo.tournament) tournamentData = jo.tournament;
			if (tournamentData.offer && tournamentData.offer.code=='tournamentOffer') tournamentOfferData = tournamentData.offer;
		}
		if (jo.tournamentLevels>=0) tournamentLevels = jo.tournamentLevels;
	}
	
	var prizes = new PIXI.Container();
	var haveScroll = false;
	
	function drawRightArea() {
		// right area
		rightBg = getAsset('tournament_right_bg', bg.width*0.38);
		rightBg.position.x = bg.width*0.97 - screen.position.x - rightBg.width;
		rightBg.position.y = -bg.height*0.08;
		rightBg.height = bg.height * 0.7;
		screen.addChild(rightBg);
		var centerX = rightBg.position.x + rightBg.width/2;
		var lab1 = createText(xmlValue('leaderboard'), {fontSize:14, bold:false, color:"white", x:centerX, y:rightBg.position.y + rightBg.height*0.03, width:rightBg.width*0.8});
		screen.addChild(lab1);
		var lab2 = createText(xmlValue('prizes'), {fontSize:14, bold:false, color:"white", x:centerX, y:rightBg.position.y + rightBg.height*0.525, width:rightBg.width*0.8});
		screen.addChild(lab2);
		exp1 = getAsset('explain', bg.width*0.04);
		exp1.anchor.x = exp1.anchor.y = 0.5;
		exp1.position.x = lab1.position.x + lab1.width/2 + exp1.width;
		exp1.position.y = lab1.position.y;
		screen.addChild(exp1);
		exp2 = getAsset('explain', bg.width*0.04);
		exp2.anchor.x = exp2.anchor.y = 0.5;
		exp2.position.x = lab2.position.x + lab2.width/2 + exp2.width;
		exp2.position.y = lab2.position.y;
		screen.addChild(exp2);
		
		leaderboard.position.x = parseInt(rightBg.position.x + rightBg.width*0.05);
		leaderboard.position.y = parseInt(rightBg.position.y + rightBg.height*0.066);
		screen.addChild(leaderboard);
		prizes.position.x = parseInt(leaderboard.position.x - rightBg.width*0.006);
		prizes.position.y = parseInt(rightBg.position.y + rightBg.height*0.6);
		screen.addChild(prizes);
		
		var area = new PIXI.Graphics();
		area.beginFill(0xff0000, 0);
		area.drawRect(0, 0, rightBg.width*0.85, 10);
		area.endFill();
		leaderboard.addChild(area);
		leaderboard.area = area;
	}
	
	
	
	var spinned = false;
	var scoreCode = '';
	// B case: Tournament playing popup
	tournamentPopup.drawPLAY = function(jo) {
		scoreCode = null;
		// refresh data
		addLoader();
		if (jo) haveData(jo);
		else serverSend('/api/tournament', haveData, removeTournamentMap);
		
		function haveData(jo) {
			scoreCode = '';
			jsonObject = jo;
			
			money = jo.money;
			refreshTopData();
			//bg.texture = assets.resources[tournament_type ? 'popup_pink_large' : 'popup_blue_large'].texture;
			
			removeAllChilds(screen);
			scoretableClips = [];
			
			updateLabel(xmlValue('playTournament')+' <yellow>'+convertToTime2(tournamentLeft - (tournamentData.type=='B' && tournamentLeft>=900 ? 900 : 0), true)+'</yellow>');
			
			if (jsonObject.prizes && jsonObject.tournament) {
				storeLocalData(jo);
				
				var spinOlev = createText(xmlValue('spinOlevel'), {fontSize:18, color:'yellow', x:0, y:-25, width:bg.width*0.5, autoResize:true});
				//spinOlev.rotation = -5 * Math.PI/180;
				var info = getAsset('explain', bg.width*0.04);
				info.anchor.x = info.anchor.y = 0.5;
				info.position.y = spinOlev.position.y - info.height/3;
				info.interactive = info.buttonMode = true;
				info.on('click', openTuto).on('touchstart', openTuto);
				
				// draw progress
				if (tournamentData.type=='B' && tournamentLeft>900) {
					var progress = new PIXI.Container();
					/*var riba1 = getAsset('ach_scr1', bg.width*0.38);
					riba1.height = bg.height*0.04;
					riba1.anchor.y = 0.5;
					progress.addChild(riba1);*/
					var riba = getAsset('bar_empty', bg.width*0.45);
					riba.height = bg.height*0.05;
					riba.anchor.y = 0.5;
					//var ribaProgress = new PIXI.Graphics();
					var riba_fill = getAsset('bar_full');
					riba_fill.height = bg.height*0.05;
					riba_fill.anchor.y = 0.5;
					//ribaProgress.beginFill(0x67c121, 1);
					//ribaProgress.moveTo(0,0);
					/*ribaProgress.lineTo(prgW, 0);
					ribaProgress.lineTo(prgW, riba.height*0.8);
					ribaProgress.lineTo(0, riba.height*0.8);
					ribaProgress.lineTo(0, 0);
					ribaProgress.endFill();
					ribaProgress.position.x = riba.height*0.12;
					ribaProgress.position.y = -riba.height*0.4;
					progress.addChild(ribaProgress);*/
					
					var nr = 0;
					if (jo.dragonpairs < 100) nr = 100;
					else if (jo.dragonpairs < 400) nr = 400;
					else if (jo.dragonpairs < 800) nr = 800;
					else if (jo.dragonpairs < 1200) nr = 1200;
					else if (jo.dragonpairs < 1600) nr = 1600;
					
					var prgW = jo.dragonpairs*(riba.width*0.98)/nr;
					if (prgW>riba.width*0.98) prgW=riba.width*0.98;
					riba_fill.width = prgW;
					
					var collected = createText(jo.dragonpairs + ' of ' + nr + ' Collected', {fontSize:11, bold:false, color:'white', x:riba.width/2, y:1, autoResize:true});
					collected.anchor.x = 0.5;
					var icod = getAsset(tournament_type ? 'babyDragonIcon' : 'goldenDragonIcon', riba.height*0.75);
					icod.position.x = collected.position.x + collected.width/2 + 4;
					icod.position.y = -8;
					
					progress.addChild(riba);
					progress.addChild(riba_fill);
					progress.addChild(collected);
					progress.addChild(icod);
					
					/*addPrizeBox(0.0625, 100);
					addPrizeBox(0.25, 400);
					addPrizeBox(0.5, 800);
					addPrizeBox(0.75, 1200);
					addPrizeBox(1, 1600);*/
					
					function addPrizeBox(wdth, n) {
						var ico = getAsset('boxTournament', parseInt(bg.width*0.044));
						ico.anchor.x = 0.5; ico.anchor.y = 0.58;
						ico.position.x = Math.round(riba.width*wdth + (n<1600 ? ico.width/4 : 0));
						
						progress.addChild(ico);
						if (jo.dragonpairs<n) {
							hintPrg = xmlValue('tournamentProgress');
							hintPrg = hintPrg.replace('[number]',n);
							makeHint(ico, hintPrg, 'BR', stageW*0.16, 0, 0);
						} else {
							var done = getAsset('check_gift', parseInt(bg.width*0.033));
							done.anchor.x = done.anchor.y = 0.5;
							done.position = ico.position;
							progress.addChild(done);
						}
					}
					
					progress.position = {x:-8,  y:bg.height*0.58};
					screen.addChild(progress);
				}
				
				if (tournamentData.offer && tournamentData.offer.code == 'tournamentOffer') {
					var offer = getAsset("tournamentOffer", bg.width*0.22);
					offer.anchor.set(0.5);
					offer.position.x = -bg.width*0.05;
					offer.position.y = bg.height*0.68;
					offer.interactive = offer.buttonMode = true;
					offer.on('click', openTOffer).on('touchstart', openTOffer); // offer js
					function openTOffer() {
						addNotouch();
						setTimeout(removeNotouch, 400);
						if (!offerPopup) {
							offerData = tournamentOfferData;
							openOffer();
						}
					}
					var offerTxt = createText(xmlValue('specialOffer'), {fontSize:28*assetsRatio['tournamentOffer'], stroke:9*assetsRatio['tournamentOffer'], x:offer.width*0.02*assetsRatio['tournamentOffer'], y:-offer.height*0.1*assetsRatio['tournamentOffer'], multiline:true, width:offer.width*0.8*assetsRatio['tournamentOffer'], height:offer.height*0.5*assetsRatio['tournamentOffer'], autoResize:true});
					offer.addChild(offerTxt);
					//screen.addChild(offer);
				}
				
				// draw Play tournament popup...
				drawSpinner();
				drawRightArea();
				
				screen.addChild(spinOlev);
				screen.addChild(info);
				// center area
				centerX = parseInt((bg.width - rightBg.position.x)/2.5);
				spinOlev.position.x = centerX;
				info.position.x = spinOlev.position.x + spinOlev.width/2 + info.width;
				
				function openTuto() {
					if (prizesToGo) prizesToGo.visible = false;
					if (tuto==null) {
						// tournament tutorial text...
						tuto = new PIXI.Container();
						
						// draw darken area...
						
						var bgt = getAsset('stopClpBG', rightBg.width + 47*scale);
						bgt.height = rightBg.height*1.03;
						bgt.position.x = rightBg.position.x - 15*scale;
						bgt.position.y = rightBg.position.y - 8*scale;
						tuto.addChild(bgt);
						var centerX = bgt.position.x + bgt.width/2;
						var txt = createText(xmlValue('tournamentTutorial').split('<br>').join('\n').split('&quot;').join('"'), {fontSize:12, stroke:0, shadow:false, color:'#58301F', align:'left', multiline:true, x:centerX, y:bgt.position.y + bgt.width*0.08, width:bgt.width*0.9, height:bgt.height*0.8});
						txt.anchor.y = 0;
						tuto.addChild(txt);
						
						var but = initBUT(xmlValue('gotit'), '');
						but.on('click', closeTuto).on('touchstart', closeTuto);
						but.position.y = parseInt(bgt.position.y + bgt.height * 0.933);
						centerBut(but, centerX);
						tuto.addChild(but);
						screen.addChild(tuto);
						function closeTuto() {
							removeAllChilds(tuto);
							screen.removeChild(tuto);
							if (prizesToGo) prizesToGo.visible = true;
							tuto = null;
						}
						if (autoplaying) setTimeout(closeTuto, 1000);
					}
				}
				
				// sharing my tournament
				// override data if enter firsttime
				if (myTournamentScoreWas==-1) myTournamentScoreWas = jo.dragonpairs*1;
				if (myTournamentPlaceWas==-1) myTournamentPlaceWas = jo.myplace;
				var shareScore = 0;
				if (jo.dragonpairs > myTournamentScoreWas && sharesObj.tournamentDragonsCollected) {
					if (myTournamentScoreWas<1600 && jo.dragonpairs>=1600) shareScore=1600;
					else if (myTournamentScoreWas<1200 && jo.dragonpairs>=1200) shareScore=1200;
					else if (myTournamentScoreWas<800 && jo.dragonpairs>=800) shareScore=800;
					else if (myTournamentScoreWas<400 && jo.dragonpairs>=400) shareScore=400;
					else if (myTournamentScoreWas<100 && jo.dragonpairs>=100) shareScore=100;
					
					log('shareScore = '+shareScore+' / tournamentGifts.length='+tournamentGifts.length);

					if (shareScore>0 && tournamentGifts.length>0) {
						// draw shared score popup (shareScore)
						
						var sharingPlace = new PIXI.Container();
						sharingPlace.position.y = stageH*0.1;
						
						var bb = getAsset('popup_small', 'auto', stageH*0.78);
						var centerX_share = parseInt(bb.width/2);
						sharingPlace.bg = bb;
						sharingPlace.addChild(bb);
						
						var share_lab = createText(xmlValue('congratulatuons'), {fontSize:25, x:centerX_share, y:bb.height*0.082, width:bb.width*0.7, autoResize:true});
						sharingPlace.addChild(share_lab);
	
						var share_t1 = createText(xmlValue('youCollected'), {fontSize:25, color:'yellow', x:centerX_share, y:bb.height*0.28, width:bb.width*0.75});
						sharingPlace.addChild(share_t1);
						
						// draw claimed gifts...
						var icoW = parseInt(bb.width*0.15);
						var xx = centerX_share - (tournamentGifts.length-1)*icoW*1.3/2;
						for (var ii in tournamentGifts) {
							var icn = getAsset(tournamentGifts[ii].type, icoW);
							icn.anchor.x = 0.5;
							icn.position = {x:xx, y:bb.height*0.58};
							sharingPlace.addChild(icn);
							var val = createText(tournamentGifts[ii].value, {fontSize:26, x:xx, y:bb.height*0.71, width:icoW});
							sharingPlace.addChild(val);
							xx+=icoW*1.3;
						}
						
						var ico = getAsset('goldDragon2_big', bb.width*0.2);
						ico.anchor.y = 0.5;
						ico.position.x = bb.width*0.56;
						ico.position.y = bb.height*0.45;
						sharingPlace.addChild(ico);
						
						var share_score = createText(shareScore, {fontSize:67, color:'yellow', x:bb.width*0.38, y:bb.height*0.45, width:bb.width*0.3});
						sharingPlace.addChild(share_score);
						
						var dragon = getSheet('dragonHappy');
						makeSheet(dragon, bb.width*0.43, false, 0.5, bb.width*0.89, bb.height*0.45);
						sharingPlace.addChild(dragon);
						
						var but = initBUT(xmlValue('claim'),'');
						centerBut(but, centerX_share);
						but.position.y = bb.height*0.89;
						but.on('click', share).on('touchstart', share);
						sharingPlace.addChild(but);
						
						/*var sharing_chb = addSharing('shareGoodNews');
						sharing_chb.position.x = parseInt(but.position.x + but.w/2 - sharing_chb.width/2);
						sharing_chb.position.y = bb.height * 0.82;
						sharingPlace.addChild(sharing_chb);
						sharing_chb.checkbox.on('click', sharingChange).on('touchstart', sharingChange);
						function sharingChange() {
							claimTournamentShare = !claimTournamentShare;
							sharing_chb.checked.visible = claimTournamentShare;
						}*/
						
						function share() {
							if (claimTournamentShare) ads(sharesObj.tournamentDragonsCollected);
							refreshTopData();
							quitPopup(sharingPlace);
							setTimeout(function() {
								removeAllChilds(sharingPlace);
								sharingPlace=null;
							}, 350);
						}
						
						if (autoplaying) setTimeout(share, 1000);
						setTimeout(function() {animatePopup(sharingPlace);}, 300);
					}
				}
				if (shareScore==0 && jo.myplace<4 && myTournamentPlaceWas>0 && myTournamentPlaceWas>jo.myplace && sharesObj.tournamentLevelUp) {
					//ads(sharesObj.tournamentLevelUp);
					sharesObj.tournamentLevelUp = null;
				}
				// store sharing data for future
				myTournamentPlaceWas = jo.myplace;
				myTournamentScoreWas = jo.dragonpairs*1;
				
				refreshLeaderboard(jo);
				
				if (tournamentPopup.popupType == 'join') openTuto(); // open tutorial first time.
				
			}
			else removeTournamentMap();
			tournamentPopup.popupType = 'play';
			
			tournamentGifts = [];
			
			
			function videoADF() {
				var isVideoWatched = false;
				stopBlinkingVideoIcon();
				if ((myData.pgroup==false || (myData.pgroup==true && money>10) || storedVars.forceLSM*1==1) && tokens==0 && playTimesToShowTokenVideo>=2 && tournamentLeft>1800) { // || true for test.
					
					// check have video ads...
					lsmAd(
						function (ad) { videoAd = ad; if (videoAd) addVideoButton(); }, 
						videoWatched,
						videoEnd
					);
					
					function askTokenVideo() {
						numlog('lsm_token_acceptAD');
						lsmAdShow(videoAd);
					}
					function videoWatched() {
						isVideoWatched = true;
						playTimesToShowTokenVideo = 0;
						videoAd = null;
					}
					function videoEnd() {
						if (isVideoWatched) {
							gflog('LSM token');
							numlog('lsm_token_claim');
							addLoader();
							serverSend('/api/tournament&lsmToken=1', function (jo) {
								// refresh tokens...
								removeLoader();
								storeLocalData(jo);
								
								if (tournamentLeft == 900) playEnded();
								else if (tournamentLeft < 900) {
									if (claimStarts) screen.removeChild(claimStarts);
									claimStarts = createText(convertToTime(tournamentLeft, true), {fontSize:19, color:"yellow", x:centerX, width:bg.width*0.5, y:bg.height*0.63});
									screen.addChild(claimStarts);
								} else {
									if (tokensNRHave) updateTxt(tokensNRHave, tokens==0 ? '0' : tokens);
									var tt_txt = tokens>=5 ? xmlValue('fullLives') : convertToTime(timerToken);
									if (tokensTime) screen.removeChild(tokensTime);
									var tok_bg_w = bg.width*0.23;
									tokensTime = createText(tt_txt, {fontSize:16, x:centerX + tok_bg_w*0.07, width:tok_bg_w*0.47, y:-bg.height*0.064, autoResize:true});
									screen.addChild(tokensTime);
								}
							}, function() {
								disconnect('Sorry, can\'t connect to server.', true);
							});
						} else {
							numlog('lsm_token_cancelAD');
						}
						stopBlinkingVideoIcon();
					}
					function addVideoButton() {
						if (tournamentPopup) {
							var wh = bg.width*0.2;
							tokenAdsIcon = getAsset('videoTV', wh*0.62);
							tokenAdsIcon.anchor.x = tokenAdsIcon.anchor.y = 0.5;
							tokenAdsIcon.position = {x:-bg.width*0.043, y:-bg.height*0.14};
							tokenVideoTxt = getAsset('videoSquare', wh);
							tokenVideoTxt.anchor.x = tokenVideoTxt.anchor.y = 0.5;
							tokenVideoTxt.position = tokenAdsIcon.position;
							tokenVideoTxt.position.y += wh*0.43;
							
							tournamentPopup.blinkingIcon = tokenAdsIcon;
							blinkIcon2('tournamentPopup');
							
							tokenVideoTxt2 = createText(xmlValue('tokenVideoButTxt'), {fontSize:14, lineHeight:14, color:'#ffffff', x:tokenVideoTxt.position.x, y:tokenVideoTxt.position.y-wh*0.005, width:wh*0.86, height:wh*0.31, multiline:true, autoResize:true});
							tokenAdsIcon.interactive = tokenAdsIcon.buttonMode = true;
							tokenVideoTxt.interactive = tokenVideoTxt.buttonMode = true;
							screen.addChild(tokenVideoTxt);
							screen.addChild(tokenVideoTxt2);
							screen.addChild(tokenAdsIcon);
							
							numlog('lsm_token_showAD');
							
							tokenAdsIcon.on('click', askTokenVideo).on('touchstart', askTokenVideo);
							tokenVideoTxt.on('click', askTokenVideo).on('touchstart', askTokenVideo);
						}
					}
					
				}
			}
			// add by default if 0 tokens at open
			videoADF();
			
			
			// ********* SPINNER ************
			
			
			function drawSpinner() {
				rolling = false;
				var centerX = parseInt(bg.width*0.22);
				
				var but1 = initBUT(xmlValue('play') + ' Level', 'green');
				var but2 = initBUT(xmlValue('spin') + ' for 1 [token]', 'blue');
				spinBut = but2;
				playTBut = but1;
				tournamentPopup.spinBut = but2;
				but1.disable(); but2.disable();
				but1.on('click', playTournament).on('touchstart', playTournament);
				but2.on('click', spinTournament).on('touchstart', spinTournament);
				
				but1.visible = spinned;

				but2.scale.set(0.7);
				centerBut(but1, centerX);
				centerBut(but2, centerX);
				but1.position.y = bg.height*0.4;
				but2.position.y = bg.height*0.33;
				
				var nr = 0;
				if (jo.dragonpairs < 100) nr = 100;
				else if (jo.dragonpairs < 400) nr = 400;
				else if (jo.dragonpairs < 800) nr = 800;
				else if (jo.dragonpairs < 1200) nr = 1200;
				else if (jo.dragonpairs < 1600) nr = 1600;
				
				var collect100 = createText(xmlValue('collecttoclaim').replace('[number]', nr).replace('[tr_type]', tr_type), {fontSize:12, color:'white', bold:false, x:centerX - 15, y:bg.height*0.53, autoResize:true});
				collect100.anchor.x = 0.5;
				screen.addChild(collect100);
				
				var ico_box = getAsset('boxTournament', bg.width*0.04);
				ico_box.anchor.x = ico_box.anchor.y = 0.5;
				ico_box.position.x = collect100.position.x + collect100.width/2 + 15;
				ico_box.position.y = collect100.position.y;
				screen.addChild(ico_box);

				var w = bg.width*0.41;
				var spin_bg = getAsset('spin_bg', w);
				var spinLine = new PIXI.Graphics(); spinLine.lineStyle(0.5 ,0x724e16); spinLine.moveTo(0,0); spinLine.lineTo(spin_bg.width-3,0);
				var spin_top = getAsset('spin_top', w);
				screen.addChild(spin_bg);
				screen.addChild(spinLine);
				spin_bg.position.x = spin_top.position.x = spinLine.position.x = centerX - w/2;
				spin_bg.position.y = spin_top.position.y = 0;
				spinLine.position.y = spin_bg.position.y + spin_bg.height*0.5;
				slo1 = new PIXI.Container();
				slo2 = new PIXI.Container();
				slo3 = new PIXI.Container();
				slo4 = new PIXI.Container();
				slo1.position.y = slo2.position.y = slo3.position.y = slo4.position.y = parseInt(spin_bg.position.y + spin_bg.height*0.05);
				slo1.position.x = parseInt(spin_bg.position.x + w*0.017);
				slo2.position.x = parseInt(spin_bg.position.x + w*0.31);
				slo3.position.x = parseInt(spin_bg.position.x + w*0.54);
				slo4.position.x = parseInt(spin_bg.position.x + w*0.75);
				slo1.visible = slo2.visible = slo3.visible = slo4.visible = false;
				var mw = w*0.23;
				var mh = spin_bg.height*0.9;
				var mas1 = new PIXI.Graphics(); mas1.beginFill(0xff0000, 1); mas1.drawRect(0, 0, mw, mh);
				mas1.position = slo1.position;
				var mas2 = new PIXI.Graphics(); mas2.beginFill(0xff0000, 1); mas2.drawRect(0, 0, mw, mh);
				mas2.position.x = w*0.31;  mas2.position.y = slo2.position.y;
				var mas3 = new PIXI.Graphics(); mas3.beginFill(0xff0000, 1); mas3.drawRect(0, 0, mw, mh);
				mas3.position.x = w*0.54;  mas3.position.y = slo3.position.y;
				var mas4 = new PIXI.Graphics(); mas4.beginFill(0xff0000, 1); mas4.drawRect(0, 0, mw, mh);
				mas1.visible = mas2.visible = mas3.visible = mas4.visible = false;
				mas4.position = slo4.position;
				screen.addChild(slo1); screen.addChild(slo2); screen.addChild(slo3); screen.addChild(slo4);
				screen.addChild(mas1); screen.addChild(mas2); screen.addChild(mas3); screen.addChild(mas4);
				screen.addChild(spin_top);
				
				var thW = parseInt(mw*0.8);
				
				screen.addChild(but1);
				screen.addChild(but2);
				
				// tokens + ticking bar
				var maxTokens = 5;
				/*var token_bg = getAsset('gems_bg', bg.width*0.23);
				token_bg.position.x = centerX - token_bg.width/2;
				token_bg.position.y = -bg.height*0.065;
				token_bg.anchor.y = 0.5;
				screen.addChild(token_bg);
				var token_ico = getAsset('token', bg.width*0.077);
				token_ico.position.x = token_bg.position.x + token_ico.width*0.5;
				token_ico.position.y = token_bg.position.y;
				token_ico.anchor.x = token_ico.anchor.y = 0.5;
				screen.addChild(token_ico);
				
				var plus_but = getAsset('plusBut', bg.width*0.041);
				plus_but.position.x = token_bg.position.x + token_bg.width*0.78;
				plus_but.position.y = token_bg.position.y;
				plus_but.anchor.y = 0.5;
				plus_but.interactive = plus_but.buttonMode = true;
				plus_but.on('click', drawTokens).on('touchstart', drawTokens);
				var plus_but_dis = getAsset('plusBut_disabled', bg.width*0.041);
				plus_but_dis.position = plus_but.position;
				plus_but_dis.anchor = plus_but.anchor;
				screen.addChild(plus_but_dis);
				screen.addChild(plus_but);
				plus_but.visible = tokens<maxTokens;*/
				
				
				var joinBG = getAsset('tournament_bottom_bar', bg.width*1.12);
				joinBG.height = bg.height*0.25;
				joinBG.anchor.x = 0.5;
				joinBG.position.x = parseInt(bg.width/2)-bg.width*0.1;
				joinBG.position.y = bg.height*0.6;
				screen.addChild(joinBG);
				
				var item_slot = getAsset('item_slot', joinBG.width*0.21);
				item_slot.height = joinBG.height*0.52;
				//item_slot.anchor.x = 0.5;
				item_slot.position.x = joinBG.position.x - joinBG.width/2 + 40;
				item_slot.position.y = joinBG.position.y + 25;
				screen.addChild(item_slot);
				
				var coin_ico = getAsset('coin', item_slot.width*0.35);
				coin_ico.position.x = item_slot.position.x + 8;
				coin_ico.position.y = item_slot.position.y + 5;
				screen.addChild(coin_ico);
				
				var coin_sum = createText('20', {fontSize:16, bold:false, color: 'yellow', x:coin_ico.position.x+coin_ico.width*0.5, y:coin_ico.position.y + coin_ico.height - 4});
				coin_sum.anchor.x = 0.5;
				screen.addChild(coin_sum);
				
				var plus_ico = getAsset('btn_plus', coin_ico.width*0.4);
				plus_ico.position.x = item_slot.position.x + item_slot.width/2;
				plus_ico.position.y = coin_ico.position.y + coin_ico.height/2;
				plus_ico.anchor.y = plus_ico.anchor.x = 0.5;
				screen.addChild(plus_ico);
				
				var token_ico = getAsset('token', coin_ico.width);
				token_ico.position.x = item_slot.position.x + item_slot.width - token_ico.width - 8;
				token_ico.position.y = coin_ico.position.y;
				screen.addChild(token_ico);
				
				var token_sum = createText('20', {fontSize:16, bold:false, color: 'yellow', x:token_ico.position.x+token_ico.width*0.5, y:token_ico.position.y + token_ico.height - 4});
				token_sum.anchor.x = 0.5;
				screen.addChild(token_sum);
				
				buy_but = initBUT('Buy for ' + (tournamentOfferData.currency == 'USD' ? '$' : (tournamentOfferData.currency == 'EUR' ? '€' : '')) + tournamentOfferData.price, 'green');
				buy_but.scale.set(0.6);
				centerBut(buy_but, item_slot.position.x+item_slot.width/2-5);
				buy_but.position.y = item_slot.position.y + item_slot.height + 4;
				buy_but.on('click', tournamentOffer).on('touchstart', tournamentOffer);
				screen.addChild(buy_but);
				
				function tournamentOffer() {
					offerData = tournamentOfferData;
					btnAction = offerData.btnAction;
					buyOffer();
				}
				
				var token_ico2 = getAsset('token', coin_ico.width);
				token_ico2.position.x = item_slot.position.x + item_slot.width + 42;
				token_ico2.position.y = token_ico.position.y;
				screen.addChild(token_ico2);
				
				if (tokensNRHave) screen.removeChild(tokensNRHave);
				var tokensNRHave = createText(tokens, {fontSize:16, bold:false, color: 'yellow', x:token_ico2.position.x+token_ico2.width*0.5, y:token_ico2.position.y + 5});
				tokensNRHave.anchor.x = 0.5;
				screen.addChild(tokensNRHave);
				
				var item_slot2 = getAsset('item_slot', joinBG.width*0.11);
				item_slot2.height = joinBG.height*0.22;
				item_slot2.anchor.x = 0.5;
				item_slot2.position.x = token_ico2.position.x + token_ico2.width*0.5;
				item_slot2.position.y = token_ico2.position.y + token_ico2.height*0.62;
				screen.addChild(item_slot2);
				
				if (tokensTime) tokensTime.destroy();
				tokensTime = createText('', {fontSize:16, x:item_slot2.position.x, width:item_slot2.width*0.8, y:item_slot2.position.y + item_slot2.height*0.5});
				tokensTime.anchor.x = 0.5;
				tickTokenTimer();
				screen.addChild(tokensTime);
				
				
				var item_slot3 = getAsset('item_slot', joinBG.width*0.13);
				item_slot3.height = joinBG.height*0.5;
				//item_slot.anchor.x = 0.5;
				item_slot3.position.x = token_ico2.position.x + token_ico2.width + 42;
				item_slot3.position.y = item_slot.position.y;
				screen.addChild(item_slot3);
				
				var token_ico3 = getAsset('token', token_ico2.width);
				token_ico3.anchor.x = 0.5;
				token_ico3.position.x = item_slot3.position.x + item_slot3.width/2;
				token_ico3.position.y = token_ico2.position.y;
				screen.addChild(token_ico3);
				
				var token_sum3 = createText('1', {fontSize:16, bold:false, color: 'yellow', x:token_ico3.position.x, y:token_ico3.position.y + token_ico3.height - 4});
				token_sum3.anchor.x = 0.5;
				screen.addChild(token_sum3);
				
				buy_but3 = initBUT('Buy for 2 [coin]', 'blue');
				buy_but3.scale.set(0.6);
				centerBut(buy_but3, token_ico3.position.x-3);
				buy_but3.position.y = item_slot3.position.y + item_slot3.height + 6;
				buy_but3.on('click', buyTPack1).on('touchstart', buyTPack1);
				screen.addChild(buy_but3);
				
				
				var item_slot4 = getAsset('item_slot', joinBG.width*0.13);
				item_slot4.height = joinBG.height*0.5;
				//item_slot.anchor.x = 0.5;
				item_slot4.position.x = item_slot3.position.x + item_slot3.width + 24;
				item_slot4.position.y = item_slot.position.y;
				screen.addChild(item_slot4);
				
				var token_ico4 = getAsset('token', token_ico2.width);
				token_ico4.anchor.x = 0.5;
				token_ico4.position.x = item_slot4.position.x + item_slot4.width/2;
				token_ico4.position.y = token_ico2.position.y;
				screen.addChild(token_ico4);
				
				var token_sum4 = createText('5', {fontSize:16, bold:false, color: 'yellow', x:token_ico4.position.x, y:token_ico4.position.y + token_ico4.height - 4});
				token_sum4.anchor.x = 0.5;
				screen.addChild(token_sum4);
				
				buy_but4 = initBUT('Buy for 8 [coin]', 'blue');
				buy_but4.scale.set(0.6);
				centerBut(buy_but4, token_ico4.position.x-3);
				buy_but4.position.y = item_slot4.position.y + item_slot4.height + 6;
				buy_but4.on('click', buyTPack2).on('touchstart', buyTPack2);
				screen.addChild(buy_but4);
				
				
				var item_slot5 = getAsset('item_slot', joinBG.width*0.13);
				item_slot5.height = joinBG.height*0.5;
				//item_slot.anchor.x = 0.5;
				item_slot5.position.x = item_slot4.position.x + item_slot4.width + 24;
				item_slot5.position.y = item_slot.position.y;
				screen.addChild(item_slot5);
				
				var token_ico5 = getAsset('token', token_ico2.width);
				token_ico5.anchor.x = 0.5;
				token_ico5.position.x = item_slot5.position.x + item_slot5.width/2;
				token_ico5.position.y = token_ico2.position.y;
				screen.addChild(token_ico5);
				
				var token_sum5 = createText('10', {fontSize:16, bold:false, color: 'yellow', x:token_ico5.position.x, y:token_ico5.position.y + token_ico5.height - 4});
				token_sum5.anchor.x = 0.5;
				screen.addChild(token_sum5);
				
				buy_but5 = initBUT('Buy for 15 [coin]', 'blue');
				buy_but5.scale.set(0.6);
				centerBut(buy_but5, token_ico5.position.x-3);
				buy_but5.position.y = item_slot5.position.y + item_slot5.height + 6;
				buy_but5.on('click', buyTPack3).on('touchstart', buyTPack3);
				screen.addChild(buy_but5);
				
				function buyTPack1() {
					buyTokens(1, prices.tokenPack1);	
				}
				function buyTPack2() {
					buyTokens(2, prices.tokenPack2);	
				}
				function buyTPack3() {
					buyTokens(3, prices.tokenPack3);	
				}
				function buyTokens(type, price) {
					buy_but.disable();
					buy_but3.disable();
					buy_but4.disable();
					buy_but5.disable();
					tournamentPopup.enableTokenButs = function() {
						if (buy_but3) {
							buy_but.enable();
							buy_but3.enable();
							buy_but4.enable();
							buy_but5.enable();
						}
					};
					if (money>=price) addLoader();
					checkMoney(price, 'tokenPack'+type);
					tokensBoughtPopup = false;
					
				}
				
				var claimStarts;
				
				clearInterval(si);
				si = setInterval(tickTokenTimer, 1000);
				refreshTokens();
				function tickTokenTimer() {
					timerToken--;
					if (timerToken<=0 && tokens<maxTokens) {
						if (!loader) addLoader();
						if (timerToken%5==0) tournamentPopup.refreshLB();
					}
					if (but2 && but2.mode=='disabled' && but2.visible && !rolling) but2.enable();
					if (spinned && but1 && but1.mode=='disabled' && but1.visible && !rolling) but1.enable();
					refreshTokens();
				}
				function refreshTokens() {
					if (jo.tournament.type=="C" || screen==null) return;
					if (tokens<0) tokens=0;
					
					if (tournamentLeft == 900) playEnded();
					else if (tournamentLeft < 900) {
						if (claimStarts) updateTxt(claimStarts, convertToTime(tournamentLeft, true));
						else {
							claimStarts = createText(convertToTime(tournamentLeft, true), {fontSize:19, color:"yellow", x:centerX, width:bg.width*0.5, y:bg.height*0.63});
							screen.addChild(claimStarts);
						}
					} else {
						if (tokensNRHave) updateTxt(tokensNRHave, tokens==0 ? '0' : tokens);
						if (tokensTime) updateTxt(tokensTime, tokens>=5 ? xmlValue('fullLives') : convertToTime(timerToken<0 ? 0 : timerToken));
						//plus_but.visible = !(tokens>=maxTokens || rolling);
					}
				}
				
				var poz,poz4;
				if (tournamentLeft >= 900) spinNow('firsttime');
				else playEnded();
				
				function playEnded() {
					spinned = false;
					but1.disable();
					/*plus_but.visible = */
					but2.visible = but1.visible = tokensTime.visible = tokensNRHave.visible = token_bg.visible = token_ico.visible = false;
					spin_bg.visible = spin_top.visible = false;
					spinOlev.visible = false;
					info.visible = false;
					removeAllChilds(slo1);
					removeAllChilds(slo2);
					removeAllChilds(slo3);
					removeAllChilds(slo4);
					if (offer) offer.visible = false;
					updateLabel(xmlValue('tournamentBEnded'));
					var karikas = getAsset('karikas', bg.width*0.27);
					karikas.anchor.x = 0.5;
					karikas.position.x = centerX;
					karikas.position.y = -bg.height*0.08;
					screen.addChild(karikas);
					var end_txt1 =  createText(xmlValue('tournamentBEnded1'), {fontSize:19, x:centerX, width:bg.width*0.5, y:bg.height*0.35});
					screen.addChild(end_txt1);
					var end_txt2 =  createText(xmlValue('tournamentBEnded2'), {fontSize:17, multiline:true, color:"brown", stroke:0, x:centerX, width:bg.width*0.5, y:bg.height*0.445});
					screen.addChild(end_txt2);
					var end_txt3 =  createText(xmlValue('tournamentBEnded3'), {fontSize:18, x:centerX, width:bg.width*0.5, y:bg.height*0.55});
					screen.addChild(end_txt3);
					removeLoader();
					screen.visible = true;
					if (prizesToGo) prizesToGo.visible = false;
					offery();
				}
				
				function playTournament() {
					spinned = false;
					but1.disable();
					but2.disable();
					removeTournament();
					askedRepeatPopup = false;
					tournament_try100percent = true;
					setTimeout(selLevel, 100, activeLevel, true);
				}
				function spinTournament() {
					but1.disable();
					but2.disable();
					if (rolling) return;
					// spin
					if (tokens>0) {
						spinned = false;
						refreshTokens();
						if (readyToSpin) startSpinning(); else spinNow();			
					} else {
						drawTokens();
					}
				}
				tournamentPopup.spinTournament = spinTournament;
				function spinNow(arg) {
					readyToSpin = false;
					but1.disable();
					but2.disable();
					
					var thumbsLoaded = 0;
					
					removeAllChilds(slo1);
					removeAllChilds(slo2);
					removeAllChilds(slo3);
					removeAllChilds(slo4);
					
					addLoader();
					// query
					if (tournamentNextSpinData && arg=='firsttime') {
						log('from tournamentNextSpinData');
						spinDataF(tournamentNextSpinData);
					} else {
						serverSend('/api/tournament?action=spinData'+(arg=='firsttime' ? '&ft=1' : ''), function(jo) {
							jsonObject = jo;
							refreshTopData();
							spinDataF( {tournamentLevels: jo.tournamentLevels, activeLevel: jo.activeLevel} );
						}, removeTournamentMap);
					}
					
					function spinDataF(dt) {
						storeLocalData(dt);
						tournamentLevels = dt.tournamentLevels;
						activeLevel = dt.activeLevel;
			
						if (tournamentLevels && tournamentData.type=='B' && tournamentLeft>900) {
							refreshTokens();
							
							// load Thumbs
							addThumb(slo1, 0);
							addThumb(slo2, 1);
							addThumb(slo3, 2);
							
							if (!slo4) slo4 = new PIXI.Container();
							
							// add dragons to sp4
							for (var z = 0; z<tournamentLevels.length; z++) {
								var clp2 = getAsset(tournament_type ? 'babyDragon' : 'goldDragon2', thW);
								var t = createText(tournamentLevels[z].dragons*2, {fontSize:25, x:clp2.width*0.5/clp2.scale.x, y:clp2.height*0.5/clp2.scale.y, width:mw});
								clp2.addChild(t);
								clp2.position.x = mw*0.06;
								clp2.position.y = z * mw;
								if (tournamentLevels[z].id == activeLevel) {
									dragonCount = parseInt(tournamentLevels[z].dragons)*2;
									poz4 = clp2.position.y + clp2.height/2;
								}
								slo4.addChild(clp2);
							}
							// add one more in front and bottom of others
							clp2 = getAsset(tournament_type ? 'babyDragon' : 'goldDragon2', thW);
							t = createText(tournamentLevels[0].dragons*2, {fontSize:25, x:clp2.width*0.5/clp2.scale.x, y:clp2.height*0.5/clp2.scale.y, width:mw});
							clp2.addChild(t);
							clp2.position.y = -mw;
							slo4.addChild(clp2);
							clp2 = getAsset(tournament_type ? 'babyDragon' : 'goldDragon2', thW);
							t = createText(tournamentLevels[1].dragons*2, {fontSize:25, x:clp2.width*0.5/clp2.scale.x, y:clp2.height*0.5/clp2.scale.y, width:mw});
							clp2.addChild(t);
							clp2.position.y = tournamentLevels.length*mw;
							slo4.addChild(clp2);
							
							slo1.rot = slo2.rot = slo3.rot = slo4.rot = true;
							
							function addThumb(clp, z) {
								removeAllChilds(clp);
								var tmz,tmzt;
								// load thumbs to slots
								for (var i = 0; i<tournamentLevels.length; i++) {
									//log('thumb_'+z+'_'+i+' = '+(dt && dt.thumbs ? dt.thumbs['thumb_'+z+'_'+i] : null));	
									loadThmb(tournamentLevels[i].thumb[z], '', tournamentLevels[i], i, 		dt && dt.thumbs ? dt.thumbs['thumb_'+z+'_'+i] : null);
								}
								// add one to bottom and one up to...
								loadThmb(tournamentLevels[0].thumb[z], '', tournamentLevels[0], -1,							dt && dt.thumbs ? dt.thumbs['thumb_'+z+'_-1'] : null);
								loadThmb(tournamentLevels[1].thumb[z], '', tournamentLevels[1], tournamentLevels.length,	dt && dt.thumbs ? dt.thumbs['thumb_'+z+'_'+tournamentLevels.length] : null);
								
								function loadThmb(lnk, reload, obj, nr,  thmb) {
									var clpT = thmb || new PIXI.Sprite.fromImage(lnk+reload+'&w='+thW);
									clpT.anchor.x = clpT.anchor.y = 0.5;
									clpT.position.x = z==0 ? mw*0.52 : mw*0.36;
									clpT.position.y = mw*nr;
									// add times to thumbs
									var thumbTime = obj.levelTime.split(',');
									var tht = convertToTime(thumbTime[z]);
									var tmT = createText(tht, {fontSize:13, width:thW, color:"brown"});
									tmT.position = clpT.position;
									tmT.position.y += thW*0.3;
									if (obj.id == activeLevel && nr!=-1 && nr!=tournamentLevels.length) poz = clpT.position.y;
									
									if (thmb) thumbReady();
									else if (clpT.texture.baseTexture.hasLoaded==true) thumbReady();
									else clpT.texture.baseTexture.on('loaded', thumbReady).on('error', function() {
										setTimeout(function() {
											if (tournamentPopup && screen) loadThmb(lnk, Math.random().toString().replace('.', ''), obj, nr);
										}, 300);
									});
									
									function thumbReady(e) {
										if (!tournamentPopup || !screen) return;
										if (clpT.width>thW) clpT.width = clpT.height = thW;
										clp.addChild(clpT);
										clp.addChild(tmT);
										
										thumbsLoaded++;
										if (thumbsLoaded==(tournamentLevels.length+2)*3) {
											
											mas1.visible = mas2.visible = mas3.visible = mas4.visible = true;
											slo1.mask = mas1; slo2.mask = mas2; slo3.mask = mas3; slo4.mask = mas4;
											slo1.visible = slo2.visible = slo3.visible = slo4.visible = true;
											
											slo1.position.y -= Math.random()*mw;
											slo3.position.y -= Math.random()*mw;
											slo2.position.y -= Math.random()*mw;
											
											removeLoader(true);
											readyToSpin = true;
											
											if (arg=='firsttime') {
												screen.visible = true;
												makeHint(info, xmlValue('tournamentExplainOlevel'), 'TR', stageW*0.2, 0, 0);
												makeHint(exp1, xmlValue('tournamentExplainLeaderboard'), 'BL', stageW*0.33, 0, 0);
												makeHint(exp2, xmlValue('tournPrizeHint'), 'TL', stageW*0.33, 0, 0);
												if (tournamentLeft>=900) but2.enable();
												//spinned = true;
												if (but1 && but1.visible) but1.enable();
												if (autoplaying && !but2.mode != 'disabled') {
													if (tokens>0) setTimeout(spinTournament, 800); else setTimeout(drawTokens, 800);
												}
												
												tournamentNextSpinData = null;
												jsonTournamentDONE = null;
												
											} else {
												rolling = false;
												startSpinning();
											}
										}
									}
								}
							}
						} else removeTournamentMap();
						
					}
					
					
					
				}
				
				function startSpinning() {
					if (!rolling) {
						resetFPS();
						readyToSpin = false;
						but2.disable();
						
						//plus_but.visible = false;
						
						spin_bg.alpha = spin_top.alpha = 1;
						slo2.visible = slo3.visible = true;
						mas1.width = mw;
						
						spinning();
						sp = setInterval(spinning, 8);
						playSound('wheelStart');
						
						// if not success nake again (no token) - new -
						tokens--;
						updateTxt(tokensNRHave, tokens);
						/*var againTRY = setTimeout(checkSPINLength, 10000);
						function checkSPINLength() {
							forceQueryEnd = true;
							log('stop query');
						}
						function badSpin() {
							clearTimeout(againTRY);
							disconnect('Whoops! We cannot connect to the server...<br>Your token has been returned, let\'s spin again!', true);
							clearInterval(sp);
							if (tournamentPopup) {
								tokens++;
								refreshTokens();
								slo1.rot = slo2.rot = slo3.rot = slo4.rot = true;
								slo1.position.y -= Math.random()*mw*0.8;
								slo2.position.y -= Math.random()*mw*0.8;
								slo3.position.y -= Math.random()*mw*0.8;
								slo4.position.y -= Math.random()*mw*0.8;
								but2.enable();
								spinned = false;
								readyToSpin = true;
								rolling = false;
							}
						}*/
						function badSpin() {
							disconnect('Whoops! We cannot connect to the server...<br>Try again!', true);
							clearInterval(sp);
							if (tournamentPopup) {
								slo1.rot = slo2.rot = slo3.rot = slo4.rot = true;
								slo1.position.y -= Math.random()*mw*0.8;
								slo2.position.y -= Math.random()*mw*0.8;
								slo3.position.y -= Math.random()*mw*0.8;
								slo4.position.y -= Math.random()*mw*0.8;
								but2.enable();
								spinned = false;
								readyToSpin = true;
								rolling = false;
							}
						}
							
						serverSend('/api/tournament?action=spin', function(jo) {
							//clearTimeout(againTRY);
							jsonObject = jo;
							refreshTopData();
							storeLocalData(jo);
							refreshTokens();
							setTimeout(stopSpin, 2500);
							
						}, badSpin);
					}
					rolling = true;
				}
				


				function spinning() {
					if (slo1 && slo4) {
						if (slo1.rot) {
							slo1.position.y += 30;
							if (slo1.position.y > mas1.position.y) slo1.position.y = parseInt(mas1.position.y - slo1.height + mh);
						}
						if (slo2.rot) {
							slo2.position.y += 30;
							if (slo2.position.y > mas2.position.y) slo2.position.y = parseInt(mas2.position.y - slo2.height + mh);
						}
						if (slo3.rot) {
							slo3.position.y += 30;
							if (slo3.position.y > mas3.position.y) slo3.position.y = parseInt(mas3.position.y - slo3.height + mh);
						}
						if (slo4.rot) {
							slo4.position.y += 30;
							if (slo4.position.y > mas4.position.y) slo4.position.y = parseInt(mas4.position.y - slo4.height + mh);
						}
					}
				}
				function stopSpin() {
					// stop spinning
					// fps speed check to change render.
					switchCanvas();
					
					if (!tournamentPopup || !slo1 || !mas1) return;
					stopSpinning(slo1);
					slo1.position.y = mas1.position.y+mas1.height/2 - poz;
					setTimeout(function() {
						if (!tournamentPopup || !slo2 || !mas2) return;
						stopSpinning(slo2);
						slo2.position.y = mas2.position.y+mas2.height/2 - poz;
						setTimeout(function() {
							if (!tournamentPopup || !slo3 || !mas3) return;
							stopSpinning(slo3);
							slo3.position.y = mas3.position.y+mas3.height/2 - poz;
							
							// stop dragon spinning
							setTimeout(function() {
								if (!tournamentPopup || !slo4 || !mas4) return;
								stopSpinning(slo4);
								slo4.position.y = mas4.position.y+mas4.height/2 - poz4;
								
								mas1.width = mw*3.5;
								clearInterval(sp);
								
								screen.removeChild(but2);
								but2 = initBUT(xmlValue('spinAgain') + ' [token]1', tournamentLeft>0 ? 'blue' : 'disabled');
								but2.scale.set(0.7);
								centerBut(but2, parseInt(bg.width*0.22));
								but2.position.y = bg.height*0.33;
								but2.on('click', spinTournament).on('touchstart', spinTournament);
								spinBut = but2;
								
								screen.addChild(but2);
								but1.enable();
								spinned = true;
								but1.visible = true;
								readyToSpin = false; // reset thumb spin data when ready.
								setTimeout(function() {rolling = false; refreshTokens();}, 300);
								if (tokens==0 && tournamentLeft>900) videoADF(); 
								if (autoplaying) setTimeout(playTournament, 500);
							}, 500);
						}, 500);
					}, 500);
					function stopSpinning(clp) {
						if (tournamentPopup) {
							clp.rot = false;
							//clp.filters = null;
						}
					}
				}
			}
			
		}
	};
	
	function ping() {
		if (tournamentPing) clearTimeout(tournamentPing);
		tournamentPing = setTimeout(function () {
			if (tournamentPopup && tournamentPopup.quitting!=true && screen) {
				if (!offerPopup && !rolling && !tokensBoughtPopup && !moneyPopup && !loader) {
					serverSend('/api/tournament', refreshLeaderboard, ping);
				} else ping();
			} else ping();
		}, 30000);
	}
	
	
	
	// draw leaderboard (scores) and prizes
	var scoretableClips = [];
	tournamentPopup.refreshLB = function() {
		scoreCode = null; // force refresh
		scoretableClips = [];
		serverSend('/api/tournament', refreshLeaderboard, ping);
	};
	function refreshLeaderboard(jo) {
		ping();
		storeLocalData(jo);
		removeLoader();		
		if (!tournamentPopup || !screen || !jo.scores) return;
		else if (tuto || rolling && !autoplaying) return;

		scoreCode = jo.scoreCode;

		if (scoretableClips.length==0 && leaderboard || !leaderboard) {
			if (leaderboard) leaderboard.destroy();
			leaderboard = new PIXI.Container();
			leaderboard.scrollTouched = 0;
			leaderboard.position.x = parseInt(rightBg.position.x + rightBg.width*0.05);
			leaderboard.position.y = parseInt(rightBg.position.y + rightBg.height*0.066);
			screen.addChild(leaderboard);
			leaderboard.area = new PIXI.Graphics();
			leaderboard.area.beginFill(0xff0000, 0);
			leaderboard.area.drawRect(0, 0, rightBg.width*0.85, 10);
			leaderboard.area.endFill();
			leaderboard.addChild(leaderboard.area);
		}
		
		if (prizes) {
			prizes.destroy();
			prizes = new PIXI.Container();
			prizes.position.x = parseInt(leaderboard.position.x - rightBg.width*0.006);
			prizes.position.y = parseInt(rightBg.position.y + rightBg.height*0.6);
			screen.addChild(prizes);
		}
		if (prizesToGo) prizesToGo.destroy();
		// scores
		for (var z = 0; z<jo.scores.length; z++) {
			var nr = findIn(scoretableClips, 'uid', jo.scores[z].user_id);
			if (nr>=0) {
				// update and move existing row
				scoretableClips[nr].clp.position.y = bg.height*0.045 * z;
				updateTxt(scoretableClips[nr].clp.t_num, z+1);
				updateTxt(scoretableClips[nr].clp.t_score, jo.scores[z].points);
				scoretableClips[nr].clp.t_num.visible = jo.scores[z].points*1>0;
			} else {
				// add new row
				var r1 = addScoreRow(jo.scores[z], z==jo.myplace-1, z+1);
				r1.position.y = bg.height*0.045 * z;
				leaderboard.addChild(r1);
				scoretableClips.push({uid:jo.scores[z].user_id, clp:r1});
			}
		}
		function findIn(o, data,  val) {
			for (var n=0; n<o.length; n++) {
				if (o[n][data]==val) return n;
			}
			return -1;
		}
		// init scroll only first time when data over area.
		initScroll(screen, leaderboard, rightBg.width*0.8, rightBg.height*0.418, leaderboard.area);
		
		if (leaderboard.positionRuler) {
			//log('leaderboard.scrollTouched='+leaderboard.scrollTouched);
			if (leaderboard.scrollTouched==0) {
				// autoplace my place if no touched scroll
				if (jo.myplace>4) {
					leaderboard.positionRuler(-bg.height*0.05 * (jo.myplace - 3));
				}
			} else {
				// place to prev pos
				leaderboard.positionRuler(leaderboard.scrollTouched);
			}
		}
		
		// prizes area
		var myScore = jo.scores[jo.myplace-1].points*1;
		var myp = -1;
		if (jo.myplace==1) myp = 0;
		else if (jo.myplace==2) myp = 1;
		else if (jo.myplace==3) myp = 2;
		else if (jo.myplace<11) myp = 3;
		else if (jo.myplace<26) myp = 4;
		else if (jo.myplace<51) myp = 5;
		else if (jo.myplace<76) myp = 6;
	
		var meNr = 0, h = 0;
		for (var i = 0; i<jo.prizes.length; i++) {
			if (myp==i) meNr = i;
			else {
				var clp = addPrizeRow(jo.prizes[i], false);
				h = clp.height;
				clp.position.y = parseInt((h+0.5) * i);
				prizes.addChild(clp);
			}
		}
		var lastPrize = clp;
		var me;
		if (jo.myplace<76) {
			me = addPrizeRow(jo.prizes[meNr], true);
			me.position.y = parseInt((h+0.5) * meNr);
			me.position.x -= parseInt((me.width-clp.width)/2);
			me.position.y -= parseInt((me.height-clp.height)/2);
			prizes.addChild(me);
		}
	
		if (myp<0) myp=7;
		if (myp>0 && jsonObject.tournament.type=="B") {
			var prevPlace = 74;
			if (myp==1) prevPlace=0;
			else if (myp==2) prevPlace=1;
			else if (myp==3) prevPlace=2;
			else if (myp==4) prevPlace=9;
			else if (myp==5) prevPlace=24;
			else if (myp==6) prevPlace=49;
			
			// if I still have 0 points...
			var less = jo.scores.length<=prevPlace;
			if (myScore==0) {
				prevPlace = 74;
				if (jo.scores.length<=74) {prevPlace = jo.scores.length-1; less = true;}
			}
			
			//log('---------------------');
			//log('prevPlace='+prevPlace);
			
			// move UP until same score .
			for (var j=prevPlace; j>=0; j--) {
				if (jo.scores[j].points*1>myScore) break;
				prevPlace = j;
			}
			//log('prevPlace='+prevPlace);
			//log(prevPlace+'  have points  '+(jo.scores[prevPlace].points*1));
			
			var togoNr = 7;
			if (prevPlace+1==1) togoNr = 0;
			else if (prevPlace+1==2) togoNr = 1;
			else if (prevPlace+1==3) togoNr = 2;
			else if (prevPlace+1<11) togoNr = 3;
			else if (prevPlace+1<26) togoNr = 4;
			else if (prevPlace+1<51) togoNr = 5;
			else if (prevPlace+1<76) togoNr = 6;
			
			if (jo.myplace>1 && prevPlace>=0 && jo.scores.length>=prevPlace && tournamentLeft>900) {
				
				// show "to go" clip*********
				prizesToGo = new PIXI.Sprite();
				prizesToGo.anchor.y = 0.5;
				
				var bg1 = getAsset('to_go', bg.width*0.08);
				bg1.anchor.y = 0.5;
				prizesToGo.addChild(bg1);
				
				prizesToGo.position.y = (me ? me.position.y - me.height*0.92 : lastPrize.position.y) + prizes.position.y;
				// ericase - same pos if 0.
				if (myScore==0 && less) {
					prizesToGo.position.y = me.position.y + prizes.position.y;
				}
				prizesToGo.position.x = (me ? me.position.x : lastPrize.position.x) + prizes.position.x - bg1.width*0.6;
				
				var d = getAsset(tournament_type ? 'babyDragonIcon' : 'goldenDragonIcon', bg1.width*0.45);
				d.anchor.y = 0.5;
				d.position.x = bg1.width*0.3;
				d.position.y = -bg1.height*0.17;
				prizesToGo.addChild(d);
				
				// +2 yes or no??
				var t = createText(jo.scores[prevPlace].points*1 - myScore + 2, {fontSize:13, stroke:4, x:bg1.width/3.5, y:-bg1.height*0.2, width:bg1.width*0.7});
				prizesToGo.addChild(t);
				var t2 = createText('to go', {fontSize:10, x:bg1.width/2.3, y:bg1.height*0.16, width:bg1.width*0.7});
				prizesToGo.addChild(t2);
				
				screen.addChild(prizesToGo);
			}
		}
		
		function addScoreRow(obj, my, num) {
			var row = new PIXI.Sprite();
			var bg = getAsset('man_tournament', leaderboard.area.width+5);
			
			var face = new PIXI.Sprite();
			makeFaceURL(face, obj.pic, false, 0, 'noframe', bg.width*0.12);
			if (face) {
				face.scale.set(0.38);
				face.position.x = bg.width*0.062;
				face.position.y = bg.height/1.9;
				row.addChild(face);
			}
			
			row.addChild(bg);

			if (my) bg.tint = 0xff9933;
			
			row.t_num = createText(num, {fontSize:13, color:"yellow", bold:false, x:leaderboard.area.width*0.14, y:bg.height/2, width:leaderboard.area.width*0.1});
			row.t_num.anchor.x = 0;
			row.addChild(row.t_num);
			row.t_num.visible = obj.points*1>0;
			
			var ico = getAsset(tournament_type ? 'babyDragonIcon' : 'goldenDragonIcon', leaderboard.area.width*0.09);
			ico.position.x = parseInt(leaderboard.area.width*0.92);
			ico.position.y = 2;
			row.addChild(ico);
			
			var t_name = createText(obj.first_name + (obj.last_name=='' ? '' : ' '+obj.last_name.slice(0,1)+'.'), {font:"Arial", fontSize:14, x:row.t_num.position.x+row.t_num.width+2, y:bg.height/2, width:leaderboard.area.width*0.58, stroke:0, color:"brown"});
			t_name.anchor.x = 0;
			row.addChild(t_name);
			
			row.t_score = createText(obj.points, {fontSize:14, bold:false, color:obj.playing ? '#33ff00' : '#ffffff', x:leaderboard.area.width*0.91, y:bg.height/2, width:leaderboard.area.width*0.1});
			row.t_score.anchor.x = 1;
			row.addChild(row.t_score);
			
			row.h = bg.height;
			
			return row;
		}
		function addPrizeRow(obj, my) {
			var row = new PIXI.Container();
			row.position.x = leaderboard.area.width*0.02;
			
			var bg = getAsset('prize_tournament', leaderboard.area.width+5);
			bg.anchor.y = 0.5;
			bg.scale.y -= 0.1;
			if (my && myScore>0) {
				bg.tint = 0xff9933;
				bg.scale.x += 0.003;
				bg.scale.x += 0.09;
				
				var shadow = getAsset('prize_tournament', bg.width);
				shadow.anchor.y = 0.5;
				shadow.tint = 0x000000;
				shadow.alpha = 0.45;
				shadow.position.x = shadow.position.y = bg.height*0.1;
				row.addChild(shadow);
			}
			row.addChild(bg);
			
			var t_place = createText(obj.place, {fontSize:14, color:"brown", x:bg.width*0.05, y:0, width:bg.width*0.1});
			t_place.anchor.x = 0;
			row.addChild(t_place);
			
			var ico1 = getAsset('coin', bg.width*0.09);
			ico1.anchor.y = 0.5;
			ico1.position.x = bg.width*0.35;
			row.addChild(ico1);
			var t_1 = createText(obj.coins, {fontSize:14, x:ico1.position.x + ico1.width/3, y:0, width:bg.width*0.25});
			t_1.anchor.x = 1;
			row.addChild(t_1);
			
			var ico2 = getAsset('heart', bg.width*0.094);
			ico2.anchor.y = 0.5;
			ico2.position.x = bg.width*0.52;
			row.addChild(ico2);
			var t_2 = createText(obj.lives, {fontSize:14, x:ico2.position.x + ico2.width/3, y:0, width:bg.width*0.25});
			t_2.anchor.x = 1;
			row.addChild(t_2);
			
			if (obj.times) {
				var ico3 = getAsset('boosters_time', bg.width*0.09);
				ico3.anchor.y = 0.5;
				ico3.position.x = bg.width*0.69;
				row.addChild(ico3);
				var t_3 = createText(obj.times, {fontSize:14, x:ico3.position.x + ico3.width/3, y:0, width:bg.width*0.25});
				t_3.anchor.x = 1;
				row.addChild(t_3);
			}
			
			if (obj.boosts) {
				var ico4 = getAsset('boosters_highlight', bg.width*0.094);
				ico4.anchor.y = 0.5;
				ico4.position.x = bg.width*0.86;
				row.addChild(ico4);
				var t_4 = createText(obj.boosts, {fontSize:14, x:ico4.position.x + ico4.width/3, y:0, width:bg.width*0.25});
				t_4.anchor.x = 1;
				row.addChild(t_4);
			}
			return row;
		}
	}
	
	
	
	
	
	
	// C case: Tournament CLAIM
	
	tournamentPopup.drawCLAIM = function() {
		if (stopClip && stopClip.black) hideCloseClip();
		if (si) clearInterval(si);
		removeAllChilds(screen);
		drawRightArea();
		
		updateLabel(xmlValue('claimTournament')+' <yellow>'+convertToTime(tournamentLeft, true)+'</yellow>');
		
		serverSend('/api/tournament', function(jo) {
			
			jsonObject = jo;
			refreshTopData();
			removeLoader();
			refreshLeaderboard(jo);
			
			if (jsonObject.prizes) {
				
				var myplace = jsonObject.myplace;
				var claimed = jsonObject.claimed>0;
				var myscore = jsonObject.scores[myplace-1].points;
				var centerX = bg.width * 0.23;
				
				if (!claimed) {
					var bg3 = getAsset('achievement_bg_green', bg.width*0.52);
					bg3.height = bg.height * 0.23;
					bg3.anchor.x = bg3.anchor.y = 0.5;
					bg3.position.x = centerX;
					bg3.position.y = bg.height * 0.49;
					screen.addChild(bg3);
					
					if (myplace<76 && myscore>0) {
						
						var t_place = createText(xmlValue('tournamentPlace'), {fontSize:23, color:"brown", multiline:true, x:centerX, y:-bg.height*0.054, width:bg.width*0.3});
						screen.addChild(t_place);
						
						var ico = getAsset(tournament_type ? 'babyDragonIcon' : 'goldenDragonIcon', bg.width*0.294);
						ico.anchor.x = ico.anchor.y = 0.5;
						ico.position.x = centerX;
						ico.position.y = bg.height * 0.15;
						screen.addChild(ico);
						
						var myPlc = createText('#'+myplace, {fontSize:35, x:centerX, y:bg.height*0.266, width:bg.width*0.2});
						screen.addChild(myPlc);
						
						var pr = createText(xmlValue('tournPrize2'), {fontSize:24, color:'yellow', x:centerX, y:bg.height*0.38, width:bg.width*0.5});
						screen.addChild(pr);
						
					}
					
					// draw my prizes
					var myPrize, butTxt = xmlValue('claim');
					var p1,p2,p3,p4,t1,t2,t3,t4;
					
					if (myplace<4 && myscore>0) {
						if (myplace==1) myPrize = jsonObject.prizes[0];
						else if (myplace==2) myPrize = jsonObject.prizes[1];
						else if (myplace==3) myPrize = jsonObject.prizes[2];
						
						p1 = getAsset('coin', bg3.width*0.17);
						p1.anchor.x = p1.anchor.y = 0.5;
						p1.position.x = bg3.position.x - bg3.width*0.32;
						p1.position.y = bg3.position.y;
						screen.addChild(p1);
						t1 = createText(myPrize.coins+'x', {fontSize:18, x:p1.position.x, y:p1.position.y + p1.height/3, width:p1.width});
						t1.anchor.x = 0.5;
						screen.addChild(t1);
						
						p2 = getAsset('heart', bg3.width*0.18);
						p2.anchor.x = p2.anchor.y = 0.5;
						p2.position.x = bg3.position.x - bg3.width*0.11;
						p2.position.y = bg3.position.y;
						screen.addChild(p2);
						t2 = createText(myPrize.lives+'x', {fontSize:18, x:p2.position.x, y:p2.position.y + p2.height/3, width:p2.width});
						t2.anchor.x = 0.5;
						screen.addChild(t2);
						
						p3 = getAsset('boosters_time', bg3.width*0.19);
						p3.anchor.x = p3.anchor.y = 0.5;
						p3.position.x = bg3.position.x + bg3.width*0.11;
						p3.position.y = bg3.position.y;
						screen.addChild(p3);
						t3 = createText(myPrize.times+'x', {fontSize:18, x:p3.position.x, y:p3.position.y + p3.height/3, width:p3.width});
						t3.anchor.x = 0.5;
						screen.addChild(t3);
						
						p4 = getAsset('boosters_highlight', bg3.width*0.2);
						p4.anchor.x = p4.anchor.y = 0.5;
						p4.position.x = bg3.position.x + bg3.width*0.32;
						p4.position.y = bg3.position.y;
						screen.addChild(p4);
						t4 = createText(myPrize.boosts+'x', {fontSize:18, x:p4.position.x, y:p4.position.y + p4.height/3, width:p4.width});
						t4.anchor.x = 0.5;
						screen.addChild(t4);
					}
					else if (myplace<26 && myscore>0) {
						myPrize = myplace<11 ? jsonObject.prizes[3] : jsonObject.prizes[4];
						
						p1 = getAsset('coin', bg3.width*0.21);
						p1.anchor.x = p1.anchor.y = 0.5;
						p1.position.x = bg3.position.x - bg3.width*0.3;
						p1.position.y = bg3.position.y;
						screen.addChild(p1);
						t1 = createText(myPrize.coins+'x', {fontSize:18, x:p1.position.x, y:p1.position.y + p1.height/3, width:p1.width});
						t1.anchor.x = 0.5;
						screen.addChild(t1);
						
						p2 = getAsset('heart', bg3.width*0.2);
						p2.anchor.x = p2.anchor.y = 0.5;
						p2.position.x = bg3.position.x;
						p2.position.y = bg3.position.y;
						screen.addChild(p2);
						t2 = createText(myPrize.lives+'x', {fontSize:18, x:p2.position.x, y:p2.position.y + p2.height/3, width:p2.width});
						t2.anchor.x = 0.5;
						screen.addChild(t2);
						
						p3 = getAsset('boosters_time', bg3.width*0.21);
						p3.anchor.x = p3.anchor.y = 0.5;
						p3.position.x = bg3.position.x + bg3.width*0.3;
						p3.position.y = bg3.position.y;
						screen.addChild(p3);
						t3 = createText(myPrize.times+'x', {fontSize:18, x:p3.position.x, y:p3.position.y + p3.height/3, width:p3.width});
						t3.anchor.x = 0.5;
						screen.addChild(t3);
					}
					else if (myplace<76 && myscore>0) {
						myPrize = myplace<51 ? jsonObject.prizes[5] : jsonObject.prizes[6];
						
						p1 = getAsset('coin', bg3.width*0.21);
						p1.anchor.x = p1.anchor.y = 0.5;
						p1.position.x = bg3.position.x - bg3.width*0.25;
						p1.position.y = bg3.position.y;
						screen.addChild(p1);
						t1 = createText(myPrize.coins+'x', {fontSize:18, x:p1.position.x, y:p1.position.y + p1.height/3, width:p1.width});
						t1.anchor.x = 0.5;
						screen.addChild(t1);
						
						p2 = getAsset('heart', bg3.width*0.21);
						p2.anchor.x = p2.anchor.y = 0.5;
						p2.position.x = bg3.position.x + bg3.width*0.25;
						p2.position.y = bg3.position.y;
						screen.addChild(p2);
						t2 = createText(myPrize.lives+'x', {fontSize:18, x:p2.position.x, y:p2.position.y + p2.height/3, width:p2.width});
						t2.anchor.x = 0.5;
						screen.addChild(t2);
					}
					else {
						// 76 - 100 place - no prize
						bg3.visible = false;
						butTxt = xmlValue('ok');
						
						var tl = createText(xmlValue('loseTournamentClaim'), {fontSize:21, stroke:0, color:"brown", x:centerX, y:bg.height*0.55, width:bg.width*0.5, multiline:true});
						screen.addChild(tl);
						
						var dragon = getSheet('dragonFrown');
						makeSheet(dragon, bg.width*0.32, false, 0.5, centerX, bg.height*0.16);
						screen.addChild(dragon);
						claimTournamentShare = false;
						
					}
					var but1 = initBUT(butTxt, 'green');
					but1.on('click', claimTournament).on('touchstart', claimTournament);
					but1.position.y = bg.height * 0.74;
					but1.position.x = bg.width * 0.31;
					screen.addChild(but1);
					
					// sharing chb
					if (myPrize && myscore>0) {
						
						/*var sharing_chb = addSharing('sharingHighscores');
						sharing_chb.position.x = parseInt(but1.position.x + but1.w/2 - sharing_chb.width/2);
						sharing_chb.position.y = bg.height * 0.67;
						screen.addChild(sharing_chb);
						sharing_chb.checkbox.on('click', sharingChange).on('touchstart', sharingChange);
						function sharingChange() {
							claimTournamentShare = !claimTournamentShare;
							sharing_chb.checked.visible = claimTournamentShare;
						}*/
					}
					screen.visible = true;
					makeHint(exp1, xmlValue('tournamentExplainLeaderboard'), 'BL', stageW*0.3, 0, 0);
					makeHint(exp2, xmlValue('tournPrizeHint'), 'TR', stageW*0.2, 0, 0);
					
					
					
					function claimTournament() {
						but1.disable();
						if (!claimed) {
							addLoader();
							
							serverSend('/api/tournament?action=claim', function(jo) {
								removeLoader();
								jsonObject = jo;
								
								if (claimTournamentShare) ads(sharesObj.tournamentClaim);
								removeTournamentMap();
								// wait till popup gone
								setTimeout(function() {
									
									if (myPrize && myscore>0) {
										// add blink to money
										var blink = getSheet('tileExplose');
										makeSheet(blink, stageW*0.19, false, 0.5, stageW*0.12, stageH*0.05, 300, true);
										stage.addChild(blink);
									}
									jsonObject = jo;
									refreshTopData();
									offery();
								}, 350);
								
								
							}, removeTournamentMap);
							
						} else removeTournamentMap();
					}
					
					
					
				} else removeTournamentMap();
				
			} else removeTournamentMap();
			
		}, removeTournamentMap);
		
	};
	
	
	// buy tokens popup
	function drawTokens() {
		var pop = new PIXI.Container();
		pop.position.y = stageH*0.1;
	
		var bg = getAsset('popup_large', 'auto', stageH*0.8);
		pop.addChild(bg);
		pop.bg = bg;
		var centerX = parseInt(bg.width/2);
		
		var label = createText(xmlValue('buyTokensLabel'), {fontSize:25, x:centerX, y:bg.height/24, width:bg.width*0.55});
		pop.addChild(label);
		
		var closeBut = getAsset('closeBut', bg.width/16);
		closeBut.position.x = bg.width/1.06;
		closeBut.position.y = bg.height/18;
		closeBut.interactive = closeBut.buttonMode = true;
		closeBut.on('click', removeTokensPop).on('touchstart', removeTokensPop);
		function removeTokensPop() {
			tokensBoughtPopup = false;
			
			if (spinBut) spinBut.enable();
			if (playTBut && playTBut.visible && spinned) playTBut.enable();
			
			quitPopup(pop);
		}
		pop.addChild(closeBut);
		
		var tt = createText(xmlValue('getTokensTxt'), {fontSize:21, multiline:true, color:"brown", stroke:0, x:centerX, y:bg.height*0.23, width:bg.width*0.8});
		pop.addChild(tt);

		var but1 = initBUT(xmlValue('buyFor')+' [coin] '+prices.tokenPack1,'');
		var but2 = initBUT(xmlValue('buyFor')+' [coin] '+prices.tokenPack2,'');
		var but3 = initBUT(xmlValue('buyFor')+' [coin] '+prices.tokenPack3,'');
		setTimeout(function() {
			but1.on('click', buyTPack1).on('touchstart', buyTPack1);
			but2.on('click', buyTPack2).on('touchstart', buyTPack2);
			but3.on('click', buyTPack3).on('touchstart', buyTPack3);
		}, 300); // wait till animate
		but1.position.y = but2.position.y = but3.position.y = bg.height*0.77;
		pop.addChild(but1);
		pop.addChild(but2);
		pop.addChild(but3);
		
		var icon_bg1 = getAsset('tokenPack1', bg.width*0.25);
		var icon_bg2 = getAsset('tokenPack2', bg.width*0.25);
		var icon_bg3 = getAsset('tokenPack3', bg.width*0.25);
		icon_bg1.anchor.x = icon_bg2.anchor.x = icon_bg3.anchor.x = 0.5;
		icon_bg1.position.y = icon_bg2.position.y = icon_bg3.position.y = bg.height*0.38;
		
		icon_bg1.position.x = bg.width*0.22;
		icon_bg2.position.x = centerX;
		icon_bg3.position.x = bg.width*0.78;
		
		but1.scale.set(0.9);
		but2.scale.set(0.9);
		but3.scale.set(0.9);
		maxButWidth(but1, icon_bg1.width*1.05);
		maxButWidth(but2, icon_bg2.width*1.05);
		maxButWidth(but3, icon_bg3.width*1.05);
		centerBut(but1, icon_bg1.position.x*0.97);
		centerBut(but2, icon_bg2.position.x*0.97);
		centerBut(but3, icon_bg3.position.x*0.99);
		
		pop.addChild(icon_bg1);
		pop.addChild(icon_bg2);
		pop.addChild(icon_bg3);
		
		var fs = 37;
		var t1 = createText('1', {fontSize:fs, x:icon_bg1.position.x-icon_bg1.width*0.25, y:icon_bg1.position.y + icon_bg1.height*0.75});
		pop.addChild(t1);
		var t2 = createText('5', {fontSize:fs, x:icon_bg2.position.x-icon_bg2.width*0.25, y:t1.position.y});
		pop.addChild(t2);
		var t3 = createText('10', {fontSize:fs, x:icon_bg3.position.x-icon_bg3.width*0.25, y:t1.position.y});
		pop.addChild(t3);
		
		function buyTPack1() {
			buyTokens(1, prices.tokenPack1);	
		}
		function buyTPack2() {
			buyTokens(2, prices.tokenPack2);	
		}
		function buyTPack3() {
			buyTokens(3, prices.tokenPack3);	
		}
		function buyTokens(type, price) {
			but1.disable();
			but2.disable();
			but3.disable();
			tournamentPopup.tokenPopup = pop;
			tournamentPopup.tokenPopup.enableButs = function() {
				if (but1) {
					but1.enable();
					but2.enable();
					but3.enable();
				}
			};
			if (money>=price) addLoader();
			checkMoney(price, 'tokenPack'+type);
			tokensBoughtPopup = false;
			
		}
		animatePopup(pop);
		tokensBoughtPopup = true;
		if (autoplaying) {
			if (Math.random()<0.3) setTimeout(buyTPack2, 1000); else setTimeout(buyTPack1, 1000);
		}
	}
	
	
	// A case: Join Tournament
	if (tournamentData.type=='A') {
		
		//bg.texture = assets.resources['popup_large_shine'].texture;
		tournamentPopup.popupType = 'join';
		
		centerX -= screen.position.x;
		
		updateLabel(xmlValue('joinTournament'));
		
		var header = getAsset(tournament_type ? 'tournament_join_header' : 'tournament_join_header2', bg.width*0.8);
		header.anchor.x = header.anchor.y = 0.5;
		header.position.x = centerX ;
		header.position.y = bg.height*0.15;
		screen.addChild(header);
		
		var t1 = createText(xmlValue(tournament_type ? 'howManyBabyDragons' : 'howManyGoldenDragons'), {fontSize:22, color:'yellow', stroke:5, strokeColor:'#63485a', bold:false, x:centerX, y:header.position.y+header.height/2+40, width:bg.width*0.7});
		screen.addChild(t1);
		
		var t2 = createText(xmlValue(tournament_type ? 'joinTournamentDescription' : 'joinTournamentDescription2'), {fontSize:16, color:'white', strokeColor:'#63485a', bold:false, align:"center", multiline:true, x:centerX, y:t1.position.y+t1.height+45, width:bg.width*0.9});
		screen.addChild(t2);
		
		/*var dragon = getSheet('dragonHappy');
		makeSheet(dragon, bg.width*0.25, false, 0.5, bg.width*0.75, t2.position.y);
		screen.addChild(dragon);
			
		var badge = getAsset('blue_badge1', bg.height*0.35);
		badge.anchor.x = badge.anchor.y = 0.5;
		badge.position.x = -bg.width*0.018;
		badge.position.y = -bg.height*0.08;
		
		var tb = createText(xmlValue('everyoneWins'), {fontSize:26, x:badge.position.x, y:badge.position.y, multiline:true, width:badge.width*0.5, height:badge.height*0.5, autoResize:true});
		badge.rotation = tb.rotation = -10 * Math.PI/180;
		screen.addChild(badge);
		screen.addChild(tb);

		var ico1 = getAsset('coin', bg.width*0.13);
		ico1.anchor.x = ico1.anchor.y = 0.5;
		ico1.position.x = centerX - bg.width*0.35 + bg.width*0.04;
		ico1.position.y = bg.height*0.192;
		screen.addChild(ico1);
		var t_ico1 = createText('100x', {fontSize:34, x:ico1.position.x - ico1.width/2, y:ico1.position.y + ico1.height/3, width:ico1.width*1.2});
		screen.addChild(t_ico1);
		
		var ico2 = getAsset('heart', bg.width*0.13);
		ico2.anchor.x = ico2.anchor.y = 0.5;
		ico2.position.x = centerX - bg.width*0.17 + bg.width*0.04;
		ico2.position.y = ico1.position.y;
		screen.addChild(ico2);
		var t_ico2 = createText('10x', {fontSize:34, x:ico2.position.x - ico2.width/2, y:ico2.position.y + ico2.height/3, width:ico2.width});
		screen.addChild(t_ico2);
		
		var ico3 = getAsset('boosters_time', bg.width*0.13);
		ico3.anchor.x = ico3.anchor.y = 0.5;
		ico3.position.x = centerX + bg.width*0.04;
		ico3.position.y = ico1.position.y;
		screen.addChild(ico3);
		var t_ico3 = createText('5x', {fontSize:34, x:ico3.position.x - ico3.width/2, y:ico3.position.y + ico3.height/3, width:ico3.width});
		screen.addChild(t_ico3);
		
		var ico4 = getAsset('boosters_highlight', bg.width*0.13);
		ico4.anchor.x = ico4.anchor.y = 0.5;
		ico4.position.x = centerX + bg.width*0.17 + bg.width*0.04;
		ico4.position.y = ico1.position.y;
		screen.addChild(ico4);
		var t_ico4 = createText('3x', {fontSize:34, x:ico4.position.x - ico4.width/2, y:ico4.position.y + ico4.height/3, width:ico4.width});
		screen.addChild(t_ico4);
		
		var ico5 = getAsset('boxTournament', bg.width*0.13);
		ico5.anchor.x = ico5.anchor.y = 0.5;
		ico5.position.x = centerX + bg.width*0.32 + bg.width*0.04;
		ico5.position.y = ico1.position.y;
		screen.addChild(ico5);
		var t_ico5 = createText('5x', {fontSize:34, x:ico5.position.x - ico5.width*0.4, y:ico5.position.y + ico5.height/3, width:ico5.width});
		screen.addChild(t_ico5);*/
		
		var joinBG = getAsset('tournament_bottom_bar', bg.width*0.88);
		joinBG.height = bg.height*0.16;
		joinBG.anchor.x = joinBG.anchor.y = 0.5;
		joinBG.position.x = centerX;
		joinBG.position.y = bg.height*0.78;
		screen.addChild(joinBG);

		analytics('/api/analytics?code=' + (fromFirstPopups==true ? 'openJoin' : 'openJoinMap'));

		var but = initBUT('      ' + xmlValue('join') + '      ', 'green');
		but.position.x = centerX + joinBG.width/2 - but.w - 35;
		but.position.y = joinBG.position.y - but.h/2;
		screen.addChild(but);
		but.on('click', joinTournament).on('touchstart', joinTournament);
		
		// sharing chb
		/*var sharing_chb = addSharing('sharingHighscores');
		sharing_chb.position.x = parseInt(but.position.x + but.w/2 - sharing_chb.width/2);
		sharing_chb.position.y = parseInt(but.position.y + but.h*1.7);
		screen.addChild(sharing_chb);
		sharing_chb.checkbox.on('click', sharingChange).on('touchstart', sharingChange);
		function sharingChange() {
			joinTournamentShare = !joinTournamentShare;
			sharing_chb.checked.visible = joinTournamentShare;
		}*/
		function joinTournament() {
			but.disable();
			if (joinTournamentShare) ads(sharesObj.tournamentJoing);
			
			// send join tournament query
			serverSend('/api/tournament?action=join', tournamentPopup.drawPLAY, removeTournamentMap);
		}
		tournamentPopup.joinAction = joinTournament;
		
		tournamentPopup.timeLeftTxt = createText(xmlValue('timeleft2'), {fontSize:21, color:"white", bold:false, x:centerX-joinBG.width/2+80, y:joinBG.position.y, width:joinBG.width - but.w});
		screen.addChild(tournamentPopup.timeLeftTxt);
		
		tournamentPopup.joinTimerTxt = createText(' ', {fontSize:21, color:"yellow", bold:false, x:tournamentPopup.timeLeftTxt.position.x+tournamentPopup.timeLeftTxt.width+40, y:joinBG.position.y, width:joinBG.width - but.w});
		screen.addChild(tournamentPopup.joinTimerTxt);
		
		var stars = getSheet('starsExplose');
		makeSheet(stars, bg.width*0.22, false, 0.5, but.position.x + but.w*0.85, but.position.y + but.h/2, 1000, true);
		screen.addChild(stars);
		setTimeout(removeLoader, 300);
		screen.visible = true;

		if (autoplaying) setTimeout(joinTournament, 1000);
		
	} else if (tournamentData.type=='B') tournamentPopup.drawPLAY(jsonTournamentDONE);
	else if (tournamentData.type=='C') tournamentPopup.drawCLAIM();
		
		

	animatePopup(tournamentPopup);
	addLoader();
	if (autoplayBut) {stage.removeChild(autoplayBut); placeAutoplay();}
}


// double dragond popup
var doubleDragonsPopup;
function addDoubleDragonsPopup() {
	doubleDragons = false;
	doubleDragonsPopup = new PIXI.Container();
	doubleDragonsPopup.position.y = stageH*0.15;
	
	var bg = getAsset(tournament_type ? 'popup_pink_small' : 'popup_blue_small', 'auto', stageH*0.7);
	doubleDragonsPopup.addChild(bg);
	doubleDragonsPopup.bg = bg;
	var centerX = parseInt(bg.width/2);
	
	var label = createText(xmlValue('doubleDragonsLabel'), {fontSize:23, x:centerX, y:bg.height/12, width:bg.width/3});
	doubleDragonsPopup.addChild(label);
	
	var glow = getAsset('glow', bg.width*1.1);
	glow.anchor.x = glow.anchor.y = 0.5;
	glow.position.x = centerX;
	glow.position.y = bg.height*0.36;
	doubleDragonsPopup.addChild(glow);
	var si = setInterval(function() {
		glow.rotation += 0.009;
	}, 30);
	
	var ico = getAsset(tournament_type ? 'DoubleBabyDragon' : 'DoubleDragon', bg.width*0.6);
	ico.anchor = glow.anchor;
	ico.position = glow.position;
	doubleDragonsPopup.addChild(ico);
	
	var t;
	if (doubleDragonsAmount>0) {
		var badge = getAsset('wheel_badge', ico.width*0.25);
		badge.anchor = ico.anchor;
		badge.position = {x:centerX + ico.width*0.37, y:ico.position.y + ico.height*0.35};
		doubleDragonsPopup.addChild(badge);
		var ddt = createText(doubleDragonsAmount, {fontSize:18, x:badge.position.x, y:badge.position.y, width:badge.width*0.9});
		doubleDragonsPopup.addChild(ddt);
		t = createText(xmlValue('doubleDragonsDescriptionFree').replace('[doubleDragons]', doubleDragonsAmount), {fontSize:18, color:'yellow', shadow:false, x:centerX, y:bg.height * 0.63, multiline:true, width:bg.width*0.62});
		doubleDragonsPopup.but = initBUT(xmlValue('doubleDragonsBut'), 'green');
		doubleDragonsPopup.addChild(t);
	} else {
		t = createText(xmlValue('doubletiles').replace('[tr_type]', tr_type), {fontSize:20, color:'yellow', shadow:false, bold:false, x:centerX, y:bg.height * 0.65, multiline:true, width:bg.width*0.56, lineHeight:24});
		t2 = createText(xmlValue('collectrank'), {fontSize:17, lineHeight:20, color:'white', shadow:false, bold:false, x:centerX, y:bg.height * 0.79, multiline:true, width:bg.width*0.56});
		doubleDragonsPopup.but = initBUT('Double for '+prices.doubleDragons+' [coin]', 'green');
		doubleDragonsPopup.addChild(t);
		doubleDragonsPopup.addChild(t2);
	}
	
	var closeBut = getAsset('closeBut', bg.width/11);
	closeBut.position.x = bg.width*0.84;
	closeBut.position.y = bg.height*0.07;
	closeBut.interactive = closeBut.buttonMode = true;
	closeBut.visible = true;
	doubleDragonsPopup.closeBut = closeBut;
	doubleDragonsPopup.addChild(closeBut);
	doubleDragonsPopup.removeDD = function () {
		if (doubleDragonsPopup) {
			closeBut.interactive = closeBut.buttonMode = false;
			doubleDragonsPopup.but.disable();
			clearInterval(si);
			quitPopup(doubleDragonsPopup);
			startPlay();
		}
	};
	closeBut.on('click', doubleDragonsPopup.removeDD).on('touchstart', doubleDragonsPopup.removeDD);
	
	doubleDragonsPopup.but.disable();
	centerBut(doubleDragonsPopup.but, centerX);
	doubleDragonsPopup.but.position.y = bg.height*0.89;
	doubleDragonsPopup.addChild(doubleDragonsPopup.but);
	doubleDragonsPopup.but.on('click', makeDD).on('touchstart', makeDD);
	
	function makeDD() {
		if (doubleDragonsPopup) {
			closeBut.interactive = closeBut.buttonMode = false;
			doubleDragonsPopup.but.disable();
			if (doubleDragonsAmount>0) {
				doubleDragons = true;
				doubleCounter++;
				dragonCount = dragonCount*2;
				if (elements) updateTxt(elements.t_dr, '0 / '+(dragonCount*2));
				doubleDragonsPopup.removeDD();
			} else checkMoney(prices.doubleDragons, 'doubleDragons');
		}
	}
	doubleDragonsPopup.butAction = makeDD;
	animatePopup(doubleDragonsPopup);
	if (autoplaying) setTimeout(function() {
		if (autoplaying) {
			if (Math.random()<0.94) makeDD(); else doubleDragonsPopup.removeDD();
		}
	}, 700);
	
	var isVideoWatched = false;
	
	//log(videoAdEnable['doubleDragons']+' && '+doubleDragonsAmount+'==0 && ('+myData.pgroup+'==false || '+myData.pgroup+'==true && '+money+'>10) && '+(tournamentCounter+1)+'%5==0 && '+tournamentCounter+'>0 && '+tournamentLeft+'>900');
	
	if (videoAdEnable['doubleDragons']==true && doubleDragonsAmount==0 && (myData.pgroup==false || (myData.pgroup==true && money>10) || storedVars.forceLSM*1==1) && (tournamentCounter+1)%5==0 && tournamentCounter>0 && tournamentLeft>900) {
		
		// check have video ads...
		lsmAd(
			function (ad) { videoAd = ad; log(ad); if (videoAd) addVideoButton(); }, 
			videoWatched,
			videoEnd
		);
		
		function askDoubleVideo() {
			numlog('lsm_double_acceptAD');
			lsmAdShow(videoAd);
		}
		function videoWatched() {
			isVideoWatched = true;
			playTimesToShowLivesVideo = 0;
			videoAd = null;
		}
		function videoEnd() {
			if (isVideoWatched) {
				numlog('lsm_double_claim');
				gflog('LSM double');
				lsmStartlevelDATA = '&lsmDouble=1';
				closeBut.interactive = closeBut.buttonMode = false;
				doubleDragonsPopup.but.disable();
				setTimeout(doubledByVideo, 330);
			} else {
				numlog('lsm_double_cancelAD');
				doubleDragonsPopup.removeDD();
			}
		}
		function doubledByVideo() {
			log('doubled by video');
			doubleDragons = true;
			doubleCounter++;
			dragonCount = dragonCount*2;
			if (elements) updateTxt(elements.t_dr, '0 / '+dragonCount);
			doubleDragonsPopup.removeDD();
		}
		function addVideoButton() {
			// only one life left...
			
			var videoAdIcon = getAsset('videoTV', bg.width*0.15);
			videoAdIcon.anchor.x = videoAdIcon.anchor.y = 0.5;
			videoAdIcon.rotation = -Math.PI/180*8;
			var dblAdsBut = initBUT('          '+xmlValue('doubleAdsBut'), '');
			dblAdsBut.scale.set(0.71);
			dblAdsBut.interactive = dblAdsBut.buttonMode = true;
			doubleDragonsPopup.but.position.y = bg.height*0.695;
			dblAdsBut.position.y = bg.height * 0.84;
			centerBut(dblAdsBut, centerX - bg.width*0.009);
			videoAdIcon.position = {x:dblAdsBut.position.x + dblAdsBut.h*0.36 * 0.71,   y:dblAdsBut.position.y + dblAdsBut.h*0.71*0.35};
			doubleDragonsPopup.addChild(dblAdsBut);
			doubleDragonsPopup.addChild(videoAdIcon);
			
			doubleDragonsPopup.blinkingIcon = videoAdIcon;
			blinkIcon2('doubleDragonsPopup');
			
			numlog('lsm_double_showAD');
			dblAdsBut.on('click', askDoubleVideo).on('touchstart', askDoubleVideo);
		}
		
	}
	tournamentCounter++;
	
	
	function stopBlinkingVideoIcon() {
		doubleDragonsPopup.blinkingIcon = null;
	}
}

// finished tournament
function tournamentLevelDone(arg) {
	autoCollect = false;
	clockStop();
	
	doubleDragonsPopup = new PIXI.Container();
	doubleDragonsPopup.position.y = stageH*0.15;
		
	var bg = getAsset(tournament_type ? 'popup_pink_small' : 'popup_blue_small', 'auto', stageH*0.7);
	doubleDragonsPopup.addChild(bg);
	doubleDragonsPopup.bg = bg;
	var centerX = parseInt(bg.width/2);
		
	var levelCase = tournament_try100percent && turns3*2==totalTiles3 && turns3>0 ? 'perfect' : 'normal';
	
	var label = createText(xmlValue(levelCase == 'perfect' ? 'challengeLevelLabelPerfect' : 'challengeLevelLabel'), {fontSize:23, x:centerX, y:bg.height/12, width:bg.width/3});
	doubleDragonsPopup.addChild(label);
		
	var glow = getAsset('glow', bg.width*0.8);
	glow.anchor.x = glow.anchor.y = 0.5;
	glow.position.x = centerX;
	glow.position.y = bg.height*0.36;
	doubleDragonsPopup.addChild(glow);
	var si = setInterval(function() {
		glow.rotation += 0.009;
	}, 30);
		
	var ico = getAsset(tournament_type ? 'babyDragonIcon' : 'goldenDragonIcon', bg.width*0.4);
	ico.anchor = glow.anchor;
	ico.position = glow.position;
	doubleDragonsPopup.addChild(ico);	
	
	var txt2 = xmlValue(levelCase == 'perfect' ? (tournament_type ? 'dragonsCollectedPerfect2' : 'dragonsCollectedPerfect') : (tournament_type ? 'dragonsCollectedLabel2' : 'dragonsCollectedLabel'));
	if (tournamentLeft<=0) txt2 = xmlValue(tournament_type ? 'dragonsCollectedLabelEND2' : 'dragonsCollectedLabelEND');
	if (levelCase == 'perfect') txt2 = txt2.replace('<br><br>', '\n\n').replace('<br>', '\n');
	var t = createText(txt2.replace('[number]', friendTilePairsCollected*2), {fontSize:21, color:'yellow', bold:false, shadow:false, x:centerX, y:bg.height*0.62, multiline:true, width:bg.width*0.71});
	doubleDragonsPopup.addChild(t);
	
	if (levelCase == 'perfect') {
		var t2 = createText(xmlValue('claimfreetoken'), {fontSize:19, color:'white', bold:false, shadow:false, x:centerX, y:bg.height*0.78, multiline:true, width:bg.width*0.71});
		doubleDragonsPopup.addChild(t2);
	}
	
	var but = initBUT(levelCase == 'perfect' ? xmlValue('claim')+' 1 [token]' : xmlValue('close'), 'green');
	but.scale.set(1.1);
	centerBut(but, centerX);
	but.position.y = bg.height*0.88;
	doubleDragonsPopup.addChild(but);
	but.disable();
	setTimeout(function() {	but.enable(); }, 900);

	but.on('click', endTornamentLevel).on('touchend', endTornamentLevel);
	if (autoplaying) setTimeout(endTornamentLevel, 1500);
	
	function endTornamentLevel() {
		tournament_try100percent = false;
		but.disable();
		
		levelComplete();

		addLoader();
		makeNextLevel = false;

		// store for anime.
		myXPwas = jsonObject.experience;
		money = money;
		
		serverSend('/api/settournament?id='+selectedLevel+'&playlog_id='+playLog+'&dragonsCollected='+(friendTilePairsCollected*2)+'&points='+levelScore+'&dragonsTotal='+dragonCount+'&timeLeft='+levelTime+'&doubleDragons='+(doubleDragons ? 1 : 0)+'&completePercent='+(turns3*200/totalTiles3)+'&shuffles='+shufflesInGame+'&time='+completedTimes.join(','), function(jo) {
			removeLoader();
			playTimesToShowTokenVideo++;
			jsonObject = jo;
			jsonTournamentDONE = jo;
			tournamentGifts = jo.tournamentGifts || [];
			refreshTopData();
			
			if (tournamentNextSpinData) {
				tournamentNextSpinData.tokens = jo.tokens;
				tournamentNextSpinData.tokentime = jo.tokentime;
			}
			
			playLog = '';
			
			quitPopup(doubleDragonsPopup);
			resetLevel();
			removeAllChilds(elements);
			refreshTopData();
			openTournament();
			askedRepeatPopup = false;
		
		}, function(error) {
			disconnect('Server not responsing. Please refresh page.', true, error);
			goMAP();
		});
	}
	animatePopup(doubleDragonsPopup);
}

// level 3/3 - get all dragons, not all tiles
function tournamentPlayOnPopup() {
	doubleDragonsPopup = new PIXI.Container();
	doubleDragonsPopup.position.y = stageH*0.15;
		
	var bg = getAsset(tournament_type ? 'popup_pink_small' : 'popup_blue_small', 'auto', stageH*0.7);
	doubleDragonsPopup.addChild(bg);
	doubleDragonsPopup.bg = bg;
	var centerX = parseInt(bg.width/2);
	var label = createText(xmlValue('challengeLevelLabel'), {fontSize:23, x:centerX, y:bg.height/12, width:bg.width/3});
	doubleDragonsPopup.addChild(label);
		
	var glow = getAsset('glow', bg.width*0.8);
	glow.anchor.x = glow.anchor.y = 0.5;
	glow.position.x = centerX;
	glow.position.y = bg.height*0.36;
	doubleDragonsPopup.addChild(glow);
	var si = setInterval(function() {
		glow.rotation += 0.009;
	}, 30);
		
	var ico = getAsset(tournament_type ? 'babyDragonIcon' : 'goldenDragonIcon', bg.width*0.4);
	ico.anchor = glow.anchor;
	ico.position = glow.position;
	doubleDragonsPopup.addChild(ico);
	
	var t0txt = xmlValue(tournament_type ? dragonsCollectedLabel2 : dragonsCollectedLabel);
	var t0 = createText(t0txt.replace('[number]', friendTilePairsCollected*2), {fontSize:21, color:'yellow', bold:false, shadow:false, x:centerX, y:bg.height * 0.62, multiline:true, width:bg.width*0.71});
	doubleDragonsPopup.addChild(t0);
	
	var t = createText(xmlValue('timesupDescriptionTournament'), {fontSize:19, color:'white', bold:false, shadow:false, x:centerX, y:bg.height * 0.78, multiline:true, width:bg.width*0.71});
	doubleDragonsPopup.addChild(t);
	
	var but = initBUT(xmlValue('playon') + ' +1 [token]', 'green');
	var but2 = initBUT('[tokenBroken]  ' + xmlValue('giveUp'), 'blue');
	but.on('click', continueTornamentLevel).on('touchend', continueTornamentLevel);
	but2.on('click', endTornamentLevel).on('touchend', endTornamentLevel);
	centerBut(but, centerX);
	but2.scale.set(0.76);
	centerBut(but2, centerX);
	but.position.y = bg.height*0.89;
	but2.position.y =  but.position.y + but.h*1.5;
	doubleDragonsPopup.addChild(but);
	doubleDragonsPopup.addChild(but2);
	
	askedRepeatPopup = true;
	
	but.disable(); but2.disable();
	setTimeout(function() {
		but.enable(); but2.enable(); 
		if (autoplaying) setTimeout(endTornamentLevel, 400);
	}, 900);
	
	function continueTornamentLevel() {
		but.disable();
		but2.disable();
		quitPopup(doubleDragonsPopup);
		if (!havePair()) shuffle();
		bl.visible = br.visible = true;
		repeatClock();
		if (autoplaying) autoCollect=true;
		if (autoCollect) nextAutoCollect();
	}
	function endTornamentLevel() {
		tournament_try100percent = false;
		if (but) but.disable();
		if (but2) but2.disable();
		
		levelComplete();

		addLoader();
		makeNextLevel = false;

		// store for anime.
		myXPwas = jsonObject.experience;
		money = money;
		
		serverSend('/api/settournament?id='+selectedLevel+'&playlog_id='+playLog+'&dragonsCollected='+(friendTilePairsCollected*2)+'&points='+levelScore+'&dragonsTotal='+dragonCount+'&timeLeft='+levelTime+'&doubleDragons='+(doubleDragons ? 1 : 0)+'&completePercent='+(turns3*200/totalTiles3)+'&shuffles='+shufflesInGame+'&time='+completedTimes.join(','), function(jo) {
			removeLoader();
			playTimesToShowTokenVideo++;
			jsonObject = jo;
			jsonTournamentDONE = jo;
			tournamentGifts = jo.tournamentGifts || [];
			refreshTopData();
			playLog = '';
			
			if (tournamentNextSpinData) {
				tournamentNextSpinData.tokens = jo.tokens;
				tournamentNextSpinData.tokentime = jo.tokentime;
			}
			
			quitPopup(doubleDragonsPopup);
			resetLevel();
			elements.destroy();
			openTournament();
		
		}, function(error) {
			disconnect('Server not responsing. Please refresh page.', true, error);
			goMap();
		});
	}
	animatePopup(doubleDragonsPopup);
}



function updateLabel(txt) {
	if (tournamentPopup.label) {
		txt = txt.replace('</yellow>','').split('<yellow>');
		updateTxt(tournamentPopup.label, txt[0] || '');
		updateTxt(tournamentPopup.label2, txt[1] || '');
		
		var w = tournamentPopup.label.width + tournamentPopup.label2.width;
		tournamentPopup.label.position.x = tournamentPopup.label2.position.x = tournamentPopup.bg.width/2 - w/2 + tournamentPopup.label.width;
	}
}
function tournamentStartsSoon() {
	tournamentPopup = new PIXI.Container();
	tournamentPopup.position.y = stageH*0.07;
	
	var bg = getAsset('popup_small', 'auto', stageH*0.84);
	tournamentPopup.addChild(bg);
	tournamentPopup.bg = bg;
	
	var centerX = parseInt(bg.width/2);
	var label = createText(xmlValue('tournStartsInLabel'), {fontSize:23, x:centerX, y:bg.height*0.084, width:bg.width*0.7, autoResize:true});
	tournamentPopup.addChild(label);
	
	var closeBut = getAsset('closeBut', bg.width/11);
	closeBut.position.x = bg.width*0.84;
	closeBut.position.y = bg.height*0.085;
	closeBut.interactive = closeBut.buttonMode = true;
	closeBut.on('click', removeTournamentIntro).on('touchstart', removeTournamentIntro);
	function removeTournamentIntro() {
		quitPopup(tournamentPopup);
	}
	tournamentPopup.addChild(closeBut);
	
	tournamentPopup.removeingData = function() {
		tournamentPopup.destroy();
		tournamentPopup = null;
	};
	
	var tim1 = createText(xmlValue('offerTimer'), {fontSize:20, strokeColor:"#773501", x:centerX, color:"yellow", y:bg.height*0.18, width:bg.width*0.8, autoResize:true});
	tournamentPopup.addChild(tim1);
	tournamentPopup.tim2 = createText(convertToTime(tournamentData.wTimeLeft, true), {fontSize:22, strokeColor:"#984210", x:centerX, color:"white", y:bg.height*0.24, width:bg.width*0.8, autoResize:true});
	tournamentPopup.addChild(tournamentPopup.tim2);
	
	var ico = getAsset('karikas', bg.width*0.4);
	ico.anchor.x = ico.anchor.y = 0.5;
	ico.position.x = centerX;
	ico.position.y = bg.height * 0.465;
	tournamentPopup.addChild(ico);
	
	var label2 = createText(xmlValue('chanceToWin'), {fontSize:26, x:centerX, color:"yellow", strokeColor:"#ff7200", y:bg.height*0.7, width:bg.width*0.8, autoResize:true});
	tournamentPopup.addChild(label2);
	
	var ico1 = getAsset('coin', bg.width*0.13);
	ico1.anchor.x = ico1.anchor.y = 0.5;
	ico1.position.x = centerX - bg.width*0.26;
	ico1.position.y = bg.height*0.82;
	tournamentPopup.addChild(ico1);
	var t_ico1 = createText('100x', {fontSize:19, strokeColor:"#804a22", x:ico1.position.x - ico1.width/3, y:ico1.position.y + ico1.height/3, width:ico1.width*1.2});
	tournamentPopup.addChild(t_ico1);
	
	var ico2 = getAsset('heart', bg.width*0.13);
	ico2.anchor.x = ico2.anchor.y = 0.5;
	ico2.position.x = centerX - bg.width*0.124;
	ico2.position.y = ico1.position.y;
	tournamentPopup.addChild(ico2);
	var t_ico2 = createText('10x', {fontSize:19, strokeColor:"#804a22", x:ico2.position.x - ico2.width/3, y:ico2.position.y + ico2.height/3, width:ico2.width});
	tournamentPopup.addChild(t_ico2);
	
	var ico3 = getAsset('boosters_time', bg.width*0.13);
	ico3.anchor.x = ico3.anchor.y = 0.5;
	ico3.position.x = centerX + bg.width*0.02;
	ico3.position.y = ico1.position.y;
	tournamentPopup.addChild(ico3);
	var t_ico3 = createText('10x', {fontSize:19, strokeColor:"#804a22", x:ico3.position.x - ico3.width/3, y:ico3.position.y + ico3.height/3, width:ico3.width});
	tournamentPopup.addChild(t_ico3);
	
	var ico4 = getAsset('boosters_highlight', bg.width*0.13);
	ico4.anchor.x = ico4.anchor.y = 0.5;
	ico4.position.x = centerX + bg.width*0.155;
	ico4.position.y = ico1.position.y;
	tournamentPopup.addChild(ico4);
	var t_ico4 = createText('3x', {fontSize:19, strokeColor:"#804a22", x:ico4.position.x - ico4.width/3, y:ico4.position.y + ico4.height/3, width:ico4.width});
	tournamentPopup.addChild(t_ico4);
	
	var ico5 = getAsset('boxTournament', bg.width*0.13);
	ico5.anchor.x = ico5.anchor.y = 0.5;
	ico5.position.x = centerX + bg.width*0.285;
	ico5.position.y = ico1.position.y;
	tournamentPopup.addChild(ico5);
	var t_ico4 = createText('5x', {fontSize:19, strokeColor:"#804a22", x:ico5.position.x - ico5.width/3, y:ico5.position.y + ico5.height/3, width:ico5.width});
	tournamentPopup.addChild(t_ico4);
	
	animatePopup(tournamentPopup);
}

// repeat tournament
var tournRepeatBut,tournTilesCollectTxt,dragonCnt,thisLevDragons;
function placeTournRepeatButton() {
	removeTournRepeatButton();
	thisLevDragons = 0;
	var txt = xmlValue('tournTimeBonus');
	tournTilesCollectTxt = createText(txt.replace('[time]', 0), {fontSize:16, x:0, y:stageH*0.95, width:500});
	tournTilesCollectTxt.anchor.x = 0;
	tournRepeatBut = initBUT(xmlValue('tournRepeat'), '');
	tournRepeatBut.scale.set(0.7);
	tournRepeatBut.position = {x:0, y:stageH*0.95 - tournRepeatBut.h/2.5*0.7};
	tournRepeatBut.on('click', proceedTournament).on('touchend', proceedTournament);
	tournRepeatBut.disable();
	var w = tournTilesCollectTxt.width + 20 + tournRepeatBut.w*tournRepeatBut.scale.x;
	tournTilesCollectTxt.position.x = stageW/2 - w/2;
	tournRepeatBut.position.x = tournTilesCollectTxt.position.x + tournTilesCollectTxt.width + 20;
	GAME.addChild(tournTilesCollectTxt);
	GAME.addChild(tournRepeatBut);
	tournRepeatBut.visible = tournament_try100percent;
}
function proceedTournament() {
	tournament_try100percent = false;
	if (tournRepeatBut) tournRepeatBut.visible = false;
	if (tournTilesCollectTxt) tournTilesCollectTxt.position.x = stageW/2 - tournTilesCollectTxt.width/2;
	if (fields.length>0) addTime201(turns*2); else endLevel();
}
function removeTournRepeatButton() {
	if (tournRepeatBut) {
		tournRepeatBut.destroy();
		tournRepeatBut = null;
		tournTilesCollectTxt.destroy();
		tournTilesCollectTxt = null;
	}
}
function tournamentSkipLevTutorialF() {
	tournamentPopup = new PIXI.Container();
	tournamentPopup.position.y = stageH*0.07;
	
	var bg = getAsset('popup_small', 'auto', stageH*0.84);
	tournamentPopup.addChild(bg);
	tournamentPopup.bg = bg;
	
	var centerX = parseInt(bg.width/2);
	var label = createText(xmlValue('tournSkipLevTutorialLabel'), {fontSize:23, x:centerX, y:bg.height*0.084, width:bg.width*0.7, autoResize:true});
	tournamentPopup.addChild(label);
	
	var closeBut = getAsset('closeBut', bg.width/11);
	closeBut.position.x = bg.width*0.84;
	closeBut.position.y = bg.height*0.085;
	closeBut.interactive = closeBut.buttonMode = true;
	closeBut.on('click', removeTournamentTuto).on('touchend', removeTournamentTuto);
	function removeTournamentTuto() {
		quitPopup(tournamentPopup);
	}
	tournamentPopup.removeingData = function() {
		tournamentPopup.destroy();
		tournamentPopup = null;
	};
	tournamentPopup.addChild(closeBut);
	
	var ico = getAsset(jsonObject.tournament.ttype ? 'babyDragonIcon' : 'goldenDragonIcon', 'auto', bg.height*0.25);
	ico.anchor.x = ico.anchor.y = 0.5;
	ico.position.x = centerX;
	ico.position.y = bg.height*0.29;
	tournamentPopup.addChild(ico);
	
	var tt = xmlValue('tournSkipLevTutorialtext');
	var txt = createText(tt.replace('<br>','\n').replace('\"','"'), {fontSize:16, color:"brown", multiline:true, stroke:0, x:centerX, y:bg.height*0.54, width:bg.width*0.63, height:bg.height*0.66, autoResize:true});
	tournamentPopup.addChild(txt);
	
	var but = initBUT(xmlValue('close'), '');
	centerBut(but, centerX);
	but.position.y = bg.height*0.81;
	tournamentPopup.addChild(but);
	var skip_chb = addSharing('dontShow');
	skip_chb.position = {x:centerX - skip_chb.width/2, y:bg.height*0.765};
	tournamentPopup.addChild(skip_chb);
	skip_chb.checkbox.on('click', skipChange).on('touchend', skipChange);
	var skipping = false;
	skip_chb.checked.visible = false;
	function skipChange() {
		skipping = !skipping;
		skip_chb.checked.visible = skipping;
	}
	
	but.on('click', closeTournamentTuto).on('touchend', closeTournamentTuto);
	function closeTournamentTuto() {
		if (!tournamentSkipLevTutorial && skipping) {
			analytics('/api/settings?set=tournamentSkipLevTutorial&val=1');
			tournamentSkipLevTutorial = true;
		}
		removeTournamentTuto();
	}
	animatePopup(tournamentPopup);
}