<?php

set_time_limit(900);
if (!$_SERVER['DOCUMENT_ROOT']) { list($_SERVER['DOCUMENT_ROOT']) = explode('htdocs/', __FILE__, 2); $_SERVER['DOCUMENT_ROOT'] .= 'htdocs/'; }

if (!$_SERVER['HTTP_HOST']) list(,,$_SERVER['HTTP_HOST']) = explode('/', __FILE__, 4);

require_once($_SERVER['DOCUMENT_ROOT'] . '/inc/required.php');


if (date('w') == '1' && !sqlField("SELECT id FROM tournament WHERE time_join>NOW()")) {
	// in week tournament

	$name = 'IN WEEK Tournament ' . date('d-m-Y', strtotime('next tuesday')) . '*';
	$time_join = date('Y-m-d 15:00:00', strtotime('next tuesday'));
	$time_play = date('Y-m-d 15:00:00', strtotime('next thursday'));
	$time_claim = date('Y-m-d 21:00:00', strtotime('next thursday'));
	$time_end = date('Y-m-d 21:00:00', strtotime('next saturday'));

	$tournamentAutocreate = json_decode(sqlField("SELECT val FROM settings WHERE var='tournamentAutocreate'"), 1);

	sqlQuery("INSERT INTO tournament SET name='$name', time_join='$time_join', time_play='$time_play', time_claim='$time_claim', time_end='$time_end', tiles_min='$tournamentAutocreate[tiles_min]', tiles_max='$tournamentAutocreate[tiles_max]', tournament_type='0', size='$tournamentAutocreate[size]', dragonpairs_min='$tournamentAutocreate[dragonpairs_min]', dragonpairs_max='$tournamentAutocreate[dragonpairs_max]', active='1'");

	echo 'Tournament created: ' . $name . "\n";
	
	// weekend tournament

	$name = 'Tournament ' . date('d-m-Y', strtotime('next friday')) . '*';
	$time_join = date('Y-m-d 11:00:00', strtotime('next friday'));
	$time_play = date('Y-m-d 22:00:00', strtotime('next sunday'));
	$time_claim = date('Y-m-d 04:00:00', strtotime('next monday'));
	$time_end = date('Y-m-d 12:00:00', strtotime('next wednesday')+60*60*24*7);
	
	$tournamentAutocreate = json_decode(sqlField("SELECT val FROM settings WHERE var='tournamentAutocreate'"), 1);

	sqlQuery("INSERT INTO tournament SET name='$name', time_join='$time_join', time_play='$time_play', time_claim='$time_claim', time_end='$time_end', tiles_min='$tournamentAutocreate[tiles_min]', tiles_max='$tournamentAutocreate[tiles_max]', tournament_type='1', size='$tournamentAutocreate[size]', dragonpairs_min='$tournamentAutocreate[dragonpairs_min]', dragonpairs_max='$tournamentAutocreate[dragonpairs_max]', active='1'");

	echo 'Tournament created: ' . $name . "\n";

	$name = 'Boxhunt ' . date('Y-m-d', strtotime('next thursday')+60*60*24*7) . ' *';
	$start_time = date('Y-m-d 10:00:00', strtotime('next thursday')+60*60*24*7);
	$end_time = date('Y-m-d 23:00:00', strtotime('next thursday')+60*60*24*7+60*60*24);
	sqlQuery("INSERT INTO boxhunt SET name='$name', start_time='$start_time', end_time='$end_time'");
	echo 'Boxhunt created: ' . $name . "\n";

	$name = 'Boxhunt ' . date('Y-m-d', strtotime('next saturday')+60*60*24*7) . ' *';
	$start_time = date('Y-m-d 10:00:00', strtotime('next saturday')+60*60*24*7);
	$end_time = date('Y-m-d 23:00:00', strtotime('next saturday')+60*60*24*7+60*60*24);
	sqlQuery("INSERT INTO boxhunt SET name='$name', start_time='$start_time', end_time='$end_time'");
	echo 'Boxhunt created: ' . $name . "\n";
}


if (date('w') == '1' && !sqlField("SELECT id FROM notification WHERE send_time>NOW()")) {
	$messages = array(
		'NEW TOURNAMENT! Test Your Skills and Win Great PRIZES!',
		'A NEW TOURNAMENT! Show your skills and get the prizes NOW!',
		'TOURNAMENT TIME! Play NOW and get those PRIZES!',
	);


	shuffle($messages);
	$message = $messages[0];
	$send_time = date('Y-m-d 15:00:00', strtotime('next monday'));
	$filter = 'paylog|SUM(price*erate)|max|1
user|country_id|in|228,58,77,23,69,109,164,163';

	sqlQuery("INSERT INTO notification SET message='$message', send_time='$send_time', filter='$filter', active='1'");


	$send_time = date('Y-m-d 20:00:00', strtotime('next monday'));
	$filter = 'paylog|SUM(price*erate)|max|1
user|country_id|in|39,229,15';

	sqlQuery("INSERT INTO notification SET message='$message', send_time='$send_time', filter='$filter', active='1'");

	echo 'Notifications created: ' . $message . "\n";
}
//////////// INVITEPAGES (+ news + page post)
$feedText = array(
	'tournament' => "TOURNAMENT IS OPEN 🏆🌟\nHow many golden dragon tiles can You collect?\nJoin the weekly tournament and win prizes 🎁✨\n\nClick here and join the tournament 👇✨",
	'tournament_0' => "GOLDEN DRAGON TOURNAMENT IS OPEN 🀄️✨
How many Golden Dragon tiles can You collect?
Join the tournament and win prizes 🎁

Click here and join the tournament 👇",
	'tournament_1' => "BABY DRAGON TOURNAMENT IS OPEN 🀄️✨
How many Baby Dragon tiles can You collect?
Join the tournament and win prizes 🎁

Click here and join the tournament 👇",
	'20sekBonus' => "Claim Your Free TIME Booster 🤩🎁✨\nAdd extra time to any level with time bonus boosters!\n\nClick here and claim Your FREE Time Booster 👇✨",
	'highlight' => "Claim Your Free HIGHLIGHT Booster 🤩🎁✨\nHighlight booster helps you solve levels faster by showing you all the free pairs on the board!\n\nClick here and claim Your FREE Highlight Booster 👇✨",
	'money' => "Claim Your Free Extra COIN 🤩🎁✨\nUse coins to buy boosters & solve levels faster!\n\nClick here and claim Your FREE Coin 👇✨",
	'extraLife3' => "Claim Your Free LIFE Booster 🤩🎁✨\nGet an extra life and keep on playing!\n\nClick here and claim Your FREE Life Booster 👇✨",
	'spinWheel' => "Claim Your FREE SPIN 🤩🎁✨\nSpin the daily wheel of wonders and win free coins or other boosters!\n\nClick here and claim Your FREE Spin 👇✨",
);


$activeTournament = sqlAssoc("SELECT * FROM tournament WHERE time_join<=NOW() AND time_claim>=NOW()");
//$activeTournament = false;
$create = array();
$last = sqlAssoc("SELECT * FROM invitepage ORDER BY id DESC LIMIT 1");

if ($activeTournament) {
	$ttype = $activeTournament['tournament_type'] ? 'BABY DRAGON' : 'GOLDEN DRAGON';
	if (!stristr($last['title'], $ttype) && !stristr($last['description'], $ttype)) {
		$create = array(
			'title' => rand(0, 1) == 0 ? 'NEW ' . $ttype . ' TOURNAMENT!!!' : 'JOIN THE ' . $ttype . ' TOURNAMENT!!!!',
			'description' => rand(0, 1) == 0 ? 'Play the ' . $ttype . ' Tournament and win 100 coins!' : 'Join the ' . $ttype . ' Tournament and win 100 coins!',
			'gift' => '',
			'amount' => '0',
			'end_time' => $activeTournament['time_end'],
			'autopic' => 'tournament_' . $activeTournament['tournament_type'],
		);

		$news = array(
			'message' => "NEW TOURNAMENT!!!\nJoin the Tournament and win great prizes!",
			'btn' => 'Join now!',
			'start_time' => date('Y-m-d H:i:00'),
			'active' => '1',
		);
		$feed = $feedText['tournament_' . $activeTournament['tournament_type']];
	}
} else if (!sqlField("SELECT id FROM invitepage WHERE add_time>'" . date('Y-m-d H:i:s', time()-60*60*47+60*30) . "'")) {
	$lastGift = sqlField("SELECT gift FROM invitepage WHERE gift!='' ORDER BY id DESC LIMIT 1");

	$randInvitepage = sqlAssoc("SELECT * FROM invitepage WHERE gift IN ('20sekBonus', 'highlight', 'money', 'extraLife3', 'spinWheel') AND gift!='$lastGift' ORDER BY RAND() LIMIT 1");
	$create = array(
		'title' => $randInvitepage['title'],
		'description' => $randInvitepage['description'],
		'gift' => $randInvitepage['gift'],
		'amount' => '0',
		'end_time' => date('Y-m-d H:i:s', time()+60*60*24*2),
		'autopic' => $randInvitepage['gift'],
	);

	$msgs = array(
		'20sekBonus' => 'Click and Claim free Timebooster!',
		'highlight' => 'Click and Claim free Highlight!',
		'money' => 'Click and claim Extra Coin!',
		'extraLife3' => 'Click and Claim free Extra Life!',
		'spinWheel' => 'Click and Claim Free Spin!',
	);


	$news = array(
		'message' => $msgs[$create['gift']],
		'btn' => 'Click to claim!',
		'start_time' => date('Y-m-d H:i:00'),
		'active' => '1',
	);

	$feed = $feedText[$create['gift']];
}

if ($create) {
	echo '<pre>' . print_r($create, 1) . '</pre>';
	sqlQuery("INSERT INTO invitepage(" . implode(', ', array_keys($create)) . ") VALUES ('" . implode("', '", $create) . "')");
	$invitepage_id = mysql_insert_id($con)*1;

	if ($news) {
		$news['link'] = 'https://' . $_SERVER['HTTP_HOST'] . '/og&invitepage=' . $invitepage_id;

		sqlQuery("INSERT INTO news(" . implode(', ', array_keys($news)) . ") VALUES ('" . implode("', '", $news) . "')");
	}

	if ($feed) {
		$post = fbGraph('feed', $config['fb_page_id'], array('message' => $feed, 'link' => 'https://' . $_SERVER['HTTP_HOST'] . '/og&invitepage=' . $invitepage_id), 2);
		
		$msg = 'message: ' . $feed . "\nurl: https://" . $_SERVER['HTTP_HOST'] . '/og&invitepage=' . $invitepage_id . "\n";

		echo mail('kirstivill@gmail.com', '---> 3D fanpage message created', $msg . "\n\n--------------------------\n" . date('Y-m-d H:i:s'), 'From: wwwrun@3d.mahjongwonders.com', '-fwwwrun@3d.mahjongwonders.com');
	}
}

?>