<?php

$assets = array(
	'pack1' => array (
		array('code' => 'pinAchievement', 'file' => 'MapPinAchievements.png'),
		array('code' => 'mapLeader', 'file' => 'AvatarFrameLeader.png', 'important' => true),
		array('code' => 'defaultThumb', 'file' => 'emp.png'),
		array('code' => 'popup_blue_large', 'file' => 'PopupLargeSpecial.png'),
		array('code' => 'popup_pink_large', 'file' => 'PopupLargePink.png'),
		array('code' => 'kub', 'file' => 'TimeTileRot.png'),
		array('code' => 'kub_front', 'file' => 'TimeTile.png'),
		array('code' => 'arro', 'file' => 'RotateArrow.png'),
		array('code' => 'arro_glow', 'file' => 'RotateArrowGlow.png'),
		array('code' => 'iconMahjong', 'file' => 'CrossPromoMahjong.png'),
		array('code' => 'iconHexa', 'file' => 'CrossPromoHexa.png'),
		array('code' => 'br_tuto', 'file' => 'ArrowRightImage.png'),
		array('code' => 'bl_tuto', 'file' => 'Arrow-left-image.png'),
		array('code' => 'ribbonEmpty', 'file' => 'RibbonTagEmpty.png'),
		array('code' => 'dragontile_front', 'file' => 'GoldenDragonTileRot.png'),
		array('code' => 'unlimitedlives', 'file' => 'unlimitedlives.png'),
		
		array('code' => 'huntbox_bg', 'file' => 'vaheaken_empty.png'),
		array('code' => 'huntbox_dragon', 'file' => 'treasurehunt_dragon.png'),
		array('code' => 'huntbox', 'file' => 'kast.png'),
		array('code' => 'huntbox_trunk', 'file' => 'kast_glow.png'),
		array('code' => 'huntbox_opentrunk', 'file' => 'kastlahti_glow.png'),
		array('code' => 'huntbox_goalicon', 'file' => 'treasurehunt_startlevel.png'),
		array('code' => 'mapGiftbox_ribbon', 'file' => 'ribbon_kast.png'),
		
		array('code' => 'videoWheelBut', 'file' => 'tv_round.png'),
		array('code' => 'videoTV', 'file' => 'tv.png'),
		array('code' => 'videoSquare', 'file' => 'tv_square.png'),
		
		array('code' => 'friendTile', 'file' => 'kivi.png'),
		array('code' => 'friendLint', 'file' => 'ribbon.png'),
		array('code' => 'market_slot', 'file' => 'market_slot.png'),
		array('code' => 'market_active_slot', 'file' => 'market_active_slot.png'),
		array('code' => 'market_tile_bg', 'file' => 'market_tile_bg.png'),
		array('code' => 'messages_icon', 'file' => 'MapLeftMenuMessages.png'),
		array('code' => 'popup_friends', 'file' => 'PopupLargeFriends.png'),
		array('code' => 'victory_popup', 'file' => 'PopupVictory.png'),
		array('code' => 'achievement_bg', 'file' => 'AchievementsRowBase.png', 'important' => true),
		array('code' => 'achievement_bg_green', 'file' => 'AchievementsRowBaseGreen.png', 'important' => true),
		array('code' => 'elements_coin', 'file' => 'elements_coin.png'),
		array('code' => 'btn_plus', 'file' => 'TransparentBtnPlus.png'),
		array('code' => 'booster_coin_bg', 'file' => 'elements_coin2.png'),
		array('code' => 'coin', 'file' => 'Coin.png', 'important' => true),
		array('code' => 'coin_disabled', 'file' => 'coin_disabled.png'),
		array('code' => 'pin', 'file' => 'MapPinNormal.png'),
		array('code' => 'pin_1st', 'file' => 'MapPin1st.png'),
		array('code' => 'pin_future', 'file' => 'MapPinLocked.png'),
		array('code' => 'pin_victory', 'file' => 'MapPinKeyNormal.png'),
		array('code' => 'pin_victory_future', 'file' => 'MapPinKeyLocked.png'),
		array('code' => 'mapStarGrey', 'file' => 'MapPinStarSilver.png'),
		array('code' => 'mapStarGold', 'file' => 'MapPinStarGold.png'),
		array('code' => 'closeBut', 'file' => 'closeBut.png', 'important' => true),
		array('code' => 'key', 'file' => 'key.png', 'important' => true),
		array('code' => 'thumbBG', 'file' => 'LevelSlotDark.png', 'important' => true),
		array('code' => 'starGrey', 'file' => 'starGrey.png', 'important' => true),
		array('code' => 'starGold', 'file' => 'starGold.png', 'important' => true),
		array('code' => 'music_controls_bg', 'file' => 'music_controls_bg.png'),
		array('code' => 'pause', 'file' => 'TransparentBtnPause.png'),
		array('code' => 'pause_inactive', 'file' => 'TransparentBtnPauseInactive.png'),
		array('code' => 'sound', 'file' => 'TransparentBtnSound.png'),
		array('code' => 'sound_inactive', 'file' => 'TransparentBtnSoundInactive.png'),
		array('code' => 'music', 'file' => 'TransparentBtnMusic.png'),
		array('code' => 'music_inactive', 'file' => 'TransparentBtnMusicInactive.png'),
		array('code' => 'fbicon', 'file' => 'FbIconFull.png'),
		array('code' => 'heart', 'file' => 'heart.png'),
		array('code' => 'heart_disabled', 'file' => 'heart_disabled.png'),
		array('code' => 'askLivesFB', 'file' => 'LivesAskFriendsFb.png'),
		array('code' => 'buy_lives', 'file' => 'LivesBuyAndPlay.png'),
		array('code' => 'buy3livesPermanent', 'file' => 'buy3livesPermanent.png'),
		array('code' => 'frame', 'file' => 'AvatarFrameGameboard.png'),
		array('code' => 'avatarEmpty', 'file' => 'AvatarFrameLeaderboardsEmpty.png'),
		array('code' => 'popup_small', 'file' => 'PopupSmall.png', 'important' => true),
		array('code' => 'popup_large', 'file' => 'PopupLarge.png', 'important' => true),
		array('code' => 'failed', 'file' => 'LevelFailed.png'),
		array('code' => 'failed_disabled', 'file' => 'LevelFailed_grey.png'),
		array('code' => 'glow', 'file' => 'BlingShine.png', 'important' => true),
		array('code' => 'checkboxWhite', 'file' => 'CheckboxWhite.png', 'important' => true),
		array('code' => 'checkboxWhite_checked', 'file' => 'CheckboxWhite_checked.png', 'important' => true),
		array('code' => 'check_gift', 'file' => 'Checkmark.png', 'important' => true),
		array('code' => 'restart', 'file' => 'LargeRoundButtons_00001_blue.png', 'important' => true),
		array('code' => 'timeFull', 'file' => 'TopTimeFull.png'),
		array('code' => 'xp1', 'file' => 'XPBonusTag.png', 'important' => true),
		array('code' => 'panelResults', 'file' => 'PanelLevelResults.png'),
		array('code' => 'timerBG', 'file' => 'topTime.png'),
		array('code' => 'stopClpBG', 'file' => 'ItemSlot.png', 'important' => true),
		array('code' => 'item_slot', 'file' => 'ItemSlot2.png', 'important' => true),
		array('code' => 'lives_bg', 'file' => 'MenubarTopLives.png'),
		array('code' => 'gems_bg', 'file' => 'gems_bg.png'),
		array('code' => 'xp_bg', 'file' => 'MenubarTopXp.png'),
		array('code' => 'xp_slider', 'file' => 'MenubarTopXpProgress.png'),
		array('code' => 'home', 'file' => 'ButtonsRoundHome.png'),
		array('code' => 'like_arrow', 'file' => 'LikeArrow.png'),
		array('code' => 'karikas', 'file' => 'TournamentCupGold.png'),
	),
	
	'pack2' => array (
		array('code' => 'mapShadow', 'file' => 'CornerGradient.png'),
		array('code' => 'cloudsmap', 'file' => 'CloudMapCover.png'),
		array('code' => 'nextWorld', 'file' => 'MapPinNextWorld.png'),
		array('code' => 'prevWorld', 'file' => 'MapPinPrevWorld.png'),
		array('code' => 'life_sent', 'file' => 'CheckboxHeart.png'),
		array('code' => 'first', 'file' => 'Number1Badge.png', 'important' => true),
		array('code' => 'highscore_life_but', 'file' => 'SmallRectButtons_00000.png', 'important' => true),
		array('code' => 'friend_row_bg', 'file' => 'UserSelectGridNeutral.png', 'important' => true),
		array('code' => 'friend_avatar', 'file' => 'AvatarFrameLeaderboards.png', 'important' => true),
		array('code' => 'new_avatar', 'file' => 'AvatarFrameLeaderboardsEmpty.png', 'important' => true),
			
		array('code' => 'booster_but', 'file' => 'ButtonsRoundYellow.png'),
		array('code' => 'boosters_hint_bg', 'file' => 'HighlightInactive.png'),
		array('code' => 'boosters_hint', 'file' => 'Highlight.png'),
		array('code' => 'boosters_hint_dis', 'file' => 'Highlight_dis.png'),
		array('code' => 'boosters_time_bg', 'file' => 'TimeInactive.png'),
		array('code' => 'boosters_time', 'file' => 'Time20.png', 'important' => true),
		array('code' => 'boosters_time_disabled', 'file' => 'Time20_disabled.png', 'important' => true),
		array('code' => 'time30', 'file' => 'Time30.png'),
		array('code' => 'time60', 'file' => 'Time60.png'),
		array('code' => 'time60_disabled', 'file' => 'Time60_disabled.png'),
		array('code' => 'boosters_time_dis', 'file' => 'Time20_disabled.png'),
		array('code' => 'shuffle_bg', 'file' => 'ReshuffleInactive.png', 'important' => true),
		array('code' => 'shuffle', 'file' => 'Reshuffle.png', 'important' => true),
		array('code' => 'shuffle_dis', 'file' => 'Reshuffle_dis.png'),
		array('code' => 'boosters_superhint_bg', 'file' => 'SuperHintInactive.png'),
		array('code' => 'boosters_superhint', 'file' => 'SuperHint.png'),
		array('code' => 'boosters_superhint_dis', 'file' => 'SuperHint_dis.png'),
		array('code' => 'boosters_highlight_bg', 'file' => 'HintInactive.png'),
		array('code' => 'boosters_highlight', 'file' => 'Hint.png', 'important' => true),
		array('code' => 'boosters_highlight_disabled', 'file' => 'Hint_dis.png'),
		array('code' => 'boosters_highlight_dis', 'file' => 'Hint_dis.png'),
			
		array('code' => 'wood_label', 'file' => 'WoodenTitlePlank.png'),
		array('code' => 'wheel_bg', 'file' => 'Wheel.png', 'important' => true),
		array('code' => 'wheel_bot', 'file' => 'WheelLip.png', 'important' => true),
		array('code' => 'wheel_day', 'file' => 'PanelDay.png', 'important' => true),
		array('code' => 'wheel_day_active', 'file' => 'PanelDayBlue.png', 'important' => true),
		array('code' => 'blue_badge1', 'file' => 'WinPopup.png', 'important' => true),
		array('code' => 'popup_blue_small', 'file' => 'PopupSmallSpecial.png', 'important' => true),
		array('code' => 'popup_pink_small', 'file' => 'PopupSmallPink.png', 'important' => true),
		array('code' => 'blue_badge_highscore', 'file' => 'HighScoreTag.png', 'important' => true),
		array('code' => 'wheel_arrow', 'file' => 'Pointer.png', 'important' => true),
		array('code' => 'wheel_but', 'file' => 'SpinNow.png', 'important' => true),
		array('code' => 'explain', 'file' => 'explain.png', 'important' => true),
		array('code' => 'scroll_drag', 'file' => 'ScrollbarBar.png', 'important' => true),
		array('code' => 'scroll_bg', 'file' => 'ScrollbarBase0.png', 'important' => true),
		array('code' => 'scroll_front', 'file' => 'ScrollbarBase.png', 'important' => true),
		array('code' => 'ach_scr1', 'file' => 'ach_scr1.png', 'important' => true),
		array('code' => 'ach_scr2', 'file' => 'ach_scr2.png', 'important' => true),
		array('code' => 'ach_scr3', 'file' => 'ach_scr3.png', 'important' => true),
		array('code' => 'bar_full', 'file' => 'ProgressBarFull.png', 'important' => true),
		array('code' => 'bar_empty', 'file' => 'ProgressBarEmpty.png', 'important' => true),
		array('code' => 'tournament_join_header', 'file' => 'TournamentJoinHeaderBabyDragon.png'),
		array('code' => 'tournament_join_header2', 'file' => 'TournamentJoinHeaderDragon.png'),
		array('code' => 'tournament_bottom_bar', 'file' => 'TournamentBottomBar.png'),
		array('code' => 'TournamentDragonMapLeft', 'file' => 'TournamentDragonMapLeft.png'),
		array('code' => 'TournamentBabyDragonMapLeft', 'file' => 'TournamentBabyDragonMapLeft.png'),
	),
	
		
	'pack3' => array (
		array('code' => 'timeSlider', 'file' => 'TopTimeProgressBar.png'),
		array('code' => 'buycoins_bg', 'file' => 'BuyCoinsBoxSmall.png'),
		array('code' => 'buycoins_row', 'file' => 'BuyCoinsRow.png'),
		array('code' => 'buycoins_row_green', 'file' => 'BuyCoinsRowGreen.png'),
		array('code' => 'buycoins_bg_green', 'file' => 'BuyCoinsBoxLargeGreen.png'),
		array('code' => 'sales100', 'file' => 'CoinPileMedium.png'),
		array('code' => 'sales50', 'file' => 'CoinPileSmall.png'),
		array('code' => 'sales250', 'file' => 'CoinPileLarge.png'),
		array('code' => 'sales500', 'file' => 'CoinPileChest.png'),
		array('code' => 'sales500a', 'file' => 'CoinPileExtraLarge.png'),
		array('code' => 'bestValue', 'file' => 'RibbonTagBestValue.png'),
		array('code' => 'mostPopular', 'file' => 'RibbonTagMostPopular.png'),
		array('code' => 'offerBundle', 'file' => 'BundleBase.png'),
		array('code' => 'firstBuyOfferBG', 'file' => 'PopupLargePromo003.png'),
			
		array('code' => 'wheel_icon', 'file' => 'MapLeftMenuWheel.png'),
		array('code' => 'gift_icon', 'file' => 'MapLeftMenu_00003.png'),
		array('code' => 'market_icon', 'file' => 'MapLeftMenu_00002.png'),
		array('code' => 'achievements_icon', 'file' => 'MapLeftMenu_00001.png'),
		array('code' => 'hallOfFame_icon', 'file' => 'MapLeftMenu_00007.png'),
		array('code' => 'wheel_badge', 'file' => 'NumberHolderBlue.png'),
		array('code' => 'infinity_badge', 'file' => 'NumberHolderBlueInfinite.png'),
		array('code' => 'infinity_badge_disabled', 'file' => 'NumberHolderBlueInfinite_disabled.png'),
		array('code' => 'wheel_badge_disabled', 'file' => 'NumberHolderBlue_disabled.png'),
		//array('code' => 'msg_badge', 'file' => 'NumberHolderRed.png'),
		array('code' => 'msg_badge', 'file' => 'NumberHolderGreen.png'),
		array('code' => 'tab_hide', 'file' => 'TabsFront.png', 'important' => true),
		array('code' => 'challenge', 'file' => 'challenge.png'),
		array('code' => 'help_tab1_pic', 'file' => 'TutorialGraph.png'),
			
			
		array('code' => 'b_blue_l_pr', 'file' => 'b_b_l_pr.png'),
		array('code' => 'b_blue_m_pr', 'file' => 'b_b_m_pr.png'),
		array('code' => 'b_blue_r_pr', 'file' => 'b_b_r_pr.png'),
		array('code' => 'b_blue_l', 'file' => 'b_b_l.png', 'important' => true),
		array('code' => 'b_blue_m', 'file' => 'b_b_m.png', 'important' => true),
		array('code' => 'b_blue_r', 'file' => 'b_b_r.png', 'important' => true),
		array('code' => 'b_grey_l', 'file' => 'b_g_l.png'),
		array('code' => 'b_grey_m', 'file' => 'b_g_m.png'),
		array('code' => 'b_grey_r', 'file' => 'b_g_r.png'),
		array('code' => 'b_green_l', 'file' => 'b_z_l.png'),
		array('code' => 'b_green_m', 'file' => 'b_z_m.png'),
		array('code' => 'b_green_r', 'file' => 'b_z_r.png'),
		array('code' => 'b_green_l_pr', 'file' => 'b_z_l_pr.png'),
		array('code' => 'b_green_m_pr', 'file' => 'b_z_m_pr.png'),
		array('code' => 'b_green_r_pr', 'file' => 'b_z_r_pr.png'),
		array('code' => 'b_red_l', 'file' => 'b_r_l.png'),
		array('code' => 'b_red_m', 'file' => 'b_r_m.png'),
		array('code' => 'b_red_r', 'file' => 'b_r_r.png'),
		array('code' => 'b_red_l_pr', 'file' => 'b_r_l_pr.png'),
		array('code' => 'b_red_m_pr', 'file' => 'b_r_m_pr.png'),
		array('code' => 'b_red_r_pr', 'file' => 'b_r_r_pr.png'),
			
		array('code' => 'tips1', 'file' => 'tip1.png'),
		array('code' => 'tips2', 'file' => 'tip2.png'),
		array('code' => 'tips3', 'file' => 'tip3.png'),
		array('code' => 'tips4', 'file' => 'Faster.png'),
		array('code' => 'tips6', 'file' => 'tip6.png'),
		array('code' => 'tips7', 'file' => 'tip7.png'),
		array('code' => 'tips8', 'file' => 'tip8.png'),
		array('code' => 'tips9', 'file' => 'tip9.png'),
		array('code' => 'tips10', 'file' => 'tip10.png'),
			
		array('code' => 'coins_map_bg', 'file' => 'mapGoldBG.png'),
		array('code' => 'cloud1', 'file' => 'Cloud1.png'),
		array('code' => 'cloud2', 'file' => 'Cloud2.png'),
		array('code' => 'arr', 'file' => 'arr.png'),
		array('code' => 'plusBut', 'file' => 'plusBut.png'),
		array('code' => 'plusBut_disabled', 'file' => 'TransparentBtnPlusInactive.png'),
		array('code' => 'info_but', 'file' => 'TransparentBtnInfo.png'),
		array('code' => 'info_but_inactive', 'file' => 'TransparentBtnInfoInactive.png'),
		array('code' => 'go_prev', 'file' => 'ButtonsRoundDown.png'),
		array('code' => 'go_next', 'file' => 'ButtonsRoundUp.png'),
		array('code' => 'timer_bg', 'file' => 'timer_bg.png'),
		array('code' => 'tournamentA', 'file' => 'Tournament256_00.png'),
		array('code' => 'tournamentB', 'file' => 'Tournament256_01.png'),
		array('code' => 'tournamentC', 'file' => 'Tournament256_02.png'),
		
		array('code' => 'boxTournament', 'file' => 'boxTournament.png'),
		array('code' => 'doubleDragons', 'file' => 'GoldenDragonIconDouble.png'),
			
		array('code' => 'coinPack1', 'file' => 'CoinPileSmall.png'),
		array('code' => 'coinPack2', 'file' => 'CoinPileLarge.png'),
		array('code' => 'coinPack3', 'file' => 'CoinPileChest.png'),
		array('code' => 'ribbon2', 'file' => 'Ribbon2.png'),
			
		array('code' => 'trunk', 'file' => 'trunk.png'),
		array('code' => 'token2', 'file' => 'token2.png'),
		array('code' => 'gemPack1', 'file' => 'tokenPack1.png'),
		array('code' => 'gemPack2', 'file' => 'tokenPack2.png'),
		array('code' => 'gemPack3', 'file' => 'tokenPack3.png'),
		array('code' => 'loading1', 'file' => 'LoadingScreenBar1.png'),
		array('code' => 'loading2', 'file' => 'LoadingScreenBar2.png'),
		array('code' => 'loading3', 'file' => 'LoadingScreenBar.png'),
		array('code' => 'challengeLoader', 'file' => 'GoldenKeyProgress.png'),
			
			
		array('code' => 'goldDragon2', 'file' => 'GoldenDragonIcon2.png'),
		array('code' => 'goldDragon2_big', 'file' => 'GoldenDragonIcon2_big.png'),
		array('code' => 'babyDragon', 'file' => 'BabyDragonTileNormal.png'),
		array('code' => 'babyDragon_rot', 'file' => 'BabyDragonTileTurn.png'),
		array('code' => 'goldenDragonIcon', 'file' => 'IconGoldenDragonTile.png'),
		array('code' => 'babyDragonIcon', 'file' => 'IconBabyDragonTile.png'),
		array('code' => 'DoubleDragon', 'file' => 'DoubleDragon.png'),
		array('code' => 'DoubleBabyDragon', 'file' => 'DoubleBabyDragon.png'),
		array('code' => 'tournament_right_bg', 'file' => 'TournamentLeftBoard.png'),
		array('code' => 'tokenPack1', 'file' => 'ItemSlotToken1.png'),
		array('code' => 'tokenPack2', 'file' => 'ItemSlotToken2.png'),
		array('code' => 'tokenPack3', 'file' => 'ItemSlotToken3.png'),
		array('code' => 'spin_top', 'file' => 'SpinWindow_top.png'),
		array('code' => 'spin_bg', 'file' => 'SpinWindow_bg.png'),
		array('code' => 'spin_top2', 'file' => 'SpinWindow_top2.png'),
		array('code' => 'spin_bg2', 'file' => 'SpinWindow_bg2.png'),
		array('code' => 'to_go', 'file' => 'to_go.png'),
		array('code' => 'token', 'file' => 'TokenNew.png'),
		array('code' => 'tokenBroken', 'file' => 'TokenNewBroken.png'),
		array('code' => 'tokenPileSmall', 'file' => 'TokenPileSmall.png'),
		array('code' => 'tokenPileLarge', 'file' => 'TokenPileLarge.png'),
		array('code' => 'token_disabled', 'file' => 'TokenNewDisabled.png'),
		array('code' => 'tokenBroken_disabled', 'file' => 'TokenNewBrokenDisabled.png'),
		array('code' => 'tournamentCounter', 'file' => 'TournamentCounter.png'),
		array('code' => 'man_tournament', 'file' => 'AvatarFrameTournLeaderboards.png'),
		array('code' => 'prize_tournament', 'file' => 'prize_tournament.png'),
		array('code' => 'tournamentOffer', 'file' => 'Special_offer_tournament.png'),
		array('code' => 'TournamentOfferClicker', 'file' => 'TournamentOfferClicker.png'),
		array('code' => 'timerBG_alone', 'file' => 'timerBG_alone.png'),
		array('code' => 'tournClaim', 'file' => 'TournamentClaim.png'),
		array('code' => 'ChestWithGemsCoins', 'file' => 'ChestWithGemsCoins.png'),
			//{code:'popup_large_shine', 'file' => 'to_go.png'),
			
			
		array('code' => 'balloon_top', 'file' => 'SpeechBubble1.png'),
		array('code' => 'balloon_mid', 'file' => 'SpeechBubble2.png'),
		array('code' => 'balloon_bot', 'file' => 'SpeechBubble3.png'),
		array('code' => 'teach_arrow', 'file' => 'TeachArrow.png'),
		array('code' => 'teach_arrow_f', 'file' => 'TeachArrow_f.png'),
	),
		
	'mp3' => array( // don't rename it
		array('ext' => 'mp3', 'code' => 'music2', 'file' => 'music2.mp3'),
		array('ext' => 'mp3', 'code' => 'addCoin', 'file' => 'MJ_raha.mp3'),
		array('ext' => 'mp3', 'code' => 'wheelStart', 'file' => 'MJ_daily_wheel_ac.mp3'),
		array('ext' => 'mp3', 'code' => 'music1', 'file' => 'MJ_kaardimuusika.mp3'),
		array('ext' => 'mp3', 'code' => 'last5seconds', 'file' => 'MW_tick_01-2015.mp3'),
		array('ext' => 'mp3', 'code' => 'kivi_vihje', 'file' => 'MJ_vihje_kellukesed.mp3'),
		array('ext' => 'mp3', 'code' => 'winSound', 'file' => 'MJ_v6it.mp3'),
		array('ext' => 'mp3', 'code' => 'levelUpSound', 'file' => 'MJ_tase_yles.mp3'),
		array('ext' => 'mp3', 'code' => 'firstStar', 'file' => 'MJ_t2rn.mp3'),
		array('ext' => 'mp3', 'code' => 'friendTimeBonus', 'file' => 'MJ_s6brasekundid_AC.mp3'),
		array('ext' => 'mp3', 'code' => 'tickingNumber', 'file' => 'MJ_punktid.mp3'),
		array('ext' => 'mp3', 'code' => 'popup_ette', 'file' => 'MJ_popup_ette.mp3'),
		array('ext' => 'mp3', 'code' => 'popup_kaob', 'file' => 'MJ_popup_eest.mp3'),
		array('ext' => 'mp3', 'code' => 'kivi_pair', 'file' => 'MJ_paar_F.mp3'),
		array('ext' => 'mp3', 'code' => 'animateLevel', 'file' => 'MJ_klotsid_lauda_uus.mp3'),
		array('ext' => 'mp3', 'code' => 'kivi_click', 'file' => 'MJ_klikk.mp3'),
		array('ext' => 'mp3', 'code' => 'lose', 'file' => 'MJ_kaotus.mp3'),
		array('ext' => 'mp3', 'code' => 'tenPoints', 'file' => 'MJ_10p_punktid.mp3'),
	),
		
		
	// sheets
	'json' => array ( // don't rename it
		//{ext:'json', code:'bling', 'file' => 'Bling.json'),
		array('ext' => 'json', 'code' => 'loader', 'file' => 'LoadingProgress.json'),
		array('ext' => 'json', 'code' => 'dragonHappy', 'file' => 'DragonHappyUltra.json'),
		array('ext' => 'json', 'code' => 'dragon', 'file' => 'DragonGeneric.json'),
		array('ext' => 'json', 'code' => 'dragonFrown', 'file' => 'DragonSad.json'),
		array('ext' => 'json', 'code' => 'dragonSad256', 'file' => 'DragonSad256x256.json'),
		array('ext' => 'json', 'code' => 'dragonLostLives', 'file' => 'DragonLostLives.json'),
		array('ext' => 'json', 'code' => 'dragonTeach', 'file' => 'DragonTeach.json'),
		//{ext:'json', code:'dragonLives', 'file' => 'LivesAskFriends.json'),
		array('ext' => 'json', 'code' => 'activePin', 'file' => 'MapLocator.json'),
		array('ext' => 'json', 'code' => 'starsExplose', 'file' => 'StarExplosion.json'),
		array('ext' => 'json', 'code' => 'loaderThumb', 'file' => 'loader.json'),
		array('ext' => 'json', 'code' => 'tileExplose', 'file' => 'TileExplode.json'),
	),
);

?>