// get xml texts by code = arg.
function xmlValue(arg) {
	var t = textXML.getElementsByTagName("txt");
	for (var i in t) {
		if (t[i] && t[i].getAttribute && t[i].getAttribute('name')==arg) return t[i].childNodes[0].nodeValue;
	}
	$.post('/log/xmllang', { ln: arg });
	return '';
}

// show popups - animate clp popup to page (can be multiple). ***********************************************
var totalPopupsHave = [];
function animatePopup(clp, blur, transparent) {
	if (!clp) return;
	if (hinta) hideHint();
	arg = typeof arg !== 'undefined' ? arg : '';
	
	clp.emptyBlk2 = wholeBox(0x000000, 0.4);
	
	if (blur==true) { 
		var blurFilter = new PIXI.filters.BlurFilter();
		blurFilter.blur = 5;
		if (elements) elements.filters = [blurFilter];
		if (gameBG && gameBG.width>0) gameBG.filters = [blurFilter];
		if (kivid) kivid.filters = [blurFilter];
		if (MAP) MAP.filters = [blurFilter];
		if (bl) bl.filters = br.filters = [blurFilter];
	}
		
		
	clp.emptyBlk2.alpha = dev ? 0.22 : 0;
	clp.emptyBlk2.interactive = true;
	stage.addChild(clp.emptyBlk2);
	TweenLite.to(clp.emptyBlk2, 0.3, {alpha:1});
	
	clp.position.x = -stageW;
	playSound('popup_ette', 120);
	
	stage.addChild(clp);
	TweenLite.to(clp, 0.3, {x:parseInt(stageW/2 - clp.bg.width/2)});
	
	havePopups = true;
	// blur popup behind last one
	if (totalPopupsHave.length>0) {
		var blurFilter2 = new PIXI.filters.BlurFilter();
		blurFilter2.blur = 3;
		totalPopupsHave[totalPopupsHave.length-1].filters = [blurFilter2];
	}
	totalPopupsHave.push(clp);
	restartNothingTimer();
	if (autoplayBut) {stage.removeChild(autoplayBut); placeAutoplay();}
}
// screenshot (not works)
function makeStageBitmap() {
    var src;
	src = renderer.view.toDataURL("image/png", 1);
	//log(src);
	return src;
}
// removing current popup (clp) and it's darken background.
function quitPopup(clp) {
	if (clp && clp.quitting!=true) {
		clp.quitting = true;
		playSound('popup_kaob', 50);
		TweenLite.to(clp, 0.35, {x:stageW});
		if (clp.emptyBlk2) TweenLite.to(clp.emptyBlk2, 0.35, {alpha:dev ? 0.22 : 0});
		
		if (totalPopupsHave.indexOf(clp)>=0) totalPopupsHave.splice(totalPopupsHave.indexOf(clp), 1);
		havePopups = totalPopupsHave.length>0;
		if (totalPopupsHave.length>0) {
			totalPopupsHave[totalPopupsHave.length-1].filters = null;
		}
		
		//remove filters
		if (elements) elements.filters = null;
		if (gameBG && gameBG.width>0) gameBG.filters = null;
		if (kivid && stopClip.action==null) kivid.filters = null;
		if (MAP) MAP.filters = null;
		if (bl) bl.filters = br.filters = null;
		
		setTimeout(function() {
			if (clp) {
				clp.quitting = null;
				removeAllChilds(clp);
				stage.removeChild(clp);
				TweenLite.killTweensOf(clp);
				if (clp.emptyBlk2) stage.removeChild(clp.emptyBlk2);
				clp.emptyBlk2 = null;
				//clp.destroy(true);
			}
			
			// reset popup
			if (clp==goalClip) {removeAllChilds(highscores_clip); highscores_clip=null; goalClip = null;}
			else if (clp==completePopup) {
				if ( clp.lose!=true && highscores_clip ) removeAllChilds(highscores_clip);
				highscores_clip=null;
				completePopup = null;
			
				// !!! anime clips.
				refreshTopData();
			
			}
			else if (clp==popupLives) {popupLives = null;}
			else if (clp==pauseClp) {pauseClp = null;}
			else if (clp==giftsPopup) {giftsPopup = null;}
			else if (clp==offerPopup) {offerPopup = null;}
			else if (clp==moneyPopup) {moneyPopup = null;}
			else if (clp==messagesPopup) {messagesPopup = null;}
			else if (clp==firsttimeOfferPopup) {firsttimeOfferPopup = null;}
			else if (clp==wheelPopup) {wheelPopup = null;}
			else if (clp==challengePopup) {challengePopup = null;}
			else if (clp==tournamentPopup) {tournamentPopup.removeingData(); setTimeout(memoryGarbage,200);}
			else if (clp==doubleDragonsPopup) {doubleDragonsPopup.destroy(); doubleDragonsPopup = null;}
			else if (clp==hallOfFamePopup) {hallOfFamePopup = null;}
			clp = null;
			restartNothingTimer();
		}, 350);
	}
}
function memoryGarbage() {
	var ua = window.navigator.userAgent;
	if (ua.indexOf('Chrome')>0 && ua.indexOf('Edge')<0) {
		var currentRender = renderer.type;
		var gameContainer = document.getElementById("gameContainer");
		gameContainer.removeChild(renderer.view);
		renderer.destroy(true);
		delete renderer;
		renderer = currentRender==2 ? new PIXI.CanvasRenderer(stageW, stageH, {antialias: true}) : PIXI.autoDetectRenderer(stageW, stageH, {antialias: true, preserveDrawingBuffer:true});
		renderer.roundPixels = true;
		gameContainer.appendChild(renderer.view);
		resetFPS();
		renderAll();
	}
}

// remove element (obj) all childs.
function removeAllChilds(obj) {
	while(obj && obj.children && obj.children.length>0) {
		if (obj.children[0].filters) obj.children[0].filters = null;
		obj.removeChildAt(0);
	}
}


// texts drawing. For multicolor use tags aaa<yellow>bbb</yellow> or aaa<white>bbb</white>
// {fontSize:30(default), bold:true(default)/false, color:#ffffff(default), stroke:0, strokeColor:"#422000", multiline:true/false, align:'center', lineHeight:1}
function createText(txt, style) {
	txt = String(txt).replace('<br>','\n').replace('<br/>','\n');
	var fn = style.font ? style.font : 'poetsenoneregular';
	var multistyle = txt.indexOf('</')>=0;
	var fontScaler = basePixelReso==1 ? 2 : 1;
	if (window.navigator.userAgent.indexOf("MSIE")>=0) fontScaler = 4;
	var fs = (style.fontSize ? style.fontSize*fontScaler : 60)*scale;
	if (style.width) style.width = Math.round(style.width)*fontScaler;
	if (style.height) style.height = Math.round(style.height)*fontScaler;
	if (style.lineHeight) style.lineHeight = style.lineHeight*fontScaler;
	if (style.stroke) style.stroke = style.stroke*fontScaler;
	
	if (style.color=='brown') {style.color='#422000'; style.strokeColor="#ffffff";}
	if (style.color=='yellow') style.color='#FFC300';
	if (style.color=='red') style.color='#FF0000';
	if (style.color=='lightbrown') {style.color='#6e4824'; style.stroke = 0;}
	
	var textStyle;
	updateStyle();
	
	function updateStyle() {
		textStyle = {
			def:{
				align: style.align ? style.align : 'center',
				valign: 'middle',
				fill : style.color ? style.color : '#ffffff',
				stroke : style.strokeColor ? style.strokeColor : '#422000',
				strokeThickness : style.stroke==0 || style.stroke==false ? 0 : parseInt(fs/3.6),
				wordWrap : style.multiline,
				wordWrapWidth : style.width ? style.width : 500,
				height : style.height ? style.height : 30,
				lineJoin: 'round'
			},
			yellow:{
				align: style.align ? style.align : 'center',
				valign: 'middle',
				fill : '#FFC300',
				stroke : style.strokeColor ? style.strokeColor : '#422000',
				strokeThickness : style.stroke==0 || style.stroke==false ? 0 : parseInt(fs/3.6),
				wordWrap : style.multiline,
				wordWrapWidth : style.width ? style.width : 500,
				height : style.height ? style.height : 30,
				lineJoin: 'round'
			},
			white:{
				align: style.align ? style.align : 'center',
				valign: 'middle',
				fill : '#ffffff',
				stroke : style.strokeColor ? style.strokeColor : '#422000',
				strokeThickness : style.stroke==0 || style.stroke==false ? 0 : parseInt(fs/3.6),
				wordWrap : style.multiline,
				wordWrapWidth : style.width ? style.width : 500,
				height : style.height ? style.height : 30,
				lineJoin: 'round'
			},
			red:{
				align: style.align ? style.align : 'center',
				valign: 'middle',
				fill : '#FF0000',
				stroke : '#422000',
				strokeThickness : parseInt(fs/3.6),
				wordWrap : style.multiline,
				wordWrapWidth : style.width ? style.width : 500,
				height : style.height ? style.height : 30,
				lineJoin: 'round'
			}
		};
		if (multistyle) {
			// old mode, but pixi-multistyle-text.js class is old.
			textStyle.def.font = textStyle.white.font = textStyle.yellow.font = (style.bold==false ? 'normal' : 'bold')+' '+fs+'px '+fn;
			textStyle.red.font = 'bold '+(fs*1.6)+'px '+fn;
		} else {
			textStyle.def.fontSize = fs;
			textStyle.def.fontFamily = fn;
			textStyle.def.fontWeight = style.bold==false ? 'normal' : 'bold';
		}
		if (textStyle.def.wordWrapWidth<10) textStyle.def.wordWrapWidth = textStyle.white.wordWrapWidth = textStyle.yellow.wordWrapWidth = textStyle.red.wordWrapWidth = 100;
		if (textStyle.def.height<10) textStyle.def.height = textStyle.white.height = textStyle.yellow.height = textStyle.red.height = 20;
		
		
		if (style.lineHeight) textStyle.def.lineHeight = textStyle.white.lineHeight = textStyle.yellow.lineHeight = textStyle.red.lineHeight = style.lineHeight;
	}

	var to = multistyle ? new PIXI.MultiStyleText(txt, textStyle, textStyle.def) : new PIXI.Text(txt, textStyle.def);
	
	if (style.autoResize==true) {
		// autosize
		if (textStyle.def.wordWrap) {
			// autosize multiline text
			while(to.height > textStyle.def.height) {
				fs--;
				if (style.lineHeight) style.lineHeight=parseInt(fs*1.4);
				updateStyle();
				to = multistyle ? new PIXI.MultiStyleText(txt, textStyle, textStyle.def) : new PIXI.Text(txt, textStyle.def);
				if (fs<3) break;
			}
		} // if still one word width bigger than width
		
		// autosize one row
		while(to.width > textStyle.def.wordWrapWidth) {
			fs--;
			if (style.lineHeight) style.lineHeight=parseInt(fs*1.3);
			updateStyle();
			if (textStyle.def.fontSize <= 0) {
				textStyle.def.fontSize = 1;
				break;
			}
			to = multistyle ? new PIXI.MultiStyleText(txt, textStyle, textStyle.def) : new PIXI.Text(txt, textStyle.def);
			if (fs<3) break;
		}
	}
	
	/*/ specials stroke
	if (style.stroke!=0 && style.stroke!=false) {
		if (textStyle.def.fontSize<16) textStyle.def.strokeThickness = 3;
	}*/
	if (style.stroke>0) textStyle.def.strokeThickness=style.stroke;
	to = multistyle ? new PIXI.MultiStyleText(txt, textStyle, textStyle.def) : new PIXI.Text(txt, textStyle.def);
	
	//replace text!
	to.styles = textStyle;
	to.multistyle = multistyle;
	to.anchor.x = to.anchor.y = 0.5;
	to.basescale = to.scale.x = to.scale.y = scale / fontScaler;
	to.width = Math.round(to.width);
	to.height = Math.round(to.height);
	to.position.x = Math.round(style.x ? style.x : 0);
	to.position.y = Math.round(style.y ? style.y : 0);
	return to;
}



// music + sounds --------------------------------------------------------------------------------------------------------------------------------------
function playSound(ass) {
	if (!sndOff && audioAssets[ass]) {
		//stopSound(ass);
		audioAssets[ass].seek(0);
		audioAssets[ass].play();
	}
}
function playMusic(arg) {
	if (!musicOff) {
		if (arg!=2) arg=1;
		if (currentMusic==arg) return;
		stopMusic();
		var ass = 'music'+arg;
		log('PLAY '+ass);
		if (audioAssets[ass]) {
			audioAssets[ass].seek(0);
			audioAssets[ass].play();
		}
		currentMusic = arg;
	}
}
function stopMusic() {
	currentMusic = 0;
	if (audioAssets['music1']) audioAssets['music1'].pause();
	if (audioAssets['music2']) audioAssets['music2'].pause();
}
function stopSound(ass) {
	if (audioAssets[ass]) audioAssets[ass].pause();
}
function mute() {
	for (var ass in audioAssets) audioAssets[ass].mute(true);
}
function unmute() {
	for (var ass in audioAssets) audioAssets[ass].mute(false);
}



// GRAPHICS assets ---------------------------------------------------------------------------------------------------------------------------------
// draw asset into clip - in match3 with sheets, in this version not.
function getAsset(assName, w, h) {
	if (assets && assets.resources[assName]) {
		var sprite = new PIXI.Sprite(assets.resources[assName].texture);
		var scaleRatio = w=='auto' ? h/sprite.height : w/sprite.width;
		var origRatio = assetsRatio[assName] ? scaleRatio*assetsRatio[assName] : scaleRatio;

		if (origRatio > 1) origRatio = 1;
		if (!assetsRatio[assName] || assetsRatio[assName] != 1 && assetsRatio[assName] < origRatio) $.post('/log/assetRatio', {asset: assName, ratio: origRatio});
		if (!assetsRatio[assName]) assetsRatio[assName] = 1;

		sprite.scale.set(scaleRatio*scale);
		sprite.assName = assName;
		return sprite;
	} else return new PIXI.Sprite(); // empty
}
// get animated spritesheet
function getSheet(name) {
	if (assets && PIXI.loader.resources[name].data) {
		var loaderTexture = [];
		for (var i in PIXI.loader.resources[name].data.frames) {
			loaderTexture.push( PIXI.Texture.fromFrame(i) );
		}
		return new PIXI.extras.MovieClip(loaderTexture);
	} else new PIXI.extras.MovieClip();
}
// place sheet (clip, width, loop = looping boolean, anchor = center rotation pos, xpos, ypos, delay = delay before start, hide = remove at the end)
function makeSheet(clp, w, loop, anc, x, y, delay, hide) {
	if (anc==undefined) anc=0.5;
	if (x==undefined) x=0;
	if (y==undefined) y=0;
	if (delay==undefined) delay=0;
	clp.visible = false;
	if (delay>0) setTimeout(make, delay); else make();
	function make() {
		if (clp) {
			clp.visible = true;
			clp.anchor.x = clp.anchor.y = anc;
			clp.width = clp.height = parseInt(w);
			clp.position.x = parseInt(x);
			clp.position.y = parseInt(y);
			clp.gotoAndPlay(1);
			clp.animationSpeed = animeSpeed;
			if (hide==true) {
				clp.onComplete = function() {
					if (clp && clp.parent) clp.parent.removeChild(clp);
				};
			}
			clp.loop = loop==true;
		}
	}
}


// console log and store log to send by feedback ------------------------------------------------------------------------------------------------
function log(txt) {
	logger += txt+'.';
	if (logger.length>5000) logger = logger.slice(logger.length-5000,logger.length);
	if (traces && window.console) console.log(txt);
}
function getLOG() {
	return {screenshot:makeStageBitmap(), consoleinfo:logger, render:renderer.type==1 ? 'WebGl' : 'Canvas'};
}




// add page loader (no touchable background) ----------------------------------------------------------------------------------------------------
function addLoader(arg) {
	if (loader) removeLoader(true);
	loader = new PIXI.Sprite();
	loader.interactive = true;
	
	if (!arg) {
		var bg = wholeBox(0x000000, 0.1);
		loader.addChild(bg);
	}
		
	var loadMC = getSheet('loader');
	makeSheet(loadMC, stageW/4.22222, true, 0.5, arg ? arg.bg.width/2 : stageW/2, arg ? arg.bg.height/2 : stageH/2);
	loadMC.height = loadMC.width/6;
	loader.addChild(loadMC);
	
	if (renderer.type==1) {
		loader.alpha = 0;
		TweenLite.to(loader, 2, {alpha:1});
	}
	if (arg) arg.addChild(loader); else stage.addChild(loader);
}
// remove loader
function removeLoader(force) {
	if (force) actionRemove(); else setTimeout(actionRemove, 20);
	function actionRemove() {
		if (loader) {
			TweenLite.killTweensOf(loader);
			removeAllChilds(loader);
			stage.removeChild(loader);
		}
		loader = null;
	}
}

// make whole screen sprite 
function wholeBox(col, alpha) {
	var bg = new PIXI.Graphics();
	bg.beginFill(col, alpha);
	bg.moveTo(0,0);
	bg.lineTo(stageW, 0);
	bg.lineTo(stageW, stageH);
	bg.lineTo(0, stageH);
	bg.lineTo(0, 0);
	bg.endFill();
	return bg;
}


// button ******************************************************************************************************************************************
function initBUT(txt, mode) {
	mode = typeof mode !== 'undefined' ? mode : '';
	
	var but = new PIXI.Sprite();
		
	var color = 'blue';
	if (mode=='disabled' || mode=='grey') color = 'grey'; 
	else if (mode=='red' || mode=='green' || mode=='yellow') color = mode;
	
	but.originalColor = color=='grey' ? 'blue' : color;
	
	var leftButPart,midButPart,rightButPart;
	
	but.interactive = but.buttonMode = mode!='disabled';
	
	var icon, icon2, lin;
	var iconType = '';
	if (txt.indexOf('[coin]')>=0) iconType='coin';
	if (txt.indexOf('[life]')>=0) iconType='heart';
	if (txt.indexOf('[heartBroken]')>=0) iconType='failed';
	if (txt.indexOf('[time]')>=0) iconType='boosters_time';
	if (txt.indexOf('[token]')>=0) iconType='token';
	if (txt.indexOf('[token2]')>=0) iconType='token2';
	if (txt.indexOf('[tokenBroken]')>=0) iconType='tokenBroken';
	if (txt.indexOf('[highlight]')>=0) iconType='boosters_highlight';
	var onCoin = txt.indexOf('[on_coin]')>0;
	var discount = txt.indexOf('[coin2]')>0;
	txt = txt.replace('[coin]', onCoin ? '  ' : '').replace('[token]', '').replace('[token2]', '').replace('[on_coin]', '').replace('[coin2]', '').replace('[life]', '').replace('[time]', '').replace('[heartBroken]', '').replace('[tokenBroken]', '').replace('[highlight]', '');	
	if (iconType == 'failed' || iconType == 'tokenBroken') txt = '     ' + txt;
	else if (iconType!='' && !onCoin) txt += '      ';
	but.btext = txt;
	
	var lrw = 76*0.48;
	midButPart = getAsset('b_'+color+'_m', 168*0.48);
	leftButPart = getAsset('b_'+color+'_l', lrw);
	rightButPart = getAsset('b_'+color+'_r', lrw);
	but.addChild(midButPart);
	but.addChild(leftButPart);
	but.addChild(rightButPart);
	
	var txt = createText(txt, {fontSize:22, x:lrw/2, y:21, align:"left", color:color=='grey' ? '#dddddd' : '#ffffff', strokeColor:color=='grey' ? '#999999' : ''});
	txt.anchor.x = 0;
	txt.anchor.y = 0.5;
		
	leftButPart.height = midButPart.height = rightButPart.height = 94*0.48;
	var w = Math.round(lrw + txt.width);
	midButPart.position.x = lrw - 1;
	midButPart.width = w - lrw*2 + 2;
	rightButPart.position.x = w - lrw;
	but.w = w;
	but.h = leftButPart.height;
	
	
	but.on('mousedown', dwn)
		.on('touchstart', dwn)
		.on('mouseup', up)
		.on('touchend', up)
		.on('mouseupoutside', up)
		.on('touchendoutside', up);

	
	but.disable = function() {
		this.interactive = this.buttonMode = false;
		this.mode = 'disabled';
		
		this.colorize('grey');
		
		this.removeChild(txt);
		txt = createText(this.btext, {fontSize:22, x:lrw/2, y:21, align:"left", color:'#dddddd', strokeColor:'#999999'});
		txt.anchor.x = 0;
		txt.anchor.y = 0.5;
		but.addChild(txt);
		
		if (icon) icon.texture = assets.resources[iconType+'_disabled'].texture;
		if (discount) {
			icon2.texture = assets.resources[iconType+'_disabled'].texture;
			lin.lineStyle(4, 0xcccccc, 1);
			but.removeChild(lin);
			but.addChild(lin);
		}
		if (icon) {icon.width = 38; icon.scale.y = icon.scale.x;}
		if (icon2) {icon2.width = 36; icon2.scale.y = icon2.scale.x;}
	};
	but.enable = function() {
		this.interactive = this.buttonMode = true;
		this.mode = this.originalColor;
		color = this.originalColor;
		mode = this.originalColor;
		
		this.colorize(color);
		
		this.removeChild(txt);
		txt = createText(this.btext, {fontSize:22, x:lrw/2, y:21, align:"left"});
		txt.anchor.x = 0;
		txt.anchor.y = 0.5;
		but.addChild(txt);
		
		if (icon) icon.texture = assets.resources[iconType].texture;
		if (discount) {
			icon2.texture = assets.resources[iconType].texture;
			lin.lineStyle(4, 0xcc0000, 1);
			but.removeChild(lin);
			but.addChild(lin);
		}
		if (icon) {icon.width = 38; icon.scale.y = icon.scale.x;}
		if (icon2) {icon2.width = 36; icon2.scale.y = icon2.scale.x;}
	};
	function dwn() {
		txt.position.y += 2;
		if (icon) icon.position.y += 2;
		if (icon2) icon2.position.y += 2;
		if (lin) lin.position.y += 2;
		
		drawB('_pr');
	}
	function up() {
		txt.position.y -= 2;
		if (icon) icon.position.y -= 2;
		if (icon2) icon2.position.y -= 2;
		if (lin) lin.position.y -= 2;
		drawB('');
	}
	function drawB(act) {
		leftButPart.texture = assets.resources['b_'+color+'_l'+act].texture;
		midButPart.texture = assets.resources['b_'+color+'_m'+act].texture;
		rightButPart.texture = assets.resources['b_'+color+'_r'+act].texture;
		leftButPart.width = rightButPart.width = lrw;
		leftButPart.scale.y = leftButPart.scale.x;
		rightButPart.scale.y = rightButPart.scale.x;
		midButPart.height = leftButPart.height = rightButPart.height;
		leftButPart.position.y = rightButPart.position.y = midButPart.position.y;
	}
	but.colorize = function(col) {
		leftButPart.texture = assets.resources['b_'+col+'_l'].texture;
		midButPart.texture = assets.resources['b_'+col+'_m'].texture;
		rightButPart.texture = assets.resources['b_'+col+'_r'].texture;
		leftButPart.width = rightButPart.width = lrw;
		leftButPart.scale.y = leftButPart.scale.x;
		rightButPart.scale.y = rightButPart.scale.x;
		midButPart.height = leftButPart.height = rightButPart.height;
		leftButPart.position.y = rightButPart.position.y = midButPart.position.y;
	};
	
	if (iconType!='') {
		but.icon = iconType;
		icon = getAsset(iconType, 38);
		icon.anchor.y = 0.5;
		if (iconType != 'failed' && iconType != 'tokenBroken') icon.position.x = but.w - (onCoin ? icon.width*1.18 : icon.width*1.3);
		else icon.position.x = but.w*0.08;
		icon.position.y = but.h*0.52;
		but.addChild(icon);	
	}
	if (discount) {
		but.discount = true;
		icon2 = getAsset(iconType, 36);
		icon2.anchor.y = 0.5;
		icon2.position.x = but.w - icon2.width*2.12;
		icon2.position.y = but.h*0.52;
		but.addChild(icon2);
	}
	but.addChild(txt);
	if (discount) {
		lin = new PIXI.Graphics();
		lin.lineStyle(4, mode=='disabled' ? 0xcc0000 : 0xcc0000, 1);
		lin.moveTo(icon2.position.x, icon2.position.y + icon2.height/2.5);
		lin.lineTo(icon2.position.x + icon2.width*0.9, icon2.position.y - icon2.height/2.5);
		but.addChild(lin);
	}
	
	
	but.anchor.x = but.anchor.y = 0.5;
	but.mode = mode;
	return but;
}
// place button to center X (pos)
function centerBut(but, pos) {but.position.x = pos - but.w/2.15*but.scale.x;}
// button resize
function maxButWidth(but, w) {
	if (but.w*but.scale.x > w) {
		but.scale.x = but.scale.y = w/but.w;
	}
}


// face thumb load ----------------------------------------------------------------------------------------------------------------------------
function makeFaceURL(clp, url, withHeart, invitable, withframe, siz, callback, fs) {
	if (!url) return;
	siz = siz ? parseInt(siz) : 150;
	var sprite,frLoadTimeout,nextLoaded=false;
	if (fs==undefined) fs=faceSize;
	
	var noname, loader, frm;
	
	noname = getAsset('defaultThumb', fs);
	noname.anchor = {x:0.485, y:0.5};
	loader = getSheet('loaderThumb');
	makeSheet(loader, fs*0.6, true, 0.5, 0, 0);
	clp.addChild(noname);
	clp.addChild(loader);
	if (withframe!='noframe' && withframe!==false) {
		frm = getAsset('frame', fs*1.2);
		frm.position.x = -fs*0.016;
		frm.anchor = {x:0.485, y:0.5};
		clp.addChild(frm);
	}
	
	
	if (cachedTextures['userThumb_'+url]) {
		sprite = new PIXI.Sprite(cachedTextures['userThumb_'+url]);
		drawFace();
	} else {
		var realURL = siz>0 ? url + (url.indexOf('?')>0 ? '&' : '?') + 'width='+siz+'&height='+siz : url;


		sprite = new PIXI.Sprite.fromImage(realURL);
		if (sprite.texture.baseTexture.hasLoaded==true) drawFace();
		else {
			sprite.texture.baseTexture.on('loaded', drawFace).on('error', function() {
				if (frLoadTimeout) clearTimeout(frLoadTimeout);
				frLoadTimeout = null;
				badThumb();
			});
			frLoadTimeout = setTimeout(badThumb, 3000);
		}
		function badThumb() {
			if (frLoadTimeout) return;
			sprite = getAsset('defaultThumb', fs);
			drawFace();
		}
		
	}
	function drawFace() {
		if (noname) {noname.destroy(); loader.destroy();}
		if (nextLoaded) return;
		nextLoaded = true;
			
		if (!cachedTextures['userThumb_'+url]) cachedTextures['userThumb_'+url] = new PIXI.Texture(sprite.texture.baseTexture);
		sprite.width = sprite.height = fs;
		sprite.anchor.x = sprite.anchor.y = 0.5;
		//sprite.alpha = 0.2;
		clp.addChild(sprite);
		if (frm) {
			frm.destroy();
			frm = getAsset('frame', fs*1.2);
			frm.position.x = -fs*0.016;
			frm.anchor = {x:0.485, y:0.5};
			clp.addChild(frm);
		}
		if (withHeart) {
			var ico = getAsset(invitable==1 ? 'heart' : 'life_sent', fs*0.5);
			ico.anchor = sprite.anchor;
			ico.position.x = -fs*0.37; ico.position.y = fs*0.37;
			clp.addChild(ico);
		}
		if (callback) callback(clp);
	}
}


//--------------------------------------------------------------------------------------------------------------------------------------------
function removeGame() {
	clockStop();
	if (elements) {
		removeAllChilds(elements);
		elements.destroy(true);
	}
	elements = null;
	if (GAME) {
		removeAllChilds(GAME);
		GAME.destroy(true);
	}
	GAME = null;
	removeAllChilds(gameContainer);
}



// convert seconds to dd hh:mm:ss ------------------------------------------------------------------------------------------------------------
function convertToTime(arg, withHours) {
	var min;
	var sec;
	var sec2;
	if (arg<0) arg=0;
	if (withHours==2) withHours = arg > 60*60 ? true : false;
	if (withHours==true) {
		var d = parseInt(arg/86400);
		var h = parseInt(arg/3600);
		if (d>0) h -= d*24;
		min = parseInt((arg - h*3600 - d*86400)/60);
		sec = arg - h*3600 - min*60 - d*86400;
		var min2 = min<10 ? '0'+min : min; 
		sec2 = sec<10 ? '0'+sec : sec; 
		return (d>0 ? d+'d ' : '')+h+':'+min2+':'+sec2;
	} else {
		min = parseInt(arg/60);
		sec = arg - min*60;
		sec2 = sec<10 ? '0'+sec : sec; 
		return min+':'+sec2;
	}
	
}
function convertToTime2(arg, withHours) {
	var min;
	var sec;
	var sec2;
	if (arg<0) arg=0;
	if (withHours==2) withHours = arg > 60*60 ? true : false;
	if (withHours==true) {
		var d = parseInt(arg/86400);
		var h = parseInt(arg/3600);
		if (d>0) h -= d*24;
		min = parseInt((arg - h*3600 - d*86400)/60);
		sec = arg - h*3600 - min*60 - d*86400;
		var min2 = min<10 ? '0'+min : min; 
		sec2 = sec<10 ? '0'+sec : sec; 
		return (d>0 ? d+'d: ' : '')+h+'h: '+min2+'m: '+sec2+'s';
	} else {
		min = parseInt(arg/60);
		sec = arg - min*60;
		sec2 = sec<10 ? '0'+sec : sec; 
		return min+':'+sec2;
	}
	
}
function curLevelNumber(txt) {
	if (mapDATA) {
		for (var i = 0; i<mapDATA.length; i++) {
			if (mapDATA[i].id == selectedLevel) return txt.replace('[number]', mapDATA[i].ord);
		}
	}
	return txt.replace('[number]', '');
}


// sharing checkbox ----------------------------------------------------------------------------------------------------------------------------
function addSharing(txt, color, size) {
	if (color==undefined || color=='') color='6e4824';
	if (color=='white') color='ffffff';
	if (size==undefined) size=1;
	var shareObj = new PIXI.Container();
	var obj = {color:'#'+color, align:'left', fontSize:parseInt(13*size), x:parseInt(27*size), y:parseInt(-5*scale), width:130*size};
	if (color != 'ffffff') {obj.stroke = 0;}
	var t = createText(xmlValue(txt), obj);
	t.anchor.x = 0; t.anchor.y = 0.28;
	shareObj.addChild(t);
	shareObj.checkbox = getAsset('checkboxWhite', 20*size); //color=='ffffff' ? 'checkboxWhite' : 'checkbox'
	shareObj.checkbox.interactive = shareObj.checkbox.buttonMode = true;
	shareObj.checked = getAsset('checkboxWhite_checked', 20*size); //color=='ffffff' ? 'checkboxWhite_checked' : 'checkbox_checked'
	shareObj.checkbox.anchor.y = shareObj.checked.anchor.y = 0.5;
	shareObj.addChild(t);
	shareObj.addChild(shareObj.checkbox);
	shareObj.addChild(shareObj.checked);
	return shareObj;
}



// rollover hints ******************************************************************************************************************************
// makeHint ( target clip,  rollover hint text, pos=position of hint (BR - bottom-right, TL - top-left etc), w-hint width, poprX,poprY - adjustment 
// of position related target, al-text align (left or center) )
var hinta;
function makeHint(clp, txt, pos, w, poprX, poprY, al, force) {
	if (clp) {
		poprX = poprX ? poprX : 0;
		poprY = poprY ? poprY : 0;
		var arrSize = parseInt(stageW*0.03);
		
		function calcPos(clp) {
			var par = clp.parent;
			var xy = {x:clp.x, y:clp.y, viz:clp.visible && par && par.visible};
			while(par) {
				xy.x += par.x;
				xy.y += par.y;
				par = par.parent;
				if (par && !par.visible) xy.viz = false;
			}
			if (pos.indexOf('R')>=0) xy.x += clp.width*(1-(clp.anchor ? clp.anchor.x : 0));
			else if (pos.indexOf('L')>=0) xy.x -= clp.width*(clp.anchor ? clp.anchor.x : 0) + w;
			if (pos.indexOf('B')>=0) xy.y += clp.height*(1-(clp.anchor ? clp.anchor.y : 0));
			else if (pos.indexOf('T')>=0) xy.y -= clp.height*(1-(clp.anchor ? clp.anchor.y : 0));
			xy.x += poprX;
			xy.y += poprY;
			
			if (pos=='RB' || pos=='BR') {xy.y += arrSize/1.6511628/2; xy.x -= w/3.5-arrSize;}
			if (pos=='LB' || pos=='BL') {xy.y += arrSize/1.6511628/2; xy.x += w/3.5-arrSize;}
			if (pos=='LT' || pos=='TL') {xy.y -= arrSize/1.6511628/2; xy.x += w/3.5-arrSize;}
			if (pos=='RT' || pos=='TR') {xy.y -= arrSize/1.6511628/2; xy.x -= w/3.5-arrSize;}
			if (pos=='LL') {xy.y -= arrSize/1.6511628/2;}
			return xy;
		}
		
		var xy = calcPos(clp);
		if (xy.viz) {
			if (force) {
				showHint({target:clp});
			} else {
				clp.interactive = true;
				clp.on('touchstart', showHint).on('touchend', hideHint).on('touchendoutside',hideHint).on('mouseover', showHint).on('mouseout', hideHint);
			}
		}

		
		function showHint(e) {
			if (hinta) hideHint(true);
			if (txt && txt!='') {
				hinta = new PIXI.Container();
			
				var t = createText(txt.split('<br>').join('\n'), {color:'#000000', stroke:0, align:al==undefined ? 'center' : al, fontSize:14, x:10, y:10, width:w-20, multiline:true});
				t.anchor.x = t.anchor.y = 0;
				var bg = new PIXI.Graphics();
				bg.beginFill(0xfff3ca, 1);
				bg.drawRoundedRect(0,0, w,t.height+20, 10);
				bg.endFill();
				
				var shad =  new PIXI.Graphics();
				shad.beginFill(0x000000, 0.3);
				shad.drawRoundedRect(0,2, w,t.height+20, 10);
				shad.endFill();
				var blurFilter = new PIXI.filters.BlurFilter();
				blurFilter.blur = 4;
				shad.filters = [blurFilter];
				hinta.addChild(shad);
				hinta.addChild(bg);
				t.position.x = w/2;
				t.anchor.x = 0.5;
				
				// arrow
				var arr = getAsset('arr', arrSize);
				if (pos=='RB' || pos=='BR') {arr.anchor.y = 1; arr.scale.x = -arr.scale.x; arr.position.x = w/3.5;}
				if (pos=='LB' || pos=='BL') {arr.anchor.y = 1; arr.position.x = w - w/3.5;}
				if (pos=='LT' || pos=='TL') {arr.anchor.y = 1; arr.position.x = w - w/3.5; arr.scale.y = -arr.scale.y; arr.position.y = bg.height;}
				if (pos=='RT' || pos=='TR') {arr.anchor.y = 1; arr.position.x = w/3.5; arr.scale.x = -arr.scale.x; arr.scale.y = -arr.scale.y; arr.position.y = bg.height;}
				if (pos=='LL') {arr.anchor.y = 1; arr.position.x = w; arr.rotation = Math.PI/2; arr.scale.x = -arr.scale.x; arr.position.y = arrSize + 10;}
				
				var xy = calcPos(e.target);
				hinta.position.x = parseInt(xy.x);
				hinta.position.y = parseInt(xy.y - (pos.indexOf('T')>=0 ? bg.height : 0));
				hinta.addChild(arr);
				hinta.addChild(t);
				hinta.alpha = 0;
				TweenLite.to(hinta, 0.15, {alpha:1});
				
				stage.addChild(hinta);
			}
		}
	}
}
function hideHint(arg) {
	//hints.filters = null;
	TweenLite.killTweensOf(hinta);
	
	// just make fill clp in a moment
	if (arg!=true) {
		var ovr = wholeBox(0xff0000, 0);
		ovr.interactive = true;
		stage.addChild(ovr);
		setTimeout(function() {stage.removeChild(ovr); ovr=null;}, 30);
	}
	
	removeAllChilds(hinta);
	stage.removeChild(hinta);
	if (hinta) hinta.destroy();
	hinta = null;
}






// Jarko JS communicate --------------------------------------------------------------------------------------------------------------

function ads(action) {
	if (action) {
		var t = action.replace('javascript:','');
		var tt = t.split('(');
		var a = tt.shift();
		t = tt.join('');
		var params = t.replace(');', '');
		log('JS communicate: '+a+'('+params+')');
		//window[a](params); // call Jarko JS
		setTimeout(a + '(' + params + ')', 1);
	}
}
function sendJSRequest(frList, reqType, jsLabel, jsDescription, arr) {
	// send By max 15 users (FB requirement)
	if (frList==undefined || frList==null) return;
	var list;
	frList = frList.split(',');
	var jsRequest = {frList:frList, reqType:reqType, jsLabel:jsLabel, jsDescription:jsDescription, arr:arr};
	if (frList.length>15) {
		var list = frList.slice(0,15);
		jsRequest.frList.splice(0,15);
	} else list = frList;
	if (list.length>0) {
		pinRefreshNeeded = true;
		sendRequestToUsers(JSON.stringify(list), reqType, xmlValue(jsLabel), xmlValue(jsDescription), arr);
		log('sendRequestToUsers('+JSON.stringify(list)+',   '+reqType+','+xmlValue(jsLabel)+','+xmlValue(jsDescription)+','+arr+')');
	}
}
function analytics(query) {
	serverSend(query + (playLog!='' ? '&playlog_id='+playLog : ''), function() {}, function() {});
}
function loadData(val) {
	if ($('#baseloaderSlider').is(':visible')) return;
    log('sent by JS: loadData '+val);
	if (val=='getlevels') refreshMapJson();
	else if (val=='gettileset') getTileset('');
	else if (tournamentPopup && val=='tournamentData') tournamentPopup.drawPLAY(); //!!! need this after tournament special offer bought to update tournament data (type B).
	else if (val=='getcampaign') {
		// refresh offer
		serverSend('/api/getcampaign', function(jo) {
			jsonObject = jo;
			refreshTopData();
		},	function() {});
	}
}
function inviteClosed() {
	if (jsRequest.frList.length>0) {
		sendJSRequest(jsRequest.frList.join(','), jsRequest.reqType, jsRequest.jsLabel, jsRequest.jsDescription, jsRequest.arr);
	} else {
		//!!! more?
		if (messagesPopup && messagesPopup.quitting!=true) quitPopup(messagesPopup);
		if (giftsPopup && giftsPopup.quitting!=true) giftsPopup.removePopup();
		refreshMapJson();
	}
}
function removeBaseLoader() {
	if (firsttime) $('#baseloader').hide().html('');
}
function sendGifts() {openGifts();}





function makeShadow(clp) {
	// elements shadow blur filter
	var distance = stageW*0.004;
	var shadow = new PIXI.Sprite();
	shadow.scale = clp.scale;
	shadow.position.x = clp.position.x;
	shadow.position.y = clp.position.y;
	var par = clp.parent;
	while(par) {
		shadow.scale.x = shadow.scale.x * par.scale.x;
		shadow.scale.y = shadow.scale.y * par.scale.y;
		par = par.parent;
	}
	if (shadow && shadow.width>0 && shadow.height>0) {
		shadow.texture = clp.texture;
		shadow.tint = 0x000000;
		if (renderer.type==1) {
			var blurFilter = new PIXI.filters.BlurFilter();
			blurFilter.blur = 6;
			shadow.filters = [blurFilter];
			shadow.alpha = 0.5;
		} else shadow.alpha = 0.25;
	}	
	shadow.anchor = clp.anchor;
	shadow.position.x += distance/2;
	shadow.position.y += distance;
	return shadow;
}
function refreshMessages(nr) {
	/*
	messagesData = ???;
	no message data. only number...
	offery();*/
}



// ****************************************************
// *************** Store everything *******************
// ************** and refresh data ******************** ---------------------------------------------------------------------------------------
// ****************************************************

function refreshTopData(ft) {
	// refresh map top elements - life / xp / lifetime etc
	if (jsonObject) {
		
		var mw = money;
		money = jsonObject.money*1;
		lives = jsonObject.lives*1;

		if (jsonObject.levels) {
			if (jsonObject.fullMap==0 && mapDATA && mapDATA.length>0) {
				// replace existing data pins data
				var lvls = [];
				for (var j in jsonObject.levels) lvls.push(jsonObject.levels[j]);
				while(lvls.length>0) {
					var replacer = lvls.shift();
					var found = false;
					for (var i=0; i<mapDATA.length; i++) {
						if (mapDATA[i].id == replacer.id) {
							mapDATA[i] = replacer;
							found = true;
							break;
						}
					}
					if (!found) mapDATA.push(replacer);
				}
				jsonObject.levels = null;
			} else mapDATA = jsonObject.levels;
		}
		if (jsonObject.settings) storedVars = jsonObject.settings;
		if (jsonObject.maps) mapBGs = jsonObject.maps;
		if (jsonObject.prices) {
			for (var i in jsonObject.prices) {if (!prices[i]) prices[i]=jsonObject.prices[i];}
		}
		if (jsonObject.payments) paymentsObject = jsonObject.payments;
		if (jsonObject.mobilePayments) mobilePaymentsObject = jsonObject.mobilePayments;
		if (jsonObject.offer) offerData = jsonObject.offer; else offerData = null;
		if (jsonObject.messages) messagesData = jsonObject.messages || [];
		if (jsonObject.hallOfFame) mapDATAleaders = jsonObject.hallOfFame || [];
		if (jsonObject.achievements) achievementsToClaim = jsonObject.achievements || [];
		if (jsonObject.achievements2) achievementsToClaim2 = jsonObject.achievements2 || [];
		if (jsonObject.friendBeat) friendBeat = jsonObject.friendBeat;
		
		challengeLeft = jsonObject.challenge ? jsonObject.challenge.timeLeft : 0;
		tournamentLeft = 0;
		tournamentData = jsonObject.tournament;
		
		if ( tournamentData ) {
			if (tournamentData.type=='A') tournamentLeft = tournamentData.iconDataA.timeLeft;
			else if (tournamentData.type=='B') tournamentLeft = tournamentData.iconDataB.timeLeft;
			else if (tournamentData.type=='C') tournamentLeft = tournamentData.iconDataC.timeLeft;
			else if (tournamentData.type=='W') tournamentData.wTimeLeft = tournamentData.iconDataW.timeLeft;
		}
		offerLeft = offerData ? offerData.timeLeft : 0;

		maxLives = jsonObject.maxLives*1;
		woobiEnabled = jsonObject.woobiEnabled;
		challengeData = jsonObject.challenge;
		
		xpLevel = jsonObject.XPlevel*1;
		if (jsonObject.timeToLifeFill) nextLiveTime = jsonObject.timeToLifeFill*1;
		
		// XP LEVEL UP / ACHIEVEMENT / NEW CIV ANIMATIONS.
		// important check - when lev up popups appears...
		if (!havePopups && animeclp==null && stopClip.black==null && (completePopup==null || completePopup.quitting) && !GAME && tutorialStep==0) {
			log('can have anime');
			if (xpLevel > xpLevelWas) {
				addAnimation('xp'); // animeClips.js
			}
			/*else if (jsonObject.completeEpisode) {
				toScrollPinWAS = 0; // reset civ border
				addAnimation('civComplete');
			}*/
			else if ((achievementsToClaim.length>0 || achievementsToClaim2.length>0) && backStep==0) {
				addAnimation('achievement');
			}
			else if (friendBeat) {
				// add beat friend in civ popup
				addAnimation('beatFriend');
			}
		}
	
		// refresh MAP
		//log('GAME = '+GAME);
		if (!GAME) {
			mapPosition = ft || jsonObject.completeEpisode ? 'home' : 'nochange'; // not firstime
			refreshMap();
		}
		else offery();

		if (elements && elements.t_money) { // && !animeclp && !wheelPopup
			// refresh only if grow up animation not needed
			updateTxt(elements.t_money, money);
		} else if (mapElements) {
			updateTxt(mapElements.t_money, money);
		}
	}
}
function pauseDisable() {
	if (elements) {
		elements.pause_mc.texture = assets.resources['pause_inactive'].texture;
		elements.pause_mc.interactive = elements.pause_mc.buttonMode = false;
	}
}
function pauseEnable() {
	if (elements) {
		elements.pause_mc.texture = assets.resources['pause'].texture;
		elements.pause_mc.interactive = elements.pause_mc.buttonMode = true;
	}
}
function arraySum(arr) {
	var result=0;
	for (var i in arr) result+=arr[i];
	return result;
}
function updateTxt(tb, txt) {
	if (tb && tb.parent) {
		tb.text = String(txt);
		tb.updateText();
		tb.updateTransform();
		tb.scale.x = tb.scale.y = tb.basescale;
	}
}
function blinkBut(but,times) {
	if (GAME && times>0 && but && but.visible && but.mode!='disabled') {
		var w = but.w*0.7;
		var h = but.h*0.7;
		var xx = but.position.x;
		var yy = but.position.y;
		var ww = but.width;
		var hh = but.width;
		var ww2 = stopClip.black || havePopups ? ww : ww*1.1;
		var hh2 = stopClip.black || havePopups ? hh : hh*1.1;
		var xx2 = stopClip.black || havePopups ? xx : xx-w*0.05;
		var yy2 = stopClip.black || havePopups ? yy : yy-h*0.05;
		times--;
		TweenLite.to(but, 0.12, {width:ww2, height:hh2, x:xx2, y:yy2, onComplete:function() {
			if (GAME && but) {
				TweenLite.to(but, 0.12, {width:ww, height:hh, x:xx, y:yy, onComplete:again});
			}
		}});
	}
	function again() {
		if (GAME && times>0 && but && but.visible && but.mode!='disabled') setTimeout(function() {blinkBut(but,times);}, 2000);
	}
}