function addCompletePopup() {
	
	if (tutorialStep==1) analytics('/api/analytics?code=tutorialStep_4.90');
	else if (mapDATA && mapDATA[1].stars==0) analytics('/api/analytics?code=tutorialStep_11');
	
	// remove shuffle if exist.
	if (stopClip && stopClip.black) hideCloseClip();
	pauseDisable();
	
	stopSound('last5seconds');
	elements.help2But.visible = false;
	
	// complete popup...
	completePopup = new PIXI.Container();
	completePopup.position.y = 50*scale;
	
	var bg, centerX, closeBut;
	var stopTicking = false;
	var best = 0;
	
	// send Data...
	var setlevelQuery = sandBoxId>0 ? 'testresult' : 'setlevel';
	var timeLev = threeInOneLevel ? completedTimes.join(",") : levelTimeStart - timeBonus/10;
	var query = '/api/'+setlevelQuery+'&id='+selectedLevel+'&playlog_id='+playLog+'&friendTileUsed='+(haveFrinedBoost<0 ? 1 : 0)+'&points='+levelScore+'&timeScore='+timeScore+'&timeBonus='+timeBonus+'&reason='+setLevelReason+'&time='+timeLev+'&firstStarTime='+firstStarTime+'&randomizer='+Math.random();
	setLevelReason = '';
	addLoader();
	makeNextLevel = false;

	// store for anime.
	myXPwas = jsonObject.experience;
	xpLevelWas = xpLevel;
	
	serverSend(query, function(jo) {
		removeLoader();
		jsonObject = jo;
		
		if (tutorialStep!=0) {
			myXPwas = jo.experience;
			xpLevelWas = jo.XPlevel*1;
			money = jo.money*1;
		}
		
		var popupCase = 'winner';
		playedOnce = true;

		if (jsonObject.completed==1) {
			if (checkMoreStars()) popupCase = 'collectMoreStars';
		} else popupCase = 'lose';
		//if (popupCase == 'winner' && haveFrinedBoost==-1 && helpFriend && helpFriend!='') popupCase='sendFriend';

		if (jo.error && jo.error!='') disconnect(jo.error || 'Wrong data'); else {
			drawMe(popupCase);
			animatePopup(completePopup);
		}
		if (popupCase!='collectMoreStars') playLog = '';
		
		
	}, function(error) {
		quitPopup(completePopup);
		disconnect('Server not responding. Please refresh page.', true, error);
		goMAP();
	});
		
	
	function drawMe(popupCase) {
		removeAllChilds(completePopup);
		
		
		var but, label, star1, star2, star3, highscore;
		
		playTimesToShowLivesVideo++;
		
		var isTutorialEnd = mapDATA && mapDATA[1].stars==0;
		
		if (popupCase=='winner') {
		
			if (tutorialStep==1 && selectedLevel==1) analytics('/api/analytics?code=tutorialStep_4.91');
			else if (mapDATA && mapDATA[1].stars==0 && selectedLevel==2) analytics('/api/analytics?code=tutorialStep_11.2');
			
			// complete case
			pinRefreshNeeded = true;
			if (pinWas && pinWas.stars==0) mapPosition = 'home';
			
			bg = getAsset('popup_friends', 690*scale); //!!
			completePopup.addChild(bg);
			centerX = bg.width/1.51; // bolshe <-
			
			closeBut = getAsset('closeBut', bg.width/19);
			closeBut.interactive = closeBut.buttonMode = true;
			closeBut.position.x = bg.width/1.05;
			closeBut.position.y = bg.height/21;
			completePopup.addChild(closeBut);
	
			var closetype = '';
			var glowRotate;
			var highscoreClp = new PIXI.Container();
			
			var nextBut = initBUT(xmlValue('next'), '');
			nextBut.position.x = parseInt(bg.position.x + bg.width*0.95 - nextBut.w);
			nextBut.position.y = parseInt(bg.position.y + bg.height*0.8);
			completePopup.addChild(nextBut);
			
			var restartBut = getAsset('restart', bg.width*0.081);
			restartBut.interactive = restartBut.buttonMode = true;
			restartBut.position.x = nextBut.position.x - restartBut.width*1.25;
			restartBut.position.y = bg.position.y + bg.height*0.79;
			completePopup.addChild(restartBut);
			
			restartBut.on('click', restartLevel2).on('touchstart', restartLevel2);
			closeBut.on('click', backToMapT5).on('touchstart', backToMapT5);
			function backToMapT5() {
				if (tutorialStep==1 && selectedLevel==1) analytics('/api/analytics?code=tutorialStep_4.92');
				else if (isTutorialEnd && selectedLevel==2) analytics('/api/analytics?code=tutorialStep_13');
				backToMap2();
			}
			
			if (tutorialStep==1) {
				nextBut.on('click', backToMapT492).on('touchstart', backToMapT492);
				function backToMapT492() {
					if (nextBut.mode!='disabled') {
						nextBut.disable();
						if (selectedLevel==1) analytics('/api/analytics?code=tutorialStep_5');
						backToMap2();
					}
				}
			} else {
				nextBut.on('click', nextLevel2).on('touchstart', nextLevel2);
			}
			if (sandBoxId>0) closeBut.visible = nextBut.visible = false;

			function restartLevel2() {
				closetype = 'restart';
				ckeckLike();
			}
			var nextPressed = false;
			function backToMap2() {
				closetype = 'close';
				ckeckLike();
			}
	
			function goNext() {
				if (glowRotate) clearInterval(glowRotate); glowRotate=null;
				resetLevel();
				makeNextLevel = true;
				goMAP();
				//!!!if (highscores) highscores.stopMoving();
			}

			//add texts: label
			label = createText(curLevelNumber(xmlValue('levelCompleted')), {fontSize:24, x:centerX, y:bg.height/21, width:bg.width/2.33, autoResize:true});
			completePopup.addChild(label);
		
			
			// draw highscore
			highscore = new PIXI.Container();
			highscore.position.x = bg.width * 0.93;
			highscore.position.y = bg.height * 0.25;
			highscore.visible = false;
			
			drawStars();
			
			if (tutorial) tutorial.visible = false;
			
			// share chekbox
			/*var sharing_chb = addSharing('sharingHighscores');
			sharing_chb.position.x = parseInt(bg.width*0.95 - sharing_chb.width);
			sharing_chb.position.y = parseInt(bg.height*0.92);
			sharing_chb.visible = false;
			completePopup.addChild(sharing_chb);
			sharing_chb.checkbox.on('click', sharingChange).on('touchstart', sharingChange);
			function sharingChange() {
				if (best==1) {
					sharingBestscore = !sharingBestscore;
					sharing_chb.checked.visible = sharingBestscore;
				} else {
					sharingHighscore = !sharingHighscore;
					sharing_chb.checked.visible = sharingHighscore;
				}
			}*/
			function nextLevel2() {
				if (nextBut.mode!='disabled') {
					nextBut.disable();
					
					if (isTutorialEnd) analytics('/api/analytics?code=tutorialStep_12');
					
					if (glowRotate) clearInterval(glowRotate); glowRotate=null;
					nextPressed = true;
					closetype = 'next';
					//if (sharing_chb.visible && sharing_chb.checked.visible && jsonObject.shareAction) ads(jsonObject.shareAction);
					if (sandBoxId==0) ckeckLike();
				}
			}
			
			// highscore
			if (jsonObject.highscores && jsonObject.highscores.length>2 && jsonObject.highscores[0].points <= levelScore) {
				highscore.txt_t1 = xmlValue('bestHighscore');
				best = 1;
				/*sharing_chb.checked.visible = sharingBestscore;
				shareVisible();*/
			}
			else if (starsWas>0 && jsonObject.bestScore <= levelScore) {
				highscore.txt_t1 = xmlValue('newHighscore');
				/*sharing_chb.checked.visible = sharingHighscore;
				shareVisible();*/
			}
			/*function shareVisible() {
				if (tutorialStep!=1) {
					sharing_chb.visible = highscore.visible = true;
					nextBut.position.y = bg.height*0.78;
					restartBut.position.y = bg.height*0.772;
				}
			}*/
			
			var highscores_label = createText(xmlValue('highScores'), {fontSize:18, x:bg.width*0.17, y:bg.height*0.175, width:bg.width/5, autoResize:true});
			completePopup.addChild(highscores_label);
			
			playSound('winSound', 430);
			
			// highscores table
			var highscores_clip = drawHighscores(bg.width*0.256, bg.height*0.095, true);
			highscores_clip.position.x = bg.width*0.0372;
			highscores_clip.position.y = bg.height*0.25;
			completePopup.addChild(highscores_clip);
			// highscores hints
			if (highscores_clip.rows) {				  
				for (var i in highscores_clip.rows.children) makeHint(highscores_clip.rows.children[i].but, xmlValue('lifeGift'), 'RB', stageW*0.12, bg.width*0.025, 0);
			}
	
			var face = new PIXI.Sprite();
			makeFaceURL(face, myData.pic, false, 0);
			face.scale.set(1.2);
			face.position.x = bg.width*0.41;
			face.position.y = bg.height*0.85;
			completePopup.addChild(face);
			
			
			// 1st place clip
			var firstclp = getAsset('first', bg.width*0.05);
			completePopup.firstclp = firstclp;
			firstclp.position.x = bg.width*0.35;
			firstclp.position.y = bg.height*0.865;
			completePopup.addChild(firstclp);
			firstclp.visible = jsonObject.highscores.length>0 && jsonObject.bestScore >= jsonObject.highscores[0].points;
			
			
			
			// ticking texts
			var panelResults = getAsset('panelResults', bg.width*0.61);
			panelResults.position = {x:bg.width*0.35, y:bg.height*0.49};
			panelResults.height = bg.height*0.28;
			completePopup.addChild(panelResults);
			
			var txt = xmlValue('result');
			var txtArr = txt.split('[percent]');
			// your result text
			var t_label2 = createText(txt.replace('[percent]','0'), {fontSize:27, x:centerX, y:bg.height*0.443, width:bg.width/1.5});
			completePopup.addChild(t_label2);
			var tt = createText(0, {color:'yellow', align:'left', fontSize:29, x:bg.width*0.47, y:bg.height*0.81, width:bg.width/10});
			tt.anchor.x = 0;
			completePopup.addChild(tt);
			var txp = createText('+0', {fontSize:21, align:'left', x:bg.width*0.52, y:bg.height*0.89, width:bg.width/10});
			txp.anchor.x = 0;
			completePopup.addChild(txp);
			
			var xp_icon = getAsset('xp1', bg.width*0.05);
			xp_icon.anchor.x = 0.5;
			xp_icon.anchor.y = 0.5;
			xp_icon.position = {x:tt.position.x + xp_icon.width*0.4,  y:txp.position.y};
			completePopup.addChild(xp_icon);
			
			// texts results
			// first column
			var col1Width = panelResults.width*0.5;
			var td10 = createText(xmlValue('pairsMatch'), {color:"brown", stroke:0, fontSize:15, align:'left', x:panelResults.position.x + panelResults.width*0.05, y:panelResults.position.y + panelResults.height*0.2, width:col1Width, autoResize:true});
			td10.anchor.x = 0;
			completePopup.addChild(td10);
			
			
			
			var td11 = createText(xmlValue('speedBonus'), {color:"brown", stroke:0, fontSize:15, align:'left', x:td10.position.x, y:panelResults.position.y + panelResults.height*0.4, width:col1Width, autoResize:true});
			td11.anchor.x = 0;
			completePopup.addChild(td11);
			var tlft = xmlValue('timeLeft');
			var td12 = createText(total==0 ? tlft : tlft.replace('x10', 'x0'), {color:"brown", stroke:0, fontSize:15, align:'left', x:td10.position.x, y:panelResults.position.y + panelResults.height*0.6, width:col1Width, autoResize:true});
			td12.anchor.x = 0;
			completePopup.addChild(td12);
			var td13 = createText(xmlValue('total'), {color:"brown", stroke:0, fontSize:19, align:'left', x:td10.position.x, y:panelResults.position.y + panelResults.height*0.83, width:col1Width});
			td13.anchor.x = 0;
			completePopup.addChild(td13);
			
			// second column	
			var td20 = createText(turns3+'/'+(totalTiles3/2), {color:"brown", stroke:0, fontSize:18, x:panelResults.position.x + panelResults.width*0.69, y:td10.position.y, width:panelResults.width*0.25});
			completePopup.addChild(td20);
			
			var td21 = createText('x'+parseInt(totalTiles3/20), {color:"brown", stroke:0, fontSize:18, x:td20.position.x, y:td11.position.y, width:td20.width});
			completePopup.addChild(td21);
			var td22 = createText(levelTime+xmlValue('sec').toLowerCase(), {color:"brown", stroke:0, fontSize:18, x:td20.position.x, y:td12.position.y, width:td20.width});
			completePopup.addChild(td22);
			
			
			//third column
			var td30 = createText(0, {color:"brown", stroke:0, align:'right', fontSize:18, x:panelResults.position.x + panelResults.width*0.95, y:td10.position.y, width:panelResults.width*0.25});
			td30.anchor.x = 1;
			completePopup.addChild(td30);
			var td31 = createText(0, {color:"brown", stroke:0, align:'right', fontSize:18, x:td30.position.x, y:td11.position.y, width:td30.width});
			td31.anchor.x = 1;
			completePopup.addChild(td31);
			var td32 = createText(0, {color:"brown", stroke:0, align:'right', fontSize:18, x:td30.position.x, y:td12.position.y, width:td30.width});
			td32.anchor.x = 1;
			completePopup.addChild(td32);
			var td33 = createText(0, {color:"brown", stroke:0, align:'right', fontSize:20, x:td30.position.x, y:td13.position.y, width:td30.width*1.5});
			td33.anchor.x = 1;
			completePopup.addChild(td33);
			
			var explain2 = getAsset('explain', bg.width*0.031); explain2.anchor.y = 0.5;
			var explain3 = getAsset('explain', bg.width*0.031); explain3.anchor.y = 0.5;
			explain2.position.x = td11.position.x + td11.width + 7; explain2.position.y = td11.position.y;
			explain3.position.x = td12.position.x + td12.width + 7; explain3.position.y = td12.position.y;
			completePopup.addChild(explain2);
			completePopup.addChild(explain3);
			makeHint(explain2, xmlValue('finishExplain2'), 'RT', stageW*0.2, 0, 0);
			makeHint(explain3, xmlValue('finishExplain3'), 'RT', stageW*0.2, 0, 0);
			
			
			// tick numbers
			tickNumber(t_label2, jsonObject.completePercent, 200, false, txtArr[0],txtArr[1]);
			tickNumber(td30, defaultTilesetPairScore * turns3, 400);
			tickNumber(td31, timeScore, 600);
			tickNumber(td32, timeBonus, 750);
			tickNumber(td33, levelScore, 900);
			tickNumber(tt, levelScore, 1100);
			tickNumber(txp, '+'+(jsonObject.experience - myXPwas), 1300, false,'','', xp_icon);

			restartBut.visible = retryButVisible && tutorialStep!=1;
				
			
			function ckeckLike() {
				if (glowRotate) clearInterval(glowRotate); glowRotate=null;
				stopTicking = true;
				
				log('stop tick');
				stopSound('tickingNumber');
				ckeckLike2();
			}
			function ckeckLike2() {
				
				if (tutorialStep==1) showTutorial('map2');
				
				
				// check win whole game or like popup appears
				if (jsonObject.allcompletedMessage==1 && !hallOfFamePopup) {
					addVictoryPopup();
				}
				else if (closetype == 'restart') {
					setTimeout(reloadLevel, 400); // more than 350!
				}
				else if (jsonObject.suggestLikeButton==1 && tutorialStep==0 && !hallOfFamePopup) {
					setTimeout(function() {addLikePopup(closetype, nextPressed);}, 350);
				}
				else if (closetype == 'close') {
					resetLevel();
					goMAP();
					//!!!highscores.stopMoving();
				}
				else if (nextPressed) {
					nextPressed = false;
					goNext();
				}
				else {
					goMAP();
				}
				quitPopup(completePopup);
			}
			
			makeHint(restartBut, xmlValue('hintReplayLevel'), 'LT', stageW*0.12, restartBut.width/2, restartBut.height);
			if (jsonObject.allcompleted!=1) makeHint(nextBut, xmlValue('hintNextLevel'), 'LT', stageW*0.12, nextBut.w/3, 0);
			
			
			
		} else if (popupCase=='lose') {
			if (mapDATA && mapDATA[1].stars==0) analytics('/api/analytics?code=tutorialStep_11.1');
			
			if (jsonObject.boxhuntPopup==1 && !haveBoxhunt) needOpenBoxhunt=true;															
			completePopup.lose = true;
			
			// lose case
			bg = getAsset('popup_pink_small', 'auto', stageH*0.84);
			bg.position.y = 0;
			completePopup.addChild(bg);
			centerX = bg.width/2; // bolshe <-
			
			/*var iconFailed = getAsset(lives<0 ? 'unlimitedlives' : 'failed', bg.width*0.43);
			iconFailed.position = {x:centerX, y:bg.height*0.42};
			iconFailed.anchor.x = iconFailed.anchor.y = 0.5;
			completePopup.addChild(iconFailed);*/
			
			closeBut = getAsset('closeBut', bg.width/12);
			closeBut.interactive = closeBut.buttonMode = true;
			closeBut.position.x = bg.width*0.84;
			closeBut.position.y = bg.height/12;
			completePopup.addChild(closeBut);
			
			label = createText(curLevelNumber(xmlValue('levelFailed')), {fontSize:26, x:centerX*1.015, y:bg.height/12, width:bg.width*0.6, autoResize:true});
			completePopup.addChild(label);
			
			
			function restartLevel() {
				analytics('/api/analytics?code=tryAgain');
				stopSound('tickingNumber');
				quitPopup(completePopup);
				reloadLevel();
			}
			
			var dragon2 = getSheet('dragonLostLives');
			animeSpeed = 0.4;
			makeSheet(dragon2, stageW*0.28, true, 0.5, stageW*0.417, stageH*0.4);
			animeSpeed = 0.44;
			dragon2.position.x = centerX;
			dragon2.position.y = bg.height*0.38;
			completePopup.addChild(dragon2);
			
			but = initBUT(xmlValue('tryAgain'),'green');
			but.scale.set(1.1);
			centerBut(but, centerX);
			but.position.y = parseInt(bg.position.y + bg.height*0.89);
			completePopup.addChild(but);
			but.on('click', restartLevel).on('touchstart', restartLevel);
			closeBut.on('click', backToMap).on('touchstart', backToMap);

			quitted = false;
			
			//var t1_txt = quitted ? xmlValue('failedDescription3') : getRandomTxt('failedDescription', 3);
			var t1_txt = 'You can do it';
			var t1 = createText(t1_txt, {fontSize:24, color:"yellow", x:centerX, y:bg.height*0.64, width:bg.width*0.85, autoResize:true});
			completePopup.addChild(t1);
			
			var t2 = createText('Try again and get at least one star to complete and move to the next level', {color:'white', stroke:4, fontSize:18, bold:false, x:centerX, y:bg.height*0.76, width:bg.width*0.54, multiline:true});
			completePopup.addChild(t2);

			playSound('lose', 400);
			

			// video...
			var isVideoWatched = false;
			if (videoAdEnable['lifeLose']==true && (myData.pgroup==false || myData.pgroup==true && money>10) && (jsonObject.lives==1 || jsonObject.lives==0) && playTimesToShowLivesVideo>=2) {
				
				// check have video ads...
				lsmAd(
					function (ad) { videoAd = ad; if (videoAd) addVideoButton(); }, 
					videoWatched,
					videoEnd
				);
				
				function askLivesVideo() {
					numlog('lsm_lifeLose_acceptAD');
					lsmAdShow(videoAd);
				}
				function videoWatched() {
					isVideoWatched = true;
					playTimesToShowLivesVideo = 0;
					videoAd = null;
				}
				function videoEnd() {
					stopBlinkingVideoIcon();
					
					if (isVideoWatched) {
						numlog('lsm_lifeLose_claim');
						gflog('LSM life');
						getJsonPrices(false, '', '', '&lsmLife=1');
						setTimeout(backToMap, 330);
					} else {
						numlog('lsm_life1_cancelAD');
						backToMap();
					}
				}
				function addVideoButton() {
					// only one life left...
					
					var videoAdIcon = getAsset('videoTV', bg.width*0.14);
					videoAdIcon.anchor.x = videoAdIcon.anchor.y = 0.5;
					videoAdIcon.rotation = -Math.PI/180*8;
					var livesAdsBut = initBUT('        '+xmlValue('livesAdsBut'), '');
					livesAdsBut.scale.set(0.9);
					livesAdsBut.interactive = livesAdsBut.buttonMode = true;
					livesAdsBut.position.y = bg.height * 0.71;
					centerBut(livesAdsBut, centerX-5);
					videoAdIcon.position = {x:livesAdsBut.position.x + livesAdsBut.h*0.3 * 0.9,   y:livesAdsBut.position.y + livesAdsBut.h*0.9*0.35};
					completePopup.addChild(livesAdsBut);
					completePopup.addChild(videoAdIcon);
					
					t1.visible = false;
					
					completePopup.blinkingIcon = videoAdIcon;
					blinkIcon2('completePopup');
					
					numlog('lsm_lifeLose_showAD');
					livesAdsBut.on('click', askLivesVideo).on('touchstart', askLivesVideo);
				}
				
			}
			
			
		} else if (popupCase=='collectMoreStars') {
			
			
			
			
			bg = getAsset('popup_small', 'auto', stageH*0.84);
			bg.width = stageW*0.72;
			completePopup.addChild(bg);
			centerX = bg.width/2;
			
			label = createText(curLevelNumber(xmlValue('levelCompleted')), {fontSize:26, x:centerX*1.02, y:bg.height/12, width:bg.width/1.7});
			completePopup.addChild(label);
			
			// turns to next star
			var stars = jsonObject.stars;
			var turnsLeft = totalTiles3/2 * (star_percent[stars]/100) - turns3;
			while (turnsLeft<0 && stars<3) {
				stars++;
				turnsLeft = totalTiles3/2 * (star_percent[stars]/100) - turns3;
			}
			if (turnsLeft > parseInt(turnsLeft)) turnsLeft = parseInt(turnsLeft)+1;
			var txtStarsLeft = turnsLeft>5 ? xmlValue('nextStarLeft') : xmlValue('nextStarLeftOnly');
			txtStarsLeft = txtStarsLeft.replace('[number]', '<yellow>'+parseInt(turnsLeft)+'</yellow>');
			var t3 = createText(txtStarsLeft, {fontSize:22, x:centerX, y:bg.height*0.51, width:bg.width*0.75});
			completePopup.addChild(t3);
			
			drawStars('no_highscore', bg.height*0.32, bg.width*0.24, stars);
			
			var but_repeat = initBUT('  '+xmlValue('playOn')+' [coin]'+prices.nextStar, 'green');
			but_repeat.scale.set(1.3);
			but_repeat.on('click', repeatGame2).on('touchstart', repeatGame2);
			but_repeat.position.y = bg.height*0.6;
			centerBut(but_repeat, centerX+bg.width*0.03);
			completePopup.addChild(but_repeat);
			
			var iconTime = getAsset('time60', bg.width*0.18);
			iconTime.anchor.x = iconTime.anchor.y = 0.5;
			iconTime.position.x = centerX - but_repeat.w*0.46*but_repeat.scale.x;
			iconTime.position.y = but_repeat.position.y + but_repeat.h/2*but_repeat.scale.y;
			completePopup.addChild(iconTime);
			
			closeBut = initBUT(xmlValue('nextBut'),'');
			closeBut.scale.set(0.9);
			closeBut.position.y = bg.height*0.79;
			centerBut(closeBut, centerX);
			closeBut.on('click', nextStars123).on('touchstart', nextStars123);
			completePopup.addChild(closeBut);

			function nextStars123() {
				but_repeat.disable();
				closeBut.disable();
				analytics('/api/analytics?code=noRepeatNextStar');
				//drawMe(haveFrinedBoost==-1 && helpFriend && helpFriend!='' ? 'sendFriend' : 'winner');
				drawMe('winner');
				completePopup.position.x = stageW/2 - bg.width/2;
			}
			function repeatGame2() {
				but_repeat.disable();
				closeBut.disable();
				
				if (!havePair()) shuffle();
				
				checkMoney(prices.nextStar, 'nextStar');
				if (money - prices.nextStar<0) quitPopup(completePopup);
			}
			if (autoplaying) setTimeout(nextStars123, 1000);


			
		} else if (popupCase=='sendFriend') {
			
			
			bg = getAsset('popup_small', 'auto', stageH*0.82);
			completePopup.addChild(bg);
			centerX = bg.width/2;
			
			label = createText(curLevelNumber(xmlValue('friendBonusLabel')), {fontSize:26, x:centerX*1.02, y:bg.height/12, width:bg.width*0.74, autoResize:true});
			completePopup.addChild(label);
			
			// face
			var faceF = new PIXI.Sprite();
			makeFaceURL(faceF, helpFriend, false, 0); //!!!! ?type=square is small
			faceF.scale.set(2);
			faceF.position.x = centerX;
			faceF.position.y = bg.height*0.34;
			completePopup.addChild(faceF);
			
			var t4 = createText(xmlValue('frindBonusDescription').replace('[name]', helpFriendName), {fontSize:22, color:"brown", stroke:0, x:centerX, y:bg.height*0.6, width:bg.width*0.7, multiline:true});
			completePopup.addChild(t4);
			
			closeBut = getAsset('closeBut', bg.width/12);
			closeBut.interactive = closeBut.buttonMode = true;
			closeBut.position.x = bg.width/1.19;
			closeBut.position.y = bg.height/12;
			closeBut.on('click', noSendBoost).on('touchstart', noSendBoost);
			completePopup.addChild(closeBut);
			
			but = initBUT(xmlValue('next'),'');
			centerBut(but, centerX);
			but.position.y = parseInt(bg.position.y + bg.height*0.77);
			completePopup.addChild(but);
			but.on('click', yesSendBoost).on('touchstart', yesSendBoost);
			
			function yesSendBoost() {
				but.disable();
				sendJSRequest(friendBooster_userId, "20sekBonus", 'jsRequest20secLabel', 'jsRequest20secDescription', []);
				drawMe('winner');
				completePopup.position.x = stageW/2 - bg.width/2;
			}
			function noSendBoost() {
				closeBut.interactive = closeBut.buttonMode = false;
				drawMe('winner');
				completePopup.position.x = stageW/2 - bg.width/2;
			}
			if (autoplaying) setTimeout(noSendBoost, 1000);
		}
		
		
		

		refreshTopData();
		completePopup.bg = bg;
		
		// if nextpin is scrollpos || nextpin is victory - dont enable.
		if (popupCase=='winner' && nextBut && pinWas) {
			if (jsonObject.completeEpisode || mapDATA.length>pinWas.nr && mapDATA[pinWas.nr+1] && mapDATA[pinWas.nr+1].type == 'victory') {
				var nb_pos = nextBut.position;
				completePopup.removeChild(nextBut);
				
				nextBut = initBUT(xmlValue('close'), '');
				nextBut.position = nb_pos;
				nextBut.on('click', civCompleteButPrs).on('touchstart', civCompleteButPrs);
				completePopup.addChild(nextBut);
				
				if (autoplaying) setTimeout(civCompleteButPrs, 2000);
				function civCompleteButPrs() {
					if (mapDATAleaders) openLeaderboard(true, mapDATAleaders[mapDATAleaders.length-1].episode_id, mapDATAleaders[mapDATAleaders.length-1].episode_name);
					backToMap2();
				}
			} else if (autoplaying) {
				if (tutorialStep==1) setTimeout(backToMap2, 2000); else setTimeout(nextLevel2, 2000);
			}
		}
		
		
		
		function backToMap() {
			resetLevel();
			goMAP();
			stopSound('tickingNumber');
			quitPopup(completePopup);
		}
		function drawStars(hs, posY, ws, starz) {
			if (!starz) starz = jsonObject.stars;
			star1 = getAsset(starz>=1 ? 'starGold' : 'starGrey', ws ? ws : bg.width/4.8); //!!! size
			star2 = getAsset(starz>=2 ? 'starGold' : 'starGrey', ws ? ws*1.15 : bg.width/4.45);
			star3 = getAsset(starz>=3 ? 'starGold' : 'starGrey', ws ? ws : bg.width/4.8);
			star1.anchor.x = star1.anchor.y = 0.5;
			star2.anchor.x = star2.anchor.y = 0.5;
			star3.anchor.x = star3.anchor.y = 0.5;
			star1.position.x = centerX - star1.width*1.01;
			star2.position.x = centerX;
			star3.position.x = centerX + star3.width*1.01;
			star1.position.y = star3.position.y = posY ? posY : bg.height/3.6;
			star2.position.y = posY ? posY*0.95 : bg.height/4;
			
			var glow1,glow2,glow3;

			if (jsonObject.bestScore <= levelScore && hs!='no_highscore' && renderer.type==1) {
				// add glows under stars
				glow1 = getAsset('glow', bg.width/2.8);
				glow1.anchor.x = glow1.anchor.y = 0.5; glow1.position.x = star1.position.x; glow1.position.y = star1.position.y;
				glow1.rotation = Math.random() * 360;
				completePopup.addChild(glow1);
				glow2 = getAsset('glow', bg.width/2.4);
				glow2.anchor.x = glow2.anchor.y = 0.5; glow2.position.x = star2.position.x; glow2.position.y = star2.position.y;
				glow2.rotation = Math.random() * 360;
				completePopup.addChild(glow2);
				glow3 = getAsset('glow', bg.width/2.8);
				glow3.anchor.x = glow3.anchor.y = 0.5; glow3.position.x = star3.position.x; glow3.position.y = star3.position.y;
				glow3.rotation = Math.random() * 360;
				completePopup.addChild(glow3);
				glow1.visible = glow2.visible = glow3.visible = false;
			}
			glowRotate = setInterval(function() {
				if (glow1) {
					glow1.rotation += 0.05;
					glow2.rotation += 0.05;
					glow3.rotation += 0.05;
				}
				if (highscore && highscore.visible && highscore.glow && renderer.type==1) highscore.glow.rotation += 0.05;
			}, 30);
			completePopup.addChild(star1);
			completePopup.addChild(star2);
			completePopup.addChild(star3);
			
			star1.visible = star2.visible = star3.visible = false;
			// animate stars...
			setTimeout(function() {
				// show 1 star
				var w;
				if (star1) {
					w = star1.width;
					star1.visible = true; 	if (glow1) glow1.visible = true;
					star1.alpha = 0.2; star1.width = star1.height = w*0.2;
					TweenLite.to(star1, 0.45, {alpha:1, width:w, height:w});
					if (starz>=1 && renderer.type==1) {
						var sheet1 = getSheet('starsExplose');
						makeSheet(sheet1, w*1.3, false, 0.5, star1.position.x, star1.position.y, 300, true);
						completePopup.addChild(sheet1);
					}
					setTimeout(function() {
						// show 2 star
						if (star2) {
							w = star2.width;
							star2.visible = true; 	if (glow2) glow2.visible = true;
							star2.alpha = 0.2; star2.width = star2.height = w*0.2;
							TweenLite.to(star2, 0.45, {alpha:1, width:w, height:w});
							if (starz>=2 && renderer.type==1) {
								var sheet2 = getSheet('starsExplose');
								makeSheet(sheet2, w*1.3, false, 0.5, star2.position.x, star2.position.y, 300, true);
								completePopup.addChild(sheet2);
							}
							setTimeout(function() {
								// show 3 star
								if (star3) {
									w = star3.width;
									star3.visible = true; 	if (glow3) glow3.visible = true;
									star3.alpha = 0.2; star3.width = star3.height = w*0.2;
									TweenLite.to(star3, 0.45, {alpha:1, width:w, height:w});
									if (starz==3 && renderer.type==1) {
										var sheet3 = getSheet('starsExplose');
										makeSheet(sheet3, w*1.3, false, 0.5, star3.position.x, star3.position.y, 300, true);
										if (completePopup) completePopup.addChild(sheet3);
									}
									setTimeout(function() {
										
										// draw highscore clip
										if (hs!='no_highscore' && highscore.visible) {
											// add highscore elements...
											
											var wh = best==1 ? stageH*0.36 : stageH*0.38;
											var bgh = getAsset(best==1 ? 'blue_badge_highscore' : 'blue_badge1', 'auto', wh);
											bgh.anchor.x = bgh.anchor.y = 0.5;
											var tt = createText(highscore.txt_t1, {fontSize:17, color:"yellow", x:0, y:wh*0.075, width:wh*0.46, multiline:true});
											highscore.alpha = 0; highscore.width=wh*0.39; highscore.height=wh*0.39;
											highscore.addChild(bgh);
											
											
											// add glow
											var glowh = getAsset('glow', wh*0.8);
											glowh.anchor.x = glowh.anchor.y = 0.5;
											glowh.position.x = -wh*0.1; glowh.position.y = -wh*0.166;
											highscore.glow = glowh;
											highscore.addChild(glowh);
											
											// add dragon spritesheet
											var dragon = getSheet('dragonHappy');
											makeSheet(dragon, wh*0.55, false, 0.5, glowh.position.x, glowh.position.y, 0);
											highscore.addChild(dragon);
											
											highscore.addChild(tt);
											TweenLite.to(highscore, 0.3, {alpha:1, width:wh*1.2, height:wh*1.2, onComplete:function() {
												if (highscore) TweenLite.to(highscore, 0.1, {width:wh, height:wh});
											}});
										
											if (completePopup) completePopup.addChild(highscore);
											
										}
										
									}, 410);
								}
							}, 300);
						}
					}, 300);
				}
			}, 400);
		}
	}	
		
	
	
	
	function getRandomTxt(txtId, nr) {
		var r = parseInt(Math.random()*nr)+1;
		return xmlValue(txtId + r);
	}
	function tickNumber(t, n, delay, withcomma, textBefore, textAfter, clpAfter) {
		if (completePopup==null || completePopup.quitting) return;
		withcomma = typeof withcomma !== 'undefined' ? withcomma : false;
		textBefore = typeof textBefore !== 'undefined' ? textBefore : '';
		textAfter = typeof textAfter !== 'undefined' ? textAfter : '';
		clpAfter = typeof clpAfter !== 'undefined' ? clpAfter : null;
		
		t.visible = false;
		if (clpAfter) clpAfter.visible = false;
		setTimeout(	function () {
			// start ticking
			if (t && !stopTicking) {
				t.visible = true;
				if (clpAfter) clpAfter.visible = true;
				var tick = 0;
				var showTxt;
				var totalTicks = 40;
				if (n>4) {
					var n_part = n/(totalTicks+1);
					var showNr = parseInt(n_part);
					
					var si = setInterval(tickF, 20);
					if (completePopup && completePopup.quitting!=true && !stopTicking) playSound('tickingNumber', 100);
					function tickF() {
						tick++;
						showTxt = withcomma ? commaNumber(showNr) : String(parseInt(showNr));
						
						if (t) updateTxt(t, textBefore + showTxt + textAfter);
						if (tick==totalTicks) {
							if (t) {
								showTxt = withcomma ? commaNumber(n) : String(n);
								updateTxt(t, textBefore + showTxt + textAfter);
							}
							clearInterval(si);
						}
						showNr += n_part;
					}
				} else {
					updateTxt(t, textBefore + n + textAfter);
				}
			}
		}, delay);
	}
	function commaNumber(nr) {
		return String(nr).replace( /\d{1,3}(?=(\d{3})+(?!\d))/g , "$&,");
	}
	function stopBlinkingVideoIcon() { completePopup.blinkingIcon = null; }
}