function goMAP(ft) {
	firsttime = ft;
	// remove game and game elements
	removeGame();
	removeAllChilds(gameBG);
	
	if (MAP==null) {
		MAP = new PIXI.Container();
		MAP.position.y = 0;
		// map containers
		mapBG = new PIXI.Container();
		MAP.addChild(mapBG);
		pinContainer = new PIXI.Container();
		MAP.addChild(pinContainer);
		mapContainer.addChild(MAP);
		toScrollPinWAS = -1;
		
		// temporary ****************************************************
		if (dev) {
			tmp_render_version_text = createText('render: '+(renderer.type==1 ? 'WebGl' : 'Canvas'), {fontSize:12, x:660, y:420, width:120});
			tmp_render_version_text.anchor.x = 0;
			mapContainer.addChild(tmp_render_version_text); 
			fps_text = createText('', {fontSize:10, x:10, y:55, width:130});
			fps_text.anchor.x = 0;
			stage.addChild(fps_text); 
			
			var renderBut = initBUT('change render','red'); renderBut.scale.set(0.5);
			renderBut.position.x = 660;
			renderBut.position.y = 430;
			mapContainer.addChild(renderBut);
			renderBut.on('click', switchRender);
			
			var downBut = initBUT('Map Down','red'); downBut.scale.set(0.5);
			downBut.position.x = 100;
			downBut.position.y = 565;
			mapContainer.addChild(downBut);
			downBut.on('click', function() {
				mapPosition='goPinWAS';
				if (mapDATA[0]) pinWas = {nr:0, stars:mapDATA[0].stars, best:mapDATA[0].bestOfFriends};
				refreshMap(mapDATA.length>=78 ? 78 : mapDATA.length-1);
			});
		}
		if ((dev || completeButton) && developer == 'yes,itsme') placeAutoplay();
	}
	MAP.visible = true;
	
	if (!firsttime) setTimeout(memoryGarbage,2600);
	
	
	if (ft && sandBoxId>0) {baseLoader_loadPercent(95); refreshMapJson();}
	else if (completePopup==null) {
		refreshTopData(ft); // refreshMap() is within refreshTopData.
	}
}


var fullMapLoaded = false;
function refreshMapJson(full, mov, id, prg) {
	// refresh jsonData and map.
	if (full>0) addLoader();
	serverSend('/api/getlevels'+(full>0 ? '&fullMap=1' : ''), function(jo) {
		jsonObject = jo;
		pinRefreshNeeded = true;
		
		// refresh if pressed map dpwn...
		if (full>0) {
			mapDATA = jsonObject.levels;
			mapBGs = jsonObject.maps;
			fullMapLoaded = true;
		}
		
		if (full==1) {
			// refresh if pressed map dpwn...
			refreshMap( prevPinById(id) );
			return;
		}
		else if (full==2) {
			// achievements load map and jump to pin.
			var nr = -1;
			for (var i = 0; i<mapDATA.length; i++) {
				if (mapDATA[i].episode_id && mapDATA[i].episode_id*1 == id && mapDATA[i].type=='normal' && prg>0) {nr=i; break;}
			}
			// pressing pin and go to map level ID
			if (nr>=0) {
				var togo = toScrollPin;
				for (var i = nr; i<mapDATA.length; i++) {
					if (mapDATA[i].type == 'questpos') {togo = prevPin(i); mapPosition='goPinWAS'; break;} // upper map pos.
					else if (mapDATA[i].type == 'normal' && mapDATA[i].stars == 0) {mapPosition='home'; totalPins = 0; break;} // go home
				}
				pinWas = {nr:nr, stars:mapDATA[nr].stars, best:mapDATA[nr].bestOfFriends};
				refreshMap(togo);
			}
			return;
		}
		// don't move map.
		mapPosition = 'nochange';
		if (!completePopup) pinWas = null;
		refreshTopData(); // refreshMap() is within refreshTopData.
		
	}, function(error) {
		disconnect('Getlevel data error, refresh page');
	});
}
function refreshMap(arg) {
	log('refresh map '+toScrollPinWAS+' / '+arg+' / '+mapPosition);
	if (hinta) hideHint();
	
	if (mapDATA==null) return;
	
	// calculate map part height
	var i, fromScrollPin = 0, fromBG,toBG,uppertoScrollPin,maxYBG,pinActive;
	toScrollPin = -1;
	var totalPins = mapDATA.length;
	
	var allcompleted = mapDATA.allcompleted==1 || mapDATA[totalPins-1].stars>0 || mapDATA[totalPins-2].stars>0 && mapDATA[totalPins-1].type=='victory';
	
	uppertoScrollPin = mapDATA.length-1;
	toScrollPin = totalPins-1;
	
	haveBoxhunt = false;
	for (i=mapDATA.length-1; i>0; i--) {
		if (mapDATA[i].box) {haveBoxhunt=true; break;}
	}
	log('haveBoxhunt='+haveBoxhunt);
	if (toScrollPinWAS>=0 && pinWas && (mapPosition==undefined || mapPosition=='')) toScrollPin=toScrollPinWAS; // played older level in other map location...
	if (toScrollPinWAS>=0 && mapPosition=='nochange') {toScrollPin=toScrollPinWAS; mapPosition='';}
	
	// scroll map up or down by buttons
	if ( arg!=undefined && arg>=0) {
		toScrollPinWAS = -1;
		toScrollPin = arg;
		// find now scrollpos (arg can be 20, but need 75)
		while (mapDATA[toScrollPin] && mapDATA.length>toScrollPin && mapDATA[toScrollPin].type != 'scrollpos') toScrollPin++;
	}
	while (toScrollPin>=0 && mapDATA[toScrollPin] && (mapDATA[toScrollPin].type == 'scrollpos' || mapDATA[toScrollPin].type == 'questpos')) toScrollPin--;
	
	for (i = toScrollPin-4; i>0; i--) {
		if (mapDATA[i].type == 'scrollpos') {fromScrollPin=i-1; break;}
	}
	while (fromScrollPin<totalPins && mapDATA[toScrollPin] && (mapDATA[fromScrollPin].type == 'scrollpos' || mapDATA[fromScrollPin].type == 'questpos')) fromScrollPin++;
	
	for (i = toScrollPin+4; i<totalPins; i++) {
		if (mapDATA[i].type == 'scrollpos') {uppertoScrollPin=i-1; break;}
	}
	while (uppertoScrollPin>=0 && mapDATA[uppertoScrollPin].type == 'scrollpos' || mapDATA[uppertoScrollPin].type == 'questpos') uppertoScrollPin--;
	
	toBG = -9999999;		// top pin
	fromBG = 9999999;    	// bottom pin
	// min max pins
	if (toScrollPin>=mapDATA.length) toScrollPin = mapDATA.length-1;
	for (i = fromScrollPin; i<=toScrollPin; i++) {
		if (fromBG > mapDATA[i].y*1) fromBG = mapDATA[i].y*1;
		if (toBG < mapDATA[i].y*1) toBG = mapDATA[i].y*1;
	}
	log('!! fromBG='+fromBG+'   toBG='+toBG);
	
	// max BG positions
	for (i = mapBGs.length-1; i>0; i--) {
		if (mapBGs[i].y>=toBG+100 && mapBGs[i-1].y<=toBG+100) {toBG = mapBGs[i].y; break;}
	}
	
	//log('toScrollPinWAS = '+toScrollPinWAS+' toScrollPin='+toScrollPin+'   uppertoScrollPin='+uppertoScrollPin);
	log('refresh map fromScrollPin = '+mapDATA[fromScrollPin].ord+' toScrollPin='+mapDATA[toScrollPin].ord);
	var drawed = true;
	
	// map refreshing methods
	log('pinRefreshNeeded='+pinRefreshNeeded);
	log('mapHeight='+mapHeight);
	
	
	if (sandBoxId>0) {selLevel(sandBoxId, false, false);}
	else if (toScrollPinWAS != toScrollPin) drawAllBg(); 
	else if (pinRefreshNeeded) drawPins();
	else if (showOfferFirsttime && offerData && playedOnce) openOffer();
	
	if (!pinRefreshNeeded && currentMusic!=1) playMusic(1);
	
	
	if (!pinRefreshNeeded) {
		// gifts tick interval!
		startTickingGifts();
	}
	function startTickingGifts() {
		if (mapGiftTickInterval) clearInterval(mapGiftTickInterval);
		mapGiftTickInterval = setInterval(function() {
			if (!GAME && mapgiftGlows[0]) {
				// tick map gift timer...
				if (mapgiftGlows[0].tickTimer>0) {
					var tck = mapgiftGlows[0].tickTimer;
					mapgiftGlows[0].tickTimer-=0.05;
					var tck2 = parseInt(mapgiftGlows[0].tickTimer);
					if (parseInt(tck)>tck2) {
						updateTxt(mapgiftGlows[0].mapGiftTimer, convertToTime(tck2,true));
						if (tck2<=0) refreshMapJson();
					}
				}
				if (renderer.type==1) {
					for (var i in mapgiftGlows) mapgiftGlows[i].glowGift.rotation += 0.02;
				}
			}
		},50);
	}
	// draw BG-s ---------------------------------------------------------------
	function drawAllBg() {
		drawed = false;
		removeAllChilds(pinContainer);
		if (MAP.lowerClouds) {MAP.removeChild(MAP.lowerClouds); MAP.removeChild(MAP.prevWBut); MAP.lowerClouds=null;}
		if (MAP.upperClouds) {MAP.removeChild(MAP.upperClouds); MAP.removeChild(MAP.nextWBut); MAP.upperClouds=null;}
		
		if (mapBGs.length>0) {
			mapHeight = 0;
			firstBG_height = 0;
			addLoader();
			removeAllChilds(mapBG);
			maxYBG = 0;
			var loaded = 0;
			hidedCivsHeight = 0;
			var bgs = [];
			//log('load backgrounds from '+fromBG+' to '+toBG);
			for (var d = 0; d < mapBGs.length; d++) {
				if (mapBGs[d].y > fromBG-150 && mapBGs[d].y < toBG+260) {
					
					var clp = new PIXI.Sprite.fromImage(mapBGs[d].pic);
					clp.visible = false;
					if (hidedCivsHeight==0) hidedCivsHeight = mapBGs[d].y;
					bgs.push(clp);
					if (mapBGs[d].y > maxYBG) maxYBG = mapBGs[d].y;
					clp.position.y = stageH - mapBGs[d].y + hidedCivsHeight;
					//clp.position.x = xx; xx+=40;
					//log('load '+(d+1)+'  '+mapBGs[d].y+'<'+(toBG+150));
					mapBG.addChild(clp);
				}
			}
			var realLength = 0;
			for (var i in bgs) {
				realLength++;
			}
			for (var q=0; q<realLength; q++) {
				if (bgs[q].texture.baseTexture.hasLoaded==true) bg_loaded(bgs[q].texture.baseTexture);
				else bgs[q].texture.baseTexture.on('loaded', bg_loaded).on('error', function() {
					bgs[q] = getAsset('defaultThumb', stageW); bg_loaded();
				});
			}
				
			function bg_loaded(e) {
				loaded++;
				
				if (firsttime==true) baseLoader_loadPercent(loaded/realLength*(100-85) + 85);
				
				if (loaded==realLength) {
					firstBG_height = bgs[0].height;
					MAP.firstBG_height = firstBG_height;
					for (var q=0; q<realLength; q++) {
						bgs[q].position.y -= firstBG_height;
						bgs[q].visible = true;
						//log('bg '+(q+1)+'pos = from '+bgs[q].position.y+' to '+(bgs[q].position.y+bgs[q].height)+' y='+mapBGs[q].y);
					}
					mapHeight = -bgs[realLength-1].position.y;
					removeLoader();
					if (firsttime==true) setTimeout(drawPins, 150); else drawPins(); // just to see loader on 100%.
				}
			}
			// base loader...
			
		} else drawPins();
	}
	
	
	
	function drawPins() {
		log('draw pins');
		if (mapGiftTickInterval) {clearInterval(mapGiftTickInterval); mapGiftTickInterval=null;}
		
		removeAllChilds(pinContainer);
		
		homemap = false;
		var nextLev = allcompleted ? totalPins-1 : 0;
		var minY = 0;
		
		if (allcompleted && toScrollPin>totalPins-2) mapDATA[toScrollPin].type = 'victory';
		
		// find my pin pos
		myMapPos = 0;
		for (var z = 0; z<mapDATA.length; z++) {
			if (z==0 && tutorialStep==1 || z>0 && mapDATA[prevPin(z)].stars>0 && mapDATA[z] && mapDATA[z].stars==0) {myMapPos=z; break;}
		}
		if (myMapPos==0 && mapDATA[myMapPos].type!='normal' && !fullMapLoaded) myMapPos = nextPin(-1);
		
		
		// LEADERS
		var civ = -1;
		for (var j = 0; j<toScrollPin+2 && mapDATA.length>14 && mapDATA[14].stars>0; j++) {
			//log(mapDATA[j].ord+'   '+mapDATA[j].type);
			if (mapDATA[j] && mapDATA[j].type == 'questpos' && mapDATA[prevPin(j)].stars>0) {
				civ++;
				//log('new civ '+civ);
				//log(mapDATAleaders[civ]);
				if (j>fromScrollPin && mapDATAleaders[civ] && mapDATAleaders[civ].pic) {
					
					//log(civ+' / '+mapDATA[j].ord);
					
					var leaderIcon = new PIXI.Container();
					var leaderAsset = getAsset('mapLeader', stageW*0.162);
					leaderAsset.anchor.x = leaderAsset.anchor.y = 0.5;
					var leaderThumb = new PIXI.Sprite();
					leaderThumb.anchor.x = leaderThumb.anchor.y = 0.5;
					leaderThumb.position.y = -leaderAsset.height*0.16;
					
					var leaderpic = mapDATAleaders[civ].pic;
					for (var ii in mapDATAleaders) {
						if (mapDATAleaders[ii].episode_id == mapDATA[prevPin(j)].episode_id) {
							leaderpic = mapDATAleaders[ii].pic;
							break;
						}
					}
					makeFaceURL(leaderThumb, leaderpic, false, 0);
					leaderThumb.scale.x = leaderThumb.scale.y = 1.2;
					leaderThumb.nr = j;
					
					var txt_leader = createText(xmlValue('civLeader'), {fontSize:14, autoResize:true, width:leaderAsset.width*0.8, x:0, y:0});
					txt_leader.rotation = -Math.PI/180*7;
					txt_leader.position.y = leaderAsset.height * 0.07;
					
					var xL = mapDATA[nextPin(j)].x*1;
					leaderIcon.position.x = parseInt(xL - (xL - mapDATA[prevPin(j)].x*1)/1.75);
					var yL = parseInt(hidedCivsHeight - mapDATA[nextPin(j)].y*1 + stageH - firstBG_height);
					leaderIcon.position.y = parseInt(yL - (yL - parseInt(hidedCivsHeight - mapDATA[prevPin(j)].y*1 + stageH - firstBG_height))/1.75);
					leaderThumb.interactive = leaderThumb.buttonMode = true;
					leaderThumb.on('click', clickLeaderboard).on('touchstart', clickLeaderboard);
					
					leaderIcon.addChild(leaderThumb);
					leaderIcon.addChild(leaderAsset);
					leaderIcon.addChild(txt_leader);
					pinContainer.addChild(leaderIcon);
				}
			}
		}
		function clickLeaderboard() {
			var nr = prevPin(this.nr);
			openLeaderboard(false, mapDATA[nr].episode_id, mapDATA[nr].episode_name || "");
		}
		totalMapGifts = 0;
		mapgiftGlows = [];
		for (var i = fromScrollPin; i<=toScrollPin; i++) { //-(toScrollPin<mapDATA.length-3 ? 1 : 0) ??????????
			if (mapDATA[i].type != 'scrollpos' && mapDATA[i].type != 'questpos') addPin(i, mapDATA[i]);
		}
		pinRefreshNeeded = false;
		
		
		function addPin(i, obj, animating) {
			var lev;
			var future = false;
				
			if (i==myMapPos && animating!='animate_nextpin') {
				// active (current) level
				lev = getAsset(obj.type == 'victory' ? 'pin_victory' : 'pin', stageW*0.1);
				lev.best = false;
				lev.nr = i;
				nextLev = i;
				pinActive = lev;
				homemap = true;
				
				var sheet = getSheet('activePin');
				makeSheet(sheet, 450*assetsRatio[obj.type == 'victory' ? 'pin_victory' : 'pin'], true, 0.5, 0, 0);
				lev.addChild(sheet);
			}
			else if (obj.stars>0 && animating!='animate_nextpin') {
				// done levels
				lev = getAsset(obj.bestOfFriends==1 ? 'pin_1st' : 'pin', stageW*0.1);
				lev.best = obj.bestOfFriends==1;
				lev.nr = i;
				drawPinStars(lev, mapDATA[i].stars);
				
			} else {
				// future levels
				lev = getAsset(obj.type=='victory' ? 'pin_victory_future' : 'pin_future', stageW*0.1);
				future = true;
			}
			
			lev.anchor.x = lev.anchor.y = 0.5;
			lev.id = obj.id;
			lev.nr = i;
			//lev.episode = obj.episode_id;
			lev.quest = obj.type;
			lev.thumb = obj.thumb;
			lev.points = obj.points;
			lev.stars = obj.stars;
			lev.position.x = obj.x*1;
			lev.position.y = parseInt(hidedCivsHeight - obj.y*1 + stageH - firstBG_height);
			if (lev.position.y-100 < minY && !future) minY = lev.position.y-100;
			
			pinContainer.addChild(lev);
			
			if (!future) {
				if (obj.type != 'victory') {
					var txt = createText(obj.ord, {fontSize:String(obj.ord).lentgh>3 ? 17 : 19, stroke:5, width:lev.width*0.9, x:lev.position.x, y:lev.position.y - lev.height*0.05});
					pinContainer.addChild(txt);
				}
				lev.interactive = lev.buttonMode = true;
				lev.on('mousedown', pinDown).on('mouseup', pinClicked).on('touchstart', pinDown).on('touchend', pinClicked);
			}
			lev.action = '';
			
			// add gifts to pins
			if (obj.box) {
				totalMapGifts++;
				lev.giftdata = obj.box;
				showGiftbox(lev);
				if (animating=='animate_nextpin' && lev.butClaimGift) lev.butClaimGift.visible = false;
			}
			
			//    ***  **  * draw
			function drawPinStars(pin, stars) {
				var oldStars = pinWas && pinWas.nr==pin.nr ? pinWas.stars : stars;
				
				// draw old pin stars...
				var w = pin.best ? 87 : 77;
				w *= assetsRatio[pin.assName];

				var star1 = getAsset(oldStars>0 ? 'mapStarGold' : 'mapStarGrey', w);
				var star2 = getAsset(oldStars>1 ? 'mapStarGold' : 'mapStarGrey', w*1.1);
				var star3 = getAsset(oldStars==3 ? 'mapStarGold' : 'mapStarGrey', w);
				star1.anchor.x = star1.anchor.y = star2.anchor.x = star2.anchor.y = star3.anchor.x = star3.anchor.y = 0.5
				star1.position.x = pin.best ? -62*assetsRatio[pin.assName] : -57*assetsRatio[pin.assName]; star1.position.y = pin.best ? -80*assetsRatio[pin.assName] : 67*assetsRatio[pin.assName];
				star2.position.x = 0; star2.position.y = pin.best ? -88*assetsRatio[pin.assName] : 70*assetsRatio[pin.assName];
				star3.position.x = pin.best ? 62*assetsRatio[pin.assName] : 57*assetsRatio[pin.assName]; star3.position.y = pin.best ? -80*assetsRatio[pin.assName] : 67*assetsRatio[pin.assName];
				pin.addChild(star1);
				pin.addChild(star3);
				pin.addChild(star2);

				
				// animate stars on pin...
				if (oldStars<stars) {
					setTimeout(function() {animateStar(oldStars+1);}, 400);
				}
				function animateStar(s) {
					var target = star1;
					if (s>1) target = s==2 ? star2 : star3;
					var w = target.width;
					var star = getAsset('mapStarGold', w);
					star.position = target.position;
					star.anchor = target.anchor;
					star.width = star.height = w/3;
					star.alpha = 0.2;
					target.parent.addChild(star);
					TweenLite.to(star, 0.15, {width:w*1.5, height:w*1.5, alpha:1, onComplete:function(){
						TweenLite.to(star, 0.15, {width:w, height:w});
					}});
					if (s<stars) setTimeout(function() {animateStar(s+1);}, 400);

				}
			}
			if (animating=='animate_nextpin') return lev;
		}
		var touchup = false, mouseXY;
		function pinDown(e) {
			mouseXY = {x:e.data.global.x, y:e.data.global.y};
			touchup = true;
			startDrag(e);
		}
		function pinClicked(e) {
			stopDrag();
			if (!touchup) return;
			touchup = false;
			//!!!if (rut.anime==null) {
				pinWas = {nr:this.nr, stars:this.stars, best:this.best};
				
				if (tutorialStep==1) analytics('/api/analytics?code=tutorialStep_1.1');
				else if (tutorialStep==2) analytics('/api/analytics?code=tutorialStep_5.2');
				
				// move map to active pin
				setTimeout(function() {
					if (pinWas) {
						var moveMapTo = poz(mapDATA[pinWas.nr].y);
						if (moveMapTo<0) moveMapTo=0;
						if (moveMapTo>mapHeight) moveMapTo=mapHeight;
						TweenLite.to(MAP, 0.5, {y:moveMapTo});
					}
				}, 300);
				
				if (this.quest == 'victory') {
					addVictoryPopup(); // in likePopup js
				}
				else if (this.quest == 'quest') {
					questType = true;
					alert('popup quest - not supported'); //!!!
				} else {
					// start playing level
					questType = false;
					thumbImage = this.thumb;
					if (this.action!='') {
						openMapGiftPopup(this.action);
						if (this.butClaimGift) this.butClaimGift.visible = false;
					} else selLevel(this.id);
				}
				restartNothingTimer();
			//}
		}
		
		
		/*/ redraw clouds -------------------------------------
		minY = -minY;
		// remove old clouds
		for (var old_cloud=0; old_cloud<cloudsArray.length; old_cloud++) {
			MAP.removeChild(cloudsArray[old_cloud]);
		}
		cloudsArray = [];
			
		if (mapHeight>0 && minY<mapHeight && toScrollPin >= mapDATA.length-3) {
			var alpha = 1;
			var downPos = minY + 50;
			for (var y_from = mapHeight+50; y_from > downPos; y_from-=50) {
				if (y_from < downPos+5*50) alpha-=1/6;
				for (var x_from=-100; x_from<stageW; x_from+=stageW/12) {
					var cloud = getAsset(Math.random()*100<50 ? 'cloud1' : 'cloud2', stageW*0.15 + Math.random()*stageW*0.15);
					cloud.alpha = alpha<0 ? 0 : alpha;
					cloud.position = {x:x_from, y:-y_from};
					cloud.speed = Math.random()/2;
					MAP.addChild(cloud);
					cloudsArray.push(cloud);
				}
			}
		}*/
		
		
		// drag map! --------------------------------------------------
		var drag = false;
		mapBG.interactive = true;
		mapBG.on('mousedown', startDrag).on('touchstart', startDrag).on('mouseup', stopDrag).on('touchend', stopDrag).on('mousemove',mouseMov).on('touchmove',mouseMov).on('mouseupoutside', stopDrag).on('touchendoutside', stopDrag);
		var startDragPosY;
		function startDrag(e) {restartNothingTimer(); drag = true; startDragPosY = MAP.position.y - e.data.global.y*1.4;}
		function mouseMov(e) {
			if (MAP && drag) {
				
				if (mouseXY && (Math.abs(e.data.global.y - mouseXY.y)>25 || Math.abs(e.data.global.x - mouseXY.x)>25)) touchup = false;
				
				if (!touchup) {
					TweenLite.to(MAP, 0.3, {y:limitMapPos( startDragPosY + e.data.global.y*1.5 )});
				}
			}
		}
		function stopDrag() {restartNothingTimer(); drag = false; mouseXY = null;}
		
		
		
		// up / down map buttons--------------------------------------------------------------------------------
		if (MAP.lowerClouds) {MAP.removeChild(MAP.lowerClouds); MAP.removeChild(MAP.prevWBut); MAP.lowerClouds=null;}
		if (MAP.upperClouds) {MAP.removeChild(MAP.upperClouds); MAP.removeChild(MAP.nextWBut); MAP.upperClouds=null;}
		
		if ( toScrollPin < mapDATA.length-3) {
			// up scroll visible
			var upperClouds = getAsset('cloudsmap', stageW);
			upperClouds.height = stageH*0.28;
			upperClouds.position.y = -mapHeight;
			var nextWBut = getAsset('nextWorld', stageW*0.1);
			nextWBut.anchor.x = nextWBut.anchor.y = 0.5;
			nextWBut.position.x = stageW/2;
			nextWBut.position.y = -mapHeight + stageH*0.15;
			nextWBut.interactive = nextWBut.buttonMode = true;
			nextWBut.on('click', goUp).on('touchstart', goUp);
			MAP.addChild(upperClouds);
			MAP.addChild(nextWBut);
			MAP.upperClouds = upperClouds;
			MAP.nextWBut = nextWBut;
			
			makeHint(nextWBut, xmlValue('hint_move_nextCiv'), 'BL', stageW*0.12, nextWBut.width/2, 0);
		}
		if ( mapDATA[0].ord*1>1 && fromScrollPin==0 || fromScrollPin>0) {
			// down scroll visible
			var lowerClouds = getAsset('cloudsmap', stageW);
			lowerClouds.height = stageH*0.22;
			lowerClouds.rotation = Math.PI;
			lowerClouds.position.x = stageW;
			lowerClouds.position.y = stageH;
			var prevWBut = getAsset('prevWorld', stageW*0.1);
			prevWBut.anchor.x = prevWBut.anchor.y = 0.5;
			prevWBut.position.x = stageW/2;
			prevWBut.position.y = stageH*0.92;
			prevWBut.interactive = prevWBut.buttonMode = true;
			prevWBut.on('click', goDown).on('touchstart', goDown);
			MAP.addChild(lowerClouds);
			MAP.addChild(prevWBut);
			MAP.lowerClouds = lowerClouds;
			MAP.prevWBut = prevWBut;
			
			makeHint(prevWBut, xmlValue('hint_move_prevCiv'), 'TL', stageW*0.12, prevWBut.width/2, 0);
		}
		
		//---------------------------		
		// THUMBS pos...
		// ME
		// !!! pinActive not defined if not refreshing pins...
		// need to store cur pos as global??
		
		var myFace = new PIXI.Sprite();
		makeFaceURL(myFace, myData.pic, false, 0); 
	
		placeFace(myFace, myMapPos, mapDATA[myMapPos].userpos);
		var orX = myFace.position.x;
		var orY = myFace.position.y;
		myFace.visible = tutorialStep==0 && pinActive;
	
		// animate my face to next level
		if ((!hallOfFamePopup || hallOfFamePopup.quitting==true) && tutorialStep==0 && pinWas && pinWas.stars==0 && pinActive && pinActive.nr == nextPin(pinWas.nr)) {
			if (pinActive.gft) removeGiftbox(pinActive);
			pinContainer.removeChild(pinActive);
			var pa = addPin(myMapPos, {ord:'', stars:0, type:"normal", x:mapDATA[myMapPos].x, y:mapDATA[myMapPos].y, box:mapDATA[myMapPos].box}, 'animate_nextpin'); // temporary furute pin
			
			placeFace(myFace, pinWas.nr, mapDATA[pinWas.nr].userpos);
			pinWas.stars = mapDATA[pinWas.nr].stars; // no animate after first time (civ changing)

			setTimeout(function() {
				TweenLite.to(myFace, 0.5, {x:orX, y:orY, onComplete:function() {
					pinContainer.removeChild(pa); pa=null;
					addPin(myMapPos, mapDATA[myMapPos]);
					if (makeNextLevel && animeclp==null && !havePopups && !offerPopup) setTimeout(startNextLev, 350);
				}});
				
				if (pinActive && pinWas && pinActive.nr != fromScrollPin) {
					var toY_next = MAP.position.y + (poz(mapDATA[pinActive.nr].y) - poz(mapDATA[pinWas.nr].y));
					toY_next = limitMapPos(toY_next);
					TweenLite.to(MAP, 0.5, {y:toY_next});
				}
				
			}, 1500);
		}
		function removeGiftbox(lev) {
			if (lev.butClaimGift) pinContainer.removeChild(lev.butClaimGift);
			if (lev.glowGift) pinContainer.removeChild(lev.glowGift);
			if (lev.gft) pinContainer.removeChild(lev.gft);
			if (lev.lint) {pinContainer.removeChild(lev.lint); pinContainer.removeChild(lev.mapGiftTimer);}
		}
		function showGiftbox(lev) {
			removeGiftbox(lev);

			lev.glowGift = getAsset('glow', stageW*0.27);
			mapgiftGlows.push(lev);
			
			var gft = getAsset('huntbox', stageW*(lev.giftdata.step==4 ? 0.1 : 0.089)+1);
			lev.gft = gft;
			lev.glowGift.anchor.x = lev.glowGift.anchor.y = gft.anchor.x = gft.anchor.y = 0.5;
			gft.position = lev.glowGift.position = lev.position;
			pinContainer.addChild(lev.glowGift);
			pinContainer.addChild(gft);
			lev.action = 'nextGift';
			// lint+timer or claim or nothing
			if (pinActive==lev) {
				lev.butClaimGift = initBUT(xmlValue('claim'),'green');
				lev.butClaimGift.interactive = false;
				lev.butClaimGift.position = gft.position;
				lev.butClaimGift.scale.set(0.55);
				lev.butClaimGift.position.x -= lev.butClaimGift.w/2*0.55;
				lev.butClaimGift.position.y += gft.height*0.27;
				pinContainer.addChild(lev.butClaimGift);
				lev.action = 'claim';
			}
			else if (!(makeNextLevel && myMapPos>=lev.nr)) {
				// clickable trunk to show gifts... //????
				gft.interactive = gft.buttonMode = true;
				gft.on('click', openFutureGift).on('touchstart', openFutureGift);
				function openFutureGift() {
					openMapGiftPopup('future');
				}
			}
			if (lev.giftdata.timeLeft>0) {
				lev.tickTimer = lev.giftdata.timeLeft;
				lev.lint = getAsset('mapGiftbox_ribbon', gft.width*1.46);
				lev.lint.anchor.x = lev.lint.anchor.y = 0.5;
				lev.lint.position = gft.position;
				lev.lint.position.y -= gft.height*0.35;
				pinContainer.addChild(lev.lint);
				lev.mapGiftTimer = createText(convertToTime(lev.tickTimer,true), {fontSize:10, color:"white", stroke:0, width:lev.lint.width*0.75, autoResize:true});
				lev.mapGiftTimer.position = lev.lint.position;
				lev.mapGiftTimer.position.y -= lev.lint.height*0.22;
				pinContainer.addChild(lev.mapGiftTimer);
				startTickingGifts();
			}
			if (!mapGifts) {
				// animate
				var gw=gft.width,gh=gft.height;
				gft.width *= 0.1; gft.height *= 0.1;
				gft.visible = false;
				if (lev.lint) {lev.lint.visible = lev.mapGiftTimer.visible = false;}
				lev.glowGift.alpha = 0;
				setTimeout(function() {
					if (gft && lev) {
						gft.visible = true;
						TweenLite.to(lev.glowGift,1,{alpha:1});
						TweenLite.to(gft,0.33,{width:gw*1.3,height:gh*1.3, onComplete:function() {
							if (lev.lint) {lev.lint.visible = lev.mapGiftTimer.visible = true;}
							if (gft) TweenLite.to(gft,0.21,{width:gw,height:gh});
						}});
					}
				}, 500*lev.giftdata.step);
			}
		}
		
		
		// FRIENDS
		for (var z = fromScrollPin; z<=toScrollPin; z++) {
			if (mapDATA[z].friendsOnPos) {
				var thumbData = mapDATA[z].friendsOnPos[mapDATA[z].friendsOnPos.length-1]; // object //NB! friendsOnPos array must be sorted so invited are behind uninvited.
				
				if (thumbData && thumbData.user_id != myData.id) {
					var thumb = new PIXI.Sprite();
					makeFaceURL(thumb, thumbData.pic, true, thumbData.invitable);
					placeFace(thumb, z, mapDATA[z].friendpos);
					// can send live to friend
					if (thumbData.invitable==1) {
						thumb.interactive = thumb.buttonMode = true;
						thumb.id = thumbData.user_id;
						thumb.on('click', sendLife).on('touchstart', sendLife);
					}
				}

			}
		}
		function placeFace(face, nr, pos) {
			if (face==null) return;
			for (var i in pinContainer.children) {
				var clp = pinContainer.children[i];
				if (clp.nr == nr) {
					face.position = clp.position;
					if (pos=='t') face.position.y -= faceSize*1.05;
					else if (pos=='r') face.position.x += faceSize*1.15;
					else if (pos=='b') face.position.y += faceSize*1.1;
					else if (pos=='l') face.position.x -= faceSize*1.15;
					if (mapDATA[nr].box) face.visible = false;
				}
			}
			pinContainer.addChild(face);
		}
		function sendLife() {
			sendJSRequest(this.id, "extraLife", 'jsExtraLifeLabel', 'jsExtraLifeDescription', []);
		}
		
		
		
		
		
		// MAP positioning...
		if (mapPosition=='movedUp') {
			MAP.position.y = 0;
		} else if (mapPosition=='movedDown') {
			MAP.position.y = mapHeight;
		} else if (mapPosition=='home' && pinActive) {
			MAP.position.y = poz(mapDATA[pinActive.nr].y);
		} else if (mapPosition=='goPinWAS' && pinWas) {
			MAP.position.y = poz(mapDATA[pinWas.nr].y);
		}
		if (MAP.position.y<0) MAP.position.y=0;
		if (MAP.position.y>mapHeight) MAP.position.y=mapHeight;
		mapPosition='';
		
		var nextNr = pinWas ? nextPin(pinWas.nr) : 0;
		var showOffer = showOfferFirsttime && offerData && playedOnce;
		if (makeNextLevel && animeclp==null && pinWas && (!pinActive || pinActive.nr!=nextNr)) {
			// just pressed NEXT if played already done level.
			if (showOffer && !firsttimeOfferPopup && !offerPopup) openOffer(); else setTimeout(startNextLev, 300);
		}
		
		
		if (tutorialStep==1) showTutorial('map');
		else playMusic(1);
		
		// have MAP.
		removeBaseLoader();
		removeLoader();
		drawed = true;
		
		
		function canDo() {
			if (tutorialStep==0) {
				if (firsttime && sandBoxId==0 && backStep==20) startFirstPopups();
				else if (showOfferFirsttime && offerData && playedOnce && !animeclp) setTimeout(openOffer, 180);
			}
		}
		if (firsttime) {
			canDo();
			
			// fps render check
			setTimeout(function() {
				tmp_timer = new Date();
				firsttime = false;
				mapGifts = true;
				
				// now starts loging average FPS
				setTimeout(switchCanvas, 800);
			}, 2000);
		}
		else if (jsonObject.boxhuntPopup==1 || needOpenBoxhunt) {
			setTimeout(function() {
				
				// show gitfs popup
				if (!havePopups) {
					if (makeNextLevel && nextNr) openMapGiftPopup('openNext', mapDATA[nextNr].id); else openMapGiftPopup('future');
				}
				
			}, 500*totalMapGifts+100);
		}
		needOpenBoxhunt = false;
	}
	
	
	
	// refresh map elements (top elements on map + right scroll buttons) **********************************************************
	//if (mapElements && animeclp) return;
	
	if (mapElements) {
		removeAllChilds(mapElements);
		mapContainer.removeChild(mapElements);
		removeAllChilds(soundContainer);
		removeAllChilds(mapNavArrows);
	}
	
	mapElements = new PIXI.Container();
	mapNavArrows = new PIXI.Container();
	mapNavArrows.interactive = true;
	var shadow = getAsset('mapShadow', stageW);
	shadow.height = stageH;
	shadow.interactive = false;
	mapElements.addChild(shadow);
	
	var coinsBG = getAsset('coins_map_bg', 'auto', stageH*0.076);
	coinsBG.anchor.y = 0.5;
	coinsBG.position.x = stageW*0.012;
	coinsBG.position.y = stageH*0.05;
	var coinsElement_shadow = makeShadow(coinsBG);
	mapElements.addChild(coinsElement_shadow);
	mapElements.addChild(coinsBG);
	var tm = createText(money, {fontSize:18, width:coinsBG.height*2.1, x:coinsBG.position.x + coinsBG.height*1.85, y:coinsBG.position.y});
	mapElements.t_money = tm;
	mapElements.addChild(tm);
	var addMoneyBut = getAsset('plusBut', parseInt(coinsBG.height*0.59/coinsBG.scale.y));
	mapElements.addMoneyBut = addMoneyBut;
	addMoneyBut.anchor.y = 0.49;
	addMoneyBut.position.x = coinsBG.width/coinsBG.scale.y*0.78;
	addMoneyBut.interactive = addMoneyBut.buttonMode = true;
	addMoneyBut.on('click', addMoney).on('touchstart', addMoney); // buy.js
	coinsBG.addChild(addMoneyBut);
	makeHint(coinsBG, xmlValue('hintCoins'), 'BR', stageW*0.2, -coinsBG.width/2,0);

	
	// music controls
	var musicControlsBG = getAsset('music_controls_bg', stageW*0.11);
	musicControlsBG.position.x = stageW*0.87;
	musicControlsBG.position.y = stageH*0.01;
	var musicControls_shadow = makeShadow(musicControlsBG);
	soundContainer.addChild(musicControls_shadow);
	soundContainer.addChild(musicControlsBG);
	
	var butW = musicControlsBG.width/3.8;
	getAsset('info_but_inactive', butW);
	var help_mc = getAsset('info_but', butW);
	mapElements.help_mc = help_mc;
	getAsset(sndOff ? 'sound' : 'sound_inactive', butW);
	getAsset(musicOff ? 'music' : 'music_inactive', butW);
	var sound_mc = getAsset(sndOff ? 'sound_inactive' : 'sound', butW);
	var music_mc = getAsset(musicOff ? 'music_inactive' : 'music', butW);
	mapElements.sound_mc = sound_mc;
	mapElements.music_mc = music_mc;
	
	help_mc.interactive = sound_mc.interactive = music_mc.interactive = 
	help_mc.buttonMode = sound_mc.buttonMode = music_mc.buttonMode = true;
		
	help_mc.anchor.x = sound_mc.anchor.x = music_mc.anchor.x = 0.5;
	help_mc.anchor.y = sound_mc.anchor.y = music_mc.anchor.y = 0.5;
	help_mc.position.y = sound_mc.position.y = music_mc.position.y = musicControlsBG.position.y + musicControlsBG.height/2;
	music_mc.position.x = musicControlsBG.position.x + musicControlsBG.width*0.2;
	sound_mc.position.x = musicControlsBG.position.x + musicControlsBG.width*0.5;
	help_mc.position.x = musicControlsBG.position.x + musicControlsBG.width*0.8;
	
	soundContainer.addChild(help_mc);
	soundContainer.addChild(sound_mc);
	soundContainer.addChild(music_mc);
	
	makeHint(help_mc, xmlValue('hintHelp'), 'LB', stageW*0.12, help_mc.width/2,help_mc.height/3);
	makeHint(music_mc, xmlValue('hintMusic'), 'LB', stageW*0.12, music_mc.width/2,music_mc.height/3);
	makeHint(sound_mc, xmlValue('hintSound'), 'LB', stageW*0.12, sound_mc.width/2,sound_mc.height/3);
	
	help_mc.on('click', prsInfo).on('touchstart', prsInfo);
	sound_mc.on('click', toggleSound).on('touchstart', toggleSound);
	music_mc.on('click', toggleMusic).on('touchstart', toggleMusic);
	
	function prsInfo() {
		//removeAllChilds(help_mc);
		help_mc.texture = assets.resources['info_but_inactive'].texture;
		help_mc.scale.set(help_mc.scale.x*assetsRatio['info_but']/assetsRatio['info_but_inactive']);
		openHelp();
	}
	
	
	// lives
	var livesBG = getAsset('lives_bg', stageW*0.195);
	livesBG.anchor.y = 0.5;
	livesBG.position.x = stageW*0.22;
	livesBG.position.y = stageH*0.05;
	var livesElement_shadow = makeShadow(livesBG);
	mapElements.addChild(livesElement_shadow);
	mapElements.addChild(livesBG);
	var tl = createText(lives, {fontSize:19, width:livesBG.width*0.2, x:livesBG.position.x + livesBG.width*0.17, y:livesBG.position.y});

	if (lives >= 0) mapElements.addChild(tl);
	var addLivesBut = getAsset(nextLiveTime>0 && lives >= 0 ? 'plusBut' : 'plusBut_disabled', parseInt(livesBG.height*0.6/livesBG.scale.y));
	addLivesBut.interactive = addLivesBut.buttonMode = nextLiveTime>0 && lives >= 0;
	addLivesBut.anchor.y = 0.5;
	addLivesBut.position.x = livesBG.width*0.78/livesBG.scale.y;
	addLivesBut.on('click', makeLivesPopup).on('touchstart', makeLivesPopup);
	livesBG.addChild(addLivesBut);
	makeHint(livesBG, (lives < 0 ? xmlValue('hintPermanentLives') : (jsonObject.lives>=maxLives ? xmlValue('hintLivesFull') : xmlValue('hintGetLives'))), 'BR', stageW*0.2, -livesBG.width/2,0);
	
	if (livesTimer) clearInterval(livesTimer); livesTimer=null;
	var tlt = createText(nextLiveTime>0 ? convertToTime(nextLiveTime, lives<0 ? 2 : 0) : xmlValue('fullLives'), {fontSize:16, width:livesBG.width*0.46, x:livesBG.position.x + livesBG.width*0.56, y:livesBG.position.y, autoResize:true});

	if (lives < 0) {
		var livesUnlimited = getAsset('unlimitedlives', stageW*0.14*assetsRatio['lives_bg']);
		livesUnlimited.anchor.y = 0.49;
		livesUnlimited.position.x = 5*assetsRatio['lives_bg'];
		livesBG.addChild(livesUnlimited);
	}

	if (nextLiveTime>0) livesTimer = setInterval(tickLiveTimer, 1000);
	mapElements.addChild(tlt);
	function tickLiveTimer() {
		nextLiveTime--;
		if (nextLiveTime<0 && lives < 0) {
			lives = parseInt(jsonObject.realLives);
			if (lives < maxLives) lives = maxLives;
			updateTxt(tl, lives);
			mapElements.addChild(tl);
			clearInterval(livesTimer);
			updateTxt(tlt, xmlValue('fullLives'));
			livesUnlimited.visible = false;
		} else if (nextLiveTime<0) {
			if (lives<maxLives) {
				lives++;
				updateTxt(tl, lives);
				nextLiveTime = 60*30;
			}
			if (lives>=maxLives) {
				updateTxt(tlt, xmlValue('fullLives'));
				clearInterval(livesTimer);
				addLivesBut.texture = assets.resources['plusBut_disabled'].texture;
				addLivesBut.interactive = addLivesBut.buttonMode = false;
			} else if (lives >= 0) {
				addLivesBut.texture = assets.resources['plusBut'].texture;
				addLivesBut.interactive = addLivesBut.buttonMode = true;
				updateTxt(tlt, convertToTime(nextLiveTime, lives<0 ? 2 : 0));
			}
		} else updateTxt(tlt, convertToTime(nextLiveTime, lives<0 ? 2 : 0));
		makeHint(livesBG, (lives < 0 ? xmlValue('hintPermanentLives') : (jsonObject.lives>=maxLives ? xmlValue('hintLivesFull') : xmlValue('hintGetLives'))), 'BR', stageW*0.2, -livesBG.width/2,0);
	}
	
		
	// xp and xp slider
	var xpBG = new PIXI.Sprite();
	xpBG.anchor.y = 0.5;
	xpBG.position.x = stageW*0.44;
	xpBG.position.y = stageH*0.048;
	var xpT = createText(xpLevelWas, {fontSize:19, width:stageW*0.08, x:stageW*0.476, y:xpBG.position.y});
	var xpProgress = createText(jsonObject.XPlevelGainCurrent +'/'+ jsonObject.XPlevelGain, {fontSize:16, width:stageW*0.22, x:stageW*0.604, y:xpBG.position.y});
	var xp_slider_width = 270;
	var xpSlider_bg = getAsset('loading1', xp_slider_width);
	var xpSlider = getAsset('loading2', xp_slider_width);
	xpSlider_bg.height = xpSlider.height = 52;
	xpSlider_bg.position.x = xpSlider.position.x = 109;
	xpSlider_bg.position.y = xpSlider.position.y = -23;
	xpSlider.width = parseInt(xp_slider_width*jsonObject.XPlevelGainCurrent / jsonObject.XPlevelGain);
	if (xpSlider.width > xp_slider_width) xpSlider.width=xp_slider_width;
	xpBG.addChild(xpSlider_bg);
	xpBG.addChild(xpSlider);
	var xpBG2 = getAsset('xp_bg', 400);
	xpBG2.anchor.y = 0.5;
	xpBG.addChild(xpBG2);
	xpBG.scale.x = xpBG.scale.y = stageW*0.27/400;
	
	var xp_shadow = makeShadow(xpBG2);
	xp_shadow.position.x += xpBG.position.x;
	xp_shadow.position.y += xpBG.position.y;
	mapElements.addChild(xp_shadow);
	var xp_shadow2 = makeShadow(xpSlider_bg);
	xp_shadow2.position.x += xpBG.position.x - xpSlider.position.x*xpBG.scale.x;
	xp_shadow2.position.y += xpBG.position.y - xpSlider.position.y*xpBG.scale.y;
	mapElements.addChild(xp_shadow2);
	
	mapElements.addChild(xpBG);
	mapElements.addChild(xpT);
	mapElements.addChild(xpProgress);
	makeHint(xpBG, xmlValue('hintXPpoints').replace('[score]', jsonObject.XPlevelGain), 'BR', stageW*0.2, stageW*0.11,stageH*0.04);
	
	
	
	
	// left buttons ***************************************************************************************
	MAP.leftButtons = new PIXI.Container();
	MAP.leftButtons.position.x = parseInt(stageW*0.05);
	MAP.leftButtons.position.y = parseInt(stageH*0.93);
	mapElements.addChild(MAP.leftButtons);
	offery();
	
	
	
	
	
	// scroll map by right bottom buttons...
	if (tutorialStep == 0) {
		var map_up = getAsset('go_next', stageH*0.061);
		var map_home = getAsset('home', stageH*0.082);
		var map_down = getAsset('go_prev', stageH*0.061);
		map_down.anchor.x = map_home.anchor.x = map_up.anchor.x = 0.5;
		map_down.anchor.y = map_home.anchor.y = map_up.anchor.y = 0.5;
		map_down.position.x = map_home.position.x = map_up.position.x = stageW*0.96;
		map_down.position.y = stageH*0.57;
		map_home.position.y = stageH*0.5;
		map_up.position.y = stageH*0.43;
		var map_up_shadow = makeShadow(map_up);
		mapNavArrows.addChild(map_up_shadow);
		var map_home_shadow = makeShadow(map_home);
		mapNavArrows.addChild(map_home_shadow);
		var map_down_shadow = makeShadow(map_down);
		mapNavArrows.addChild(map_down_shadow);
		mapNavArrows.addChild(map_up);
		mapNavArrows.addChild(map_home);
		mapNavArrows.addChild(map_down);
		map_down.interactive = map_home.interactive = map_up.interactive = map_down.buttonMode = map_home.buttonMode = map_up.buttonMode = true;
		map_up.on('click', moveNextCiv).on('touchstart', moveNextCiv);
		map_home.on('click', moveHome).on('touchstart', moveHome);
		map_down.on('click', movePrevCiv).on('touchstart', movePrevCiv);
		
		makeHint(map_up, xmlValue('hint_move_nextCiv'), 'LT', stageW*0.12, 0, 0);
		makeHint(map_home, xmlValue('hint_move_mapHome'), 'LL', stageW*0.13, -map_home.width/3, 0);
		makeHint(map_down, xmlValue('hint_move_prevCiv'), 'LB', stageW*0.12, 0, 0);
		
		var mapPinNr = -1;
		function moveNextCiv() {
			if (movingMap || mapPinNr==mapDATA.length-1) return;
			// move UP
			var found = false;
			mapPinNr = nearestPin();
			for (var i = mapPinNr+4; i<mapDATA.length; i++) {
				if (mapDATA[i].type == 'questpos' || mapDATA[i].type == 'scrollpos') {
					mapPinNr = prevPin(i);
					found = true;
					break;
				}
			}
			if (!found) mapPinNr = nextPin(toScrollPin);
			if (mapHeight - MAP.position.y<stageH/2) goUp();
			else movemap();
		}
		function moveHome() {
			if (movingMap) return;
			if (homemap) {mapPinNr = myMapPos; movemap();}
			else {mapPosition='home'; refreshMap();}
		}
		function movePrevCiv() {
			if (movingMap || mapPinNr==0) return;
			// move DOWN
			var found = false;
			mapPinNr = nearestPin();
			for (var i = mapPinNr-4; i>=0; i--) {
				if (mapDATA[i].type == 'questpos' || mapDATA[i].type == 'scrollpos') {
					mapPinNr = nextPin(i);
					found = true;
					break;
				}
			}
			if (MAP.position.y==0 && fromScrollPin>10) mapPinNr = prevPin(fromScrollPin);
			if (!found) mapPinNr=0;
			if (!fullMapLoaded && mapDATA[0].ord*1>1 && MAP.position.y<stageH*0.2) goDown();
			else if (mapPinNr>fromScrollPin-1) movemap();
			else goDown();
		}
		function nearestPin() {
			var h = 999999;
			var found = 0;
			for (var i = fromScrollPin; i<=toScrollPin; i++) {
				if (mapDATA[i].type != 'questpos' && mapDATA[i].type != 'scrollpos') {
					var hh = Math.abs(MAP.position.y-poz(mapDATA[i].y));
					if (hh<h) {h = hh; found=i;}
				}
			}
			return found;
		}
		var movingMap = false;
		function movemap(arg) {
			mapPosition = arg;
			if (mapPinNr>=fromScrollPin && mapPinNr<=toScrollPin) {
				movingMap = true;
				restartNothingTimer();
				var toY = poz(mapDATA[mapPinNr].y);
				toY = limitMapPos(toY);
				TweenLite.to(MAP, 0.4, {y:toY, onComplete:function() {
					movingMap=false;
				}});
			}
		}
		
		
	}
	function limitMapPos(toY) {
		if (toY < 0) toY = 0;
		if (toY > mapHeight) toY = mapHeight;
		return toY;
	}
	
	function goUp() {
		//log('uppertoScrollPin='+uppertoScrollPin);
		if (uppertoScrollPin>toScrollPin) {
			if (this.hinta) stage.removeChild(this.hinta);
			mapPosition = 'movedUp';
			refreshMap(uppertoScrollPin);
		}
	}
	function goDown() {
		if (this.hinta) stage.removeChild(this.hinta);
		mapPosition = 'movedDown';
		if (!fullMapLoaded) refreshMapJson(1, 'prev', mapDATA[fromScrollPin].id); else refreshMap( prevPin(fromScrollPin) );
	}
	function poz(yy) {
		return yy*1 - hidedCivsHeight + firstBG_height - stageH*0.48;
	}
	
	mapContainer.addChild(mapElements);
	mapContainer.addChild(mapNavArrows);
	restartNothingTimer();
	toScrollPinWAS = toScrollPin;
	
	
	// add other games bottom links
	if (mapContainer.linkHexa) mapContainer.removeChild(mapContainer.linkHexa);
	if (mapContainer.linkMahjong) mapContainer.removeChild(mapContainer.linkMahjong);
	var linkHexa = getAsset('iconHexa', stageW*0.17);
	linkHexa.position.x = stageW*0.82;
	linkHexa.position.y = stageH*0.88;
	linkHexa.interactive = linkHexa.buttonMode = true;
	linkHexa.on('click', openHexa).on('touchend', openHexa);
	mapContainer.addChild(linkHexa);
	function openHexa() {window.open(dev ? 'https://hexa.hypester.com' : 'https://hexa.mahjongwonders.com');}
	var linkMahjong = getAsset('iconMahjong', stageW*0.17);
	linkMahjong.position.x = stageW*0.82;
	linkMahjong.position.y = stageH*0.76;
	linkMahjong.interactive = linkMahjong.buttonMode = true;
	linkMahjong.on('click', openMahjong).on('touchend', openMahjong);
	mapContainer.addChild(linkMahjong);
	function openMahjong() {window.open(dev ? 'https://mahjong.hypester.com' : 'https://game.mahjongwonders.com');}
	mapContainer.linkHexa = linkHexa;
	mapContainer.linkMahjong = linkMahjong;
	if (autoplaying && tutorialStep!=1 && !animeclp) setTimeout(function() {
		if (autoplaying && !animeclp) startNextLev();
	}, 1800);
}





// TIPS popup on map - apperas each minute if nothing pressed
function secondMapTick() {
	if (GAME==null && MAP && nothingDoing && tutorialStep==0 && !havePopups && animeclp==null && tournamentPopup==null) {
		clearInterval(nothingDoing);
		nothingDoing=null;

		// show popup hints
		var hintPopup = new PIXI.Container();
		hintPopup.position.x = stageW/2;
		hintPopup.position.y = stageH*0.08;
		var bg = getAsset('popup_small', 'auto', stageH*0.86);
		hintPopup.addChild(bg);
		hintPopup.bg = bg;
		var centerX = bg.width/2;
		
		var glow = getAsset('glow', bg.width*0.9);
		glow.anchor.x = glow.anchor.y = 0.5; glow.position.x = centerX; glow.position.y = bg.height*0.4;
		var glowRotate = setInterval(function() {
			if (renderer.type==1) glow.rotation += 0.05;
		}, 30);
		hintPopup.addChild(glow);
		
		var label = createText(xmlValue('tipsLabel'), {fontSize:26, x:centerX, y:bg.height/12, width:bg.width*0.4});
		hintPopup.addChild(label);
		
		var but1 = getAsset('go_prev', bg.width*0.14);
		var but2 = getAsset('go_next', bg.width*0.14);
		but1.position.y = but2.position.y = bg.height*0.4;
		but1.anchor.x = but2.anchor.x = but1.anchor.y = but2.anchor.y = 0.5;
		but1.position.x = but1.width/1.4;
		but2.position.x = bg.width - but2.width/1.4;
		but1.rotation = Math.PI/2;
		but2.rotation = Math.PI/2;
		but1.interactive = but2.interactive = but1.buttonMode = but2.buttonMode = true;
		but1.on('click', prevHint).on('touchstart', prevHint);
		but2.on('click', nextHint).on('touchstart', nextHint);
		hintPopup.addChild(but1);
		hintPopup.addChild(but2);
		
		var close1 = getAsset('closeBut', bg.width/12);
		close1.position.x = bg.width*0.84;
		close1.position.y = bg.height/13;
		close1.interactive = close1.buttonMode = true;
		close1.on('click', closeHintPopup).on('touchstart', closeHintPopup);
		hintPopup.addChild(close1);
		
		var r2 = [3,6,7,8,10];
		var r = r2[0], nextTimer = setInterval(nextHint, 15000);
		//log('hint 1');
		showHint(r);
		function prevHint() {
			r--;
			if (r<0) r=r2.length-1;
			showHint(r2[r]);
		}
		function nextHint() {
			r++;
			if (r==r2.length) r=0;
			showHint(r2[r]);
		}
		var icon,txt1,txt2;
		function showHint(r) {
			clearInterval(nextTimer);
			if (icon) {
				TweenLite.to(icon, 0.35, {alpha:0});
				TweenLite.to(txt1, 0.35, {alpha:0});
				TweenLite.to(txt2, 0.35, {alpha:0, onComplete:showMe});
			} else showMe();
			
			function showMe() {
				if (icon) {
					hintPopup.removeChild(icon);
					hintPopup.removeChild(txt1);
					hintPopup.removeChild(txt2);
				}
				icon = getAsset('tips'+r, 'auto', bg.height*0.45);
				icon.position.x = centerX; icon.position.y = bg.height*0.39;
				icon.anchor.x = icon.anchor.y = 0.5;
				hintPopup.addChild(icon);
					
				txt1 = createText(xmlValue('tip'+r+'Label'), {fontSize:23, autoResize:true, color:"yellow", x:centerX*1.02, y:bg.height*0.67, width:bg.width*0.7});
				txt2 = createText(xmlValue('tipDescription' + r), {color:"brown", stroke:0, fontSize:18, x:centerX*1.02, y:0, width:bg.width*0.7, height:bg.height*0.3, multiline:true});
				txt2.position.y = txt1.position.y + txt1.height*0.7 + txt2.height/2;
				hintPopup.addChild(txt1);
				hintPopup.addChild(txt2);
				
				icon.alpha = txt1.alpha = txt2.alpha = 0;
				TweenLite.to(icon, 0.35, {alpha:1});
				TweenLite.to(txt1, 0.35, {alpha:1});
				TweenLite.to(txt2, 0.35, {alpha:1});
				nextTimer = setInterval(nextHint, 15000);
			}
		}
		animatePopup(hintPopup);
		
		function closeHintPopup() {
			clearInterval(nextTimer);
			clearInterval(glowRotate);
			glowRotate = null;
			quitPopup(hintPopup);
			nothingDoing = setInterval(secondMapTick, 60000);
		}
		
	}
	if (nothingDoing) {clearInterval(nothingDoing); nothingDoing=null;}
}
// reset one minute notouch for hint popup on map
function restartNothingTimer() {
	if (nothingDoing) {clearInterval(nothingDoing); nothingDoing=null;}
	if (MAP && !havePopups) nothingDoing = setInterval(secondMapTick, 60000);
}
function selLevel(id, tourn, chl) {
	if (!GAME || tourn) {
		if (nothingDoing) {clearInterval(nothingDoing); nothingDoing=null;}
		if (livesTimer) {clearInterval(livesTimer); livesTimer=null;}
		if (tutorialStep>0 && tutorial) removeTutorial();
		selectedLevel = id;
		toScrollPinWAS = toScrollPin;
		backStep = 0;
		isTournament = tourn==true;
		isChallenge = chl==true;
		goGAME();
	}
}




// left bottom buttons (icons) *******************************
function offery() {
	if (MAP && MAP.leftButtons) {
		removeAllChilds(MAP.leftButtons);
		MAP.leftButtons.position.y = parseInt(stageH*0.93);
		if (leftButtonsTimer) clearInterval(leftButtonsTimer);
		if (glowIconsInt) clearInterval(glowIconsInt);
		glowIconsInt = null;
		var yy = 0,timerBadge;
		var w = parseInt(stageW*0.088);
		var glowTournament;
		var glowChallenge;
		var glowOffer;
		
		
		/*var ico2 = getAsset('gift_icon', w);
		ico2.anchor.x = ico2.anchor.y = 0.5;
		ico2.position.y = yy;
		ico2.interactive = ico2.buttonMode = true;
		ico2.on('click', clickGiftsIcon).on('touchstart', clickGiftsIcon);
		function clickGiftsIcon() {
			if (backStep==0) {
				openGifts();
				ico2.interactive = false; setTimeout(function() {if (ico2) ico2.interactive = true;}, 400); // fastclick
			}
		}
		var ico2_shadow = makeShadow(ico2);
		MAP.leftButtons.addChild(ico2_shadow);
		MAP.leftButtons.addChild(ico2);
		makeHint(ico2, xmlValue('hintGifts'), 'TR', stageW*0.2, 0, 0);
		yy -= parseInt(ico2.height*1.025);*/
		
		var ico3 = getAsset('achievements_icon', w);
		ico3.anchor.x = ico3.anchor.y = 0.5;
		ico3.position.y = yy;
		ico3.interactive = ico3.buttonMode = true;
		ico3.on('click', clickAchievements).on('touchstart', clickAchievements);
		function clickAchievements() {
			if (backStep==0) {
				openAchievements();
				ico3.interactive = false; setTimeout(function() {if (ico3) ico3.interactive = true;}, 400); // fastclick
			}
		}
		var ico3_shadow = makeShadow(ico3);
		MAP.leftButtons.addChild(ico3_shadow);
		MAP.leftButtons.addChild(ico3);
		if (jsonObject.unclaimedAchievements>0) {
			var badgeA = getAsset('wheel_badge', ico3.width*0.44/ico3.scale.x);
			badgeA.anchor.x = badgeA.anchor.y = 0.5;
			badgeA.position.x = w*0.5; badgeA.position.y = -ico3.height*0.42;
			ico3.addChild(badgeA);
			var tA = createText(jsonObject.unclaimedAchievements, {fontSize:13, x:ico3.position.x + badgeA.position.x*ico3.scale.x, y:ico3.position.y + badgeA.position.y*ico3.scale.y-1, width:badgeA.width*0.9});
			blinkIcon(badgeA,'achievementsPopup');							 
		}
		makeHint(ico3, xmlValue('hintAchievements'), 'TR', stageW*0.2, 0, 0);
		yy -= parseInt(ico3.height*1.025);
		
		var ico4 = getAsset('hallOfFame_icon', w);
		ico4.anchor.x = ico4.anchor.y = 0.5;
		ico4.position.y = yy;
		ico4.interactive = ico4.buttonMode = true;
		ico4.on('click', clickHallOfFame).on('touchstart', clickHallOfFame);
		function clickHallOfFame() {
			if (backStep==0) {
				openHallOfFame();
				ico4.interactive = false; setTimeout(function() {if (ico4) ico4.interactive = true;}, 400); // fastclick
			}
		}
		var ico4_shadow = makeShadow(ico4);
		MAP.leftButtons.addChild(ico4_shadow);
		MAP.leftButtons.addChild(ico4);
		if (badgeA) MAP.leftButtons.addChild(tA);
		makeHint(ico4, xmlValue('hintHallOfFame'), 'TR', stageW*0.2, 0, 0);
		yy -= parseInt(ico4.height*1.065);
		

		if (messagesData && messagesData.length>0) {
			var ico_mess = getAsset('messages_icon', w);
			ico_mess.anchor.x = ico_mess.anchor.y = 0.5;
			ico_mess.position.y = yy+w*0.07;
			ico_mess.interactive = ico_mess.buttonMode = true;
			ico_mess.on('click', clickMsgIcon).on('touchstart', clickMsgIcon);
			function clickMsgIcon() {
				if (backStep==0) {
					pressMessages();
					ico_mess.interactive = false; setTimeout(function() {if (ico_mess) ico_mess.interactive = true;}, 400); // fastclick
				}
			}
			var badgeM = getAsset('msg_badge', ico_mess.width*0.4/ico_mess.scale.x);
			badgeM.anchor.x = badgeM.anchor.y = 0.5;
			badgeM.position.x = ico_mess.width*0.35; badgeM.position.y = -ico_mess.height*0.35;
			ico_mess.addChild(badgeM);
			setTimeout(function() {blinkIcon(badgeM,'messagesPopup');}, 200);														
			var tm = createText(messagesData.length, {fontSize:13, x:ico_mess.position.x + badgeM.position.x*ico_mess.scale.x, y:ico_mess.position.y + badgeM.position.y*ico_mess.scale.y-1, width:badgeM.width*0.9});
			var ico_mess_shadow = makeShadow(ico_mess);
			MAP.leftButtons.addChild(ico_mess_shadow);
			MAP.leftButtons.addChild(ico_mess);
			MAP.leftButtons.addChild(tm);
			//makeHint(ico_mess, xmlValue('hintMessages'), 'TR', stageW*0.2, 0, 0);
			yy -= parseInt(ico_mess.height*1);
		}
		// wheel
		lsmAd(
			function (ad) { videoAdExists = true; }, 
			function() {}, 
			function() {}
		);
		if (jsonObject.wheelEnabled && (jsonObject.wheelRolls>0 || (!jsonObject.eRolls && videoAdExists && videoAdEnable['wheel']==true))) {
			var ico5 = getAsset('wheel_icon', w);
			ico5.anchor.x = ico5.anchor.y = 0.5;
			ico5.position.y = yy;
			var badge = getAsset('wheel_badge', ico5.width*0.41/ico5.scale.x);
			badge.anchor.x = badge.anchor.y = 0.5;
			badge.position = {x:w/ico5.scale.x*0.33,  y:-w/ico5.scale.y*0.31};
			ico5.addChild(badge);
			var t2 = createText(jsonObject.wheelRolls + ((!jsonObject.eRolls && videoAdExists) ? 1 : 0), {fontSize:13, x:ico5.position.x + badge.position.x*ico5.scale.x, y:ico5.position.y + badge.position.y*ico5.scale.y-1, width:badge.width*0.9});
			ico5.interactive = ico5.buttonMode = true;
			ico5.on('click', clickWheelIcon).on('touchstart', clickWheelIcon);
			function clickWheelIcon() {
				if (backStep==0) {
					openWheel();
					ico5.interactive = false; setTimeout(function() {if (ico5) ico5.interactive = true;}, 400); // fastclick
				}
			}
			setTimeout(function() {blinkIcon(badge,'wheel');}, 350);											   
			var ico5_shadow = makeShadow(ico5);
			MAP.leftButtons.addChild(ico5_shadow);
			MAP.leftButtons.addChild(ico5);
			MAP.leftButtons.addChild(t2);
			yy -= parseInt(ico5.height*1.18);
		}
		//challenge
		var challengeIconText;
		if (challengeLeft>0) {
			yy -= w*0.1;
			var ico6 = getAsset('challenge', w*1.025);
			ico6.anchor.x = ico6.anchor.y = 0.5;
			ico6.position.y = yy;
			timerBadge = getAsset('timer_bg', w*1.4);
			timerBadge.anchor.x = timerBadge.anchor.y = 0.5;
			timerBadge.position.y = ico6.height*0.75;
			ico6.addChild(timerBadge);
			challengeIconText = createText(convertToTime(challengeLeft, true), {fontSize:15, stroke:5, x:0, y:timerBadge.position.y, width:w});
			ico6.addChild(challengeIconText);
			ico6.interactive = ico6.buttonMode = true;
			ico6.on('click', selChallenge).on('touchstart', selChallenge);
			function selChallenge() {
				if (backStep==0) {
					thumbImage = challengeData.thumb;
					selLevel(challengeData.id, false, true);
					ico6.interactive = false; setTimeout(function() {if (ico6) ico6.interactive = true;}, 400); // fastclick
				}
			}
			yy -= ico6.height*1.2;
			setTimeout(function() {blinkIcon(ico6,'challengePopup');}, 1000);
			
			glowChallenge = getAsset('glow', w*2.5);
			glowChallenge.anchor.x = glowChallenge.anchor.y = 0.5;
			glowChallenge.position = ico6.position;
			MAP.leftButtons.addChild(glowChallenge);
			var ico6_shadow = makeShadow(ico6);
			MAP.leftButtons.addChild(ico6_shadow);
			var ico6timerBadge_shadow = makeShadow(timerBadge);
			ico6timerBadge_shadow.position.x += ico6.position.x;
			ico6timerBadge_shadow.position.y += ico6.position.y - timerBadge.height/2.2;
			MAP.leftButtons.addChild(ico6timerBadge_shadow);
			MAP.leftButtons.addChild(ico6);
			rotateGlows();
		}
		// tournament
		var tournamentIconText, icoRepeat,ico7,tt,ico7_shadow;
		var ticon = (tournamentData && tournamentData.ttype ? 'TournamentBabyDragonMapLeft' : 'TournamentDragonMapLeft');
		if (tournamentData && tournamentData.wTimeLeft>0) {
			ico7 = getAsset(ticon, w);
			icoRepeat = assetsRatio[ticon];
			ico7.anchor.x = ico7.anchor.y = 0.5;
			ico7.position.y = yy-5;
			tt = createText(xmlValue('startsIn'), {fontSize:19*icoRepeat, x:0, y:ico7.height*0.25*icoRepeat, width:ico7.width*2*icoRepeat, autoResize:true});
			//ico7.addChild(tt);
			tournamentIconText = createText(convertToTime(tournamentData.wTimeLeft, true), {fontSize:38*icoRepeat, stroke:5*icoRepeat, x:0, y:ico7.height*1.32*icoRepeat, width:ico7.width*icoRepeat});
			ico7.addChild(tournamentIconText);
			ico7.interactive = ico7.buttonMode = true;
			ico7.on('click', tournamnetIntro).on('touchstart', tournamnetIntro);
			function tournamnetIntro() {
				if (backStep==0) {
					tournamentStartsSoon();
					ico7.interactive = false; setTimeout(function() {if (ico7) ico7.interactive = true;}, 400); // fastclick
				}
			}
			ico7_shadow = makeShadow(ico7);
			MAP.leftButtons.addChild(ico7_shadow);
			MAP.leftButtons.addChild(ico7);
			makeHint(ico7, xmlValue('tournHintW'), 'BR', stageW*0.2, 0, 0);
			yy -= ico7.height*1.1-5;
		}
		else if (tournamentLeft>0 && jsonObject.tournament) {
			ico7 = getAsset(ticon, w);
			ico7.anchor.x = ico7.anchor.y = 0.5;
			ico7.position.y = yy-5;
			icoRepeat = assetsRatio[ticon];
			var t_t = xmlValue('join');
			if (jsonObject.tournament.type=='B')  t_t = xmlValue(tournamentLeft>900 ? 'tournamentIconTxt' : 'claimIn4');
			else if (jsonObject.tournament.type=='C')  t_t = xmlValue('tournamentIconClaim');
			tt = createText(t_t, {fontSize:19*icoRepeat, x:0, y:ico7.height*0.25*icoRepeat, width:ico7.width*1.75*icoRepeat, autoResize:true});
			//ico7.addChild(tt);
			tournamentIconText = createText(convertToTime(tournamentLeft - (tournamentData.type=='B' && tournamentLeft>=900 ? 900 : 0), true), {fontSize:38*icoRepeat, stroke:5*icoRepeat, x:0, y:ico7.height*1.32*icoRepeat, width:ico7.width*icoRepeat});
			ico7.addChild(tournamentIconText);
			ico7.interactive = ico7.buttonMode = true;
			ico7.on('click', clickTournamentIcon).on('touchstart', clickTournamentIcon);
			function clickTournamentIcon() {
				if (backStep==0) {
					openTournament();
					ico7.interactive = false; setTimeout(function() {if (ico7) ico7.interactive = true;}, 400); // fastclick
				}
			}
			yy -= ico7.height*1.1-5;
			setTimeout(function() {blinkIcon(ico7,'tournamentPopup');}, 1600);
			
			glowTournament = getAsset('glow', w*2.5);
			glowTournament.anchor.x = glowTournament.anchor.y = 0.5;
			glowTournament.position = ico7.position;
			MAP.leftButtons.addChild(glowTournament);
			ico7_shadow = makeShadow(ico7);
			MAP.leftButtons.addChild(ico7_shadow);
			MAP.leftButtons.addChild(ico7);
			rotateGlows();
			
			var th = txt = xmlValue('tournHintA');
			if (jsonObject.tournament.type=='B') th = xmlValue('tournHintB');
			else if (jsonObject.tournament.type=='C') th = xmlValue('tournHintC');
			makeHint(ico7, th, 'BR', stageW*0.22, 0, 0);
		}
		// offer
		var offerIconText,ico8_shadow,ico8timerBadge_shadow;
		if (offerData && offerLeft>0) {
			var ico8 = new PIXI.Sprite.fromImage(offerData.icon);
			ico8.visible = false;
			if (ico8.texture.baseTexture.hasLoaded==true) showOfferIcon();
			else ico8.texture.baseTexture.on('loaded', showOfferIcon);
			function showOfferIcon() {
				timerBadge = getAsset('timer_bg', ico8.width*1.1);
				icoRepeat = assetsRatio[offerData.icon];
				ico8.width = w;
				ico8.scale.y = ico8.scale.x;
				ico8.anchor.x = ico8.anchor.y = 0.5;
				ico8.position.y = yy;
				timerBadge.anchor.x = timerBadge.anchor.y = 0.5;
				timerBadge.position.y = ico8.height*0.75;
				ico8.addChild(timerBadge);
				offerIconText = createText(convertToTime(offerLeft, true), {fontSize:19*icoRepeat, x:0, y:timerBadge.position.y, width:ico8.width*1.5, autoResize:true});
				ico8.addChild(offerIconText);
				ico8.interactive = ico8.buttonMode = true;
				ico8.on('click', clickOfferIcon).on('touchstart', clickOfferIcon);
				function clickOfferIcon() {
					if (backStep==0) {
						openOffer();
						ico8.interactive = false; setTimeout(function() {if (ico8) ico8.interactive = true;}, 400); // fastclick
					}
				}
				yy -= ico8.height*1.2;
				ico8.visible = true;
				
				glowOffer = getAsset('glow', w*2.5);
				glowOffer.anchor.x = glowOffer.anchor.y = 0.5;
				glowOffer.position = ico8.position;
				MAP.leftButtons.addChild(glowOffer);
				
				ico8_shadow = makeShadow(ico8);
				MAP.leftButtons.addChild(ico8_shadow);
				ico8timerBadge_shadow = makeShadow(timerBadge);
				ico8timerBadge_shadow.position.x += ico8.position.x;
				ico8timerBadge_shadow.position.y += ico8.position.y - timerBadge.position.y*ico8.scale.y + 2;
				MAP.leftButtons.addChild(ico8timerBadge_shadow);
				
				MAP.leftButtons.addChild(ico8);
				rotateGlows();
				setTimeout(function() {blinkIcon(ico8,'offerPopup');}, 2000);
			}
		}
		function checkFit() {
			var h_popravka;
			if (yy < -stageH*0.9 && ico_mess && ico_mess.visible) {
				h_popravka = parseInt(ico_mess.height*1);
				ico_mess.visible = tm.visible = false;
				if (ico5) {ico5.position.y += h_popravka;  ico5_shadow.position.y += h_popravka;  t2.position.y += h_popravka;}
				if (ico6) {ico6.position.y += h_popravka;  ico6timerBadge_shadow.position.y += h_popravka;  ico6_shadow.position.y += h_popravka;  glowChallenge.position.y += h_popravka;}
				if (ico7) {ico7.position.y += h_popravka;  ico7_shadow.position.y += h_popravka;  glowTournament.position.y += h_popravka;}
				if (ico8 && ico8timerBadge_shadow) {ico8.position.y += h_popravka;  ico8timerBadge_shadow.position.y += h_popravka;  ico8_shadow.position.y += h_popravka;  glowOffer.position.y += h_popravka;}
				yy += h_popravka;
			}
			if (yy < -stageH*0.9 && ico4 && ico4.visible) {
				h_popravka = parseInt(ico4.height*1.065);
				ico4.visible=false;
				if (ico_mess) {ico_mess.position.y += h_popravka;  ico_mess_shadow.position.y += h_popravka;  tm.position.y += h_popravka;}
				if (ico5) {ico5.position.y += h_popravka;  ico5_shadow.position.y += h_popravka;  t2.position.y += h_popravka;}
				if (ico6) {ico6.position.y += h_popravka;  ico6timerBadge_shadow.position.y += h_popravka;  ico6_shadow.position.y += h_popravka;  glowChallenge.position.y += h_popravka;}
				if (ico7) {ico7.position.y += h_popravka;  ico7_shadow.position.y += h_popravka;  glowTournament.position.y += h_popravka;}
				if (ico8 && ico8timerBadge_shadow) {ico8.position.y += h_popravka;  ico8timerBadge_shadow.position.y += h_popravka;  ico8_shadow.position.y += h_popravka;  glowOffer.position.y += h_popravka;}
				yy += h_popravka;
			}
		}
		checkFit();
		
		// glows rotating on map icons
		function rotateGlows() {
			checkFit();
			if (glowIconsInt==null) {
				glowIconsInt = setInterval(function() {
					if (glowOffer) glowOffer.rotation += 0.015;
					if (glowTournament) glowTournament.rotation += 0.015;
					if (glowChallenge) glowChallenge.rotation += 0.015;
				}, 40);
			}
		}
		
		// timers ticking
		leftButtonsTimer = setInterval(tickLeftButtons, 1000);
		function tickLeftButtons() {
			
			if (challengeLeft>0 && challengeIconText) {
				challengeLeft--;
				if (challengeLeft==0) {
					// refresh icons and remove challenge popup if visible
					offery();
					if (challengePopup) {removeLoader(); quitPopup(challengePopup); goMAP();}
				}
				else {
					// tick timer on challenge map icon
					updateTxt(challengeIconText, convertToTime(challengeLeft, true));
					// tick timer on challenge popup labels (except tokens packs)
					if (challengePopup && challengePopup.label && challengePopup.coinsFrame!=true) updateTxt(challengePopup.label, xmlValue(challengeData.collectedKeys>=10 ? 'claimChallengeLabel' : 'challengeLabel')+' <yellow>'+convertToTime(challengeLeft, true)+'</yellow>');
				}
			}
			if (tournamentIconText && tournamentData.wTimeLeft>0) {
				tournamentData.wTimeLeft--;
				if (tournamentData.wTimeLeft==0) {
					if (tournamentPopup && tournamentPopup.soon) quitPopup(tournamentPopup);
					if (!GAME) getJsonPrices(false, 'openJoinTournamnet');
				}
				else updateTxt(tournamentIconText, convertToTime(tournamentData.wTimeLeft, true));
				if (tournamentPopup && tournamentPopup.tim2) updateTxt(tournamentPopup.tim2, convertToTime(tournamentData.wTimeLeft, true));
			}
			else if (tournamentLeft>0 && tournamentIconText) {
				tournamentLeft--;
				if (tournamentLeft==0) {
					offery();
					if (tournamentPopup) {
						removeLoader(); 
						if (tournamentData.type=='B') {tournamentPopup.drawCLAIM();}
						else {
							tournamentPopup.removeTournamentMap();
						}
					} else if (!GAME) {
						// on map and need refresh...
						getJsonPrices();
					}
				}
				else if (tournamentData.type=='B' && tournamentLeft==900) {
					if (tournamentPopup) tournamentPopup.removeTournamentMap(); else offery();
				}
				else {
					// tick timer on tournament map icon
					if (MAP && MAP.visible) updateTxt(tournamentIconText, convertToTime(tournamentLeft - (tournamentData.type=='B' && tournamentLeft>=900 ? 900 : 0), true));
					// tick timer on tournament popup labels (except tokens packs & join)
					if (tournamentPopup && tournamentPopup.label && tournamentPopup.popupType!='join' && tournamentPopup.popupType!='tokens') {
						var timerLabel = xmlValue('tournamentBEnded');
						if (tournamentLeft>=900) {
							timerLabel = xmlValue(tournamentData.type=='B' ? 'playTournament' : 'claimTournament')+' <yellow>'+convertToTime2(tournamentLeft-(tournamentData.type=='B' ? 900 : 0), true)+'</yellow>';
						}
						updateLabel(timerLabel);
					}
					// ticking timer on join green badge
					if (tournamentPopup && tournamentPopup.popupType=='join') {
						updateTxt(tournamentPopup.joinTimerTxt, convertToTime2(tournamentLeft, true));
					}
					// finish tournament game if less than 5 minutes left
					if (isTournament && tournamentData.type=='B' && tournamentLeft==300 && GAME && kivid) {
						// remove pause
						if (pauseClp) {quitPopup(pauseClp); setTimeout(tournamentLevelDone, 300);} else tournamentLevelDone();
					}
				}
			}
			if (offerLeft>0) {
				offerLeft--;
				// ticking offer timer on map icon
				if (offerLeft==0) offery();
				else if (MAP.visible && offerIconText) updateTxt(offerIconText, convertToTime(offerLeft, true));
			}
		}
	}
}
function blinkIcon(ico,popup) {
	if (GAME) return;						   
	var pop;
	if (popup == 'piggyPopup') pop = piggyPopup;
	else if (popup == 'offerPopup') pop = offerPopup;
	else if (popup == 'tournamentPopup') pop = tournamentPopup;
	else if (popup == 'challengePopup') pop = challengePopup;
	else if (popup == 'messagesPopup') pop = messagesPopup;
	else if (popup == 'wheel') pop = wheelPopup;
	else if (popup == 'achievementsPopup') pop = achievementsPopup;
	
	if (ico && MAP) {
		if (!pop) {
			var w = ico.width;
			var h = ico.height;
			TweenLite.to(ico, 0.1, {width:w*1.13, height:h*1.13, onComplete:function() {
				if (ico && MAP) {
					TweenLite.to(ico, 0.1, {width:w, height:h, onComplete:function() {
						if (ico && MAP) {
							TweenLite.to(ico, 0.15, {width:w*1.13, height:h*1.13, onComplete:function() {
								if (ico && MAP) {
									TweenLite.to(ico, 0.15, {width:w, height:h, onComplete:again});
								}
							}});
						}
					}});
				}
			}});
		} else again();
	}
	function again() {
		if (ico && MAP && !GAME) setTimeout(function() {blinkIcon(ico,popup);}, 4000);
	}
}
function blinkIcon2(_neededpopup) {
	var neededpopup = checkPopups();
	if (neededpopup && neededpopup.blinkingIcon) {
		neededpopup.blinkingIcon.scale.x *= 1.11111111111;
		neededpopup.blinkingIcon.scale.y = neededpopup.blinkingIcon.scale.x;
		
		setTimeout(function() {
			if (neededpopup && neededpopup.blinkingIcon) {
				neededpopup.blinkingIcon.scale.x *= 0.9;
				neededpopup.blinkingIcon.scale.y = neededpopup.blinkingIcon.scale.x;
				
				setTimeout(function() {
					if (neededpopup && neededpopup.blinkingIcon) {
						neededpopup.blinkingIcon.scale.x *= 1.11111111111;
						neededpopup.blinkingIcon.scale.y = neededpopup.blinkingIcon.scale.x;
						
						setTimeout(function() {
							if (neededpopup && neededpopup.blinkingIcon) {
								neededpopup.blinkingIcon.scale.x *= 0.9;
								neededpopup.blinkingIcon.scale.y = neededpopup.blinkingIcon.scale.x;
								
								setTimeout(blinkIcon2, 3200,      _neededpopup);
							}
						}, 150);
					}
				}, 120);
			}
		}, 150);
	}
	function checkPopups() {
		if (_neededpopup == 'tournamentPopup') return tournamentPopup;
		else if (_neededpopup == 'popupLives') return popupLives;
		else if (_neededpopup == 'completePopup') return completePopup;
		else if (_neededpopup == 'doubleDragonsPopup') return doubleDragonsPopup;
		return null;
	}
}
function startNextLev() {
	if (goalClip==null && !havePopups) {
		var nextNr = pinWas ? nextPin(pinWas.nr) : myMapPos;
		if (mapDATA[prevPin(nextNr)].stars==0) nextNr=prevPin(nextNr); // fix...
		thumbImage = mapDATA[nextNr].thumb;
		// autoopen while NEXT level - if have giftbox claim at first.
		if (mapDATA[nextNr].box) {
			openMapGiftPopup('claim&openNext', mapDATA[nextNr].id);
		} else selLevel(mapDATA[nextNr].id);
		pinWas = {nr:nextNr, stars:mapDATA[nextNr].stars, best:mapDATA[nextNr].bestOfFriends==1};
	}
}
function prevPin(nr) {
	nr--;
	if (nr<=0) return 0;
	while (mapDATA[nr] && (mapDATA[nr].type == 'scrollpos' || mapDATA[nr].type == 'questpos')) nr--;
	if (nr<=0) return 0;
	return nr;
}
function prevPinById(id) {
	for (var i in mapDATA) {
		if (mapDATA[i].id == id) return prevPin(i);
	}
	return 0;
}
function nextPin(nr) {
	nr++;
	if (nr>mapDATA.length-1) return mapDATA.length-1;
	while (mapDATA[nr] && (mapDATA[nr].type == 'scrollpos' || mapDATA[nr].type == 'questpos')) nr++;
	if (nr>mapDATA.length-1) return mapDATA.length-1;
	return nr;
}


// first popups on start up
function startFirstPopups() {
	if (GAME || goalClip) return;
	// new gifts event - wait till drop and show.
	if (backStep==20) {
		if (totalMapGifts>0) {
			setTimeout(function() {
				
				// show gitfs popup automatically at startup.
				if (backStep==20) openMapGiftPopup('future');
				
			}, 500*totalMapGifts+100);
			return;
		} else backStep=1;
	}
	if (backStep==1) {
		if (messagesData && messagesData.length>0) pressMessages(); else {backStep=2; startFirstPopups();}
	}
	else if (backStep==2) {engage();}
	else if (backStep==3) {
		if (jsonObject.wheelRolls>0) openWheel(); else {backStep=4; startFirstPopups();}
	}
	else if (backStep==4) {
		if (jsonObject.welcomemessages  && jsonObject.welcomemessages.length>0) openWelcome(); else {backStep=5; startFirstPopups();}
	}
	else if (backStep==5) {
		if (jsonObject.tournament && (jsonObject.tournament.type=="A" && jsonObject.tournament.iconDataA.timeLeft>0 || jsonObject.tournament.type=="C" && jsonObject.tournament.iconDataC.timeLeft>0)) openTournament(true); else {
			backStep=0; 
			// all start popups are gone.
			// refresh map - maybe have achievements at start? (wait till popups gone);
			//log('start first popups ended');
			setTimeout(refreshTopData, 350);
		}
	}
	else backStep = 0;	
}


function toggleSound() {
	// sound on/off
	sndOff = !sndOff;
	mapElements.sound_mc.texture = assets.resources[sndOff ? 'sound_inactive' : 'sound'].texture;
	mapElements.sound_mc.scale.set(mapElements.sound_mc.scale.x*assetsRatio[sndOff ? 'sound' : 'sound_inactive']/assetsRatio[sndOff ? 'sound_inactive' : 'sound']);

	analytics('/api/settings?set=sound&val='+(sndOff ? 0 : 1));
}
function toggleMusic() {
	// music on/off
	musicOff = !musicOff;

	mapElements.music_mc.texture = assets.resources[musicOff ? 'music_inactive' : 'music'].texture;
	mapElements.music_mc.scale.set(mapElements.music_mc.scale.x*assetsRatio[musicOff ? 'music' : 'music_inactive']/assetsRatio[musicOff ? 'music_inactive' : 'music']);

	analytics('/api/settings?set=music&val='+(musicOff ? 0 : 1));
	if (musicOff) {
		stopMusic();
	} else {
		playMusic(1);
	}
}
/*function addSoundLoadingPopup(arg) {
	var pop = new PIXI.Container();
	pop.position.y = stageH*0.2;
	
	var bg = getAsset('popup_small', 'auto', stageH*0.6);
	pop.addChild(bg);
	pop.bg = bg;
	
	var centerX = parseInt(bg.width/2);
	
	var closeBut = getAsset('closeBut', bg.width/9);
	pop.addChild(closeBut);
	closeBut.position.x = bg.width*0.83;
	closeBut.position.y = bg.height*0.05;
	closeBut.interactive = closeBut.buttonMode = true;
	
	var label = createText(xmlValue('reloadSound'), {fontSize:24, x:centerX, y:bg.height*0.08, width:bg.width*0.66});
	pop.addChild(label);
	
	closeBut.on('click', removeSoundLoadPopup).on('touchstart', removeSoundLoadPopup);
	function removeSoundLoadPopup() {
		quitPopup(pop);
	}
	addLoader(pop);
	// check sounds loaded
	var intr = setInterval(checkSoundsLoaded, 200);
	function checkSoundsLoaded() {
		if (!noSoundAssets) {
			if (arg=='music') toggleMusic();
			else if (arg=='sound') toggleSound();
			removeSoundLoadPopup();
		}
	}
	
	xhrAudioAssets();
	animatePopup(pop);
}*/